package com.csc.library.components;


import java.io.Serializable;

import com.csc.library.database.ComponentField;
import com.csc.library.utilities.UProfile;
public interface ComponentManager extends Serializable {
	public String getName();
	public String getString();
	public String getStringWidth(); //getWidth
	public String getStringDecimal(); //getWidth
	public String getProperty(String code);
	public UProfile getUProfile();
	public String getDataFormat();
	public String getDescription();
	public String getDescriptionThai();
	public String  getDescriptionEng();
	public boolean getHELP_RETURN_FIELD();
	public String getComType();
	public String  getAlt();
	public String getAltEng();
	public String  getAltThai();
	public String getHelp();
	public char isKey();
	public String getDefault();
	public String getStringHTML();
	public ComponentField getComponentField();
	public char getLang();
	public boolean isRead();
	public boolean isEdit();
}
