package com.csc.library.cscimport;


import java.util.Hashtable;

public class ProcessLineStrip extends ProcessBase implements RecordSet {
	private Hashtable config;

	public ProcessLineStrip(String fName) {
		super(fName);
		config = new Hashtable();
	}

	public void set(String key, String value) {
		this.config.put(key, value);
	}

	public void setObject(String key, Object value) {
		this.config.put(key, value);
	}

	public void setInt(String key, int value) {
		this.config.put(key, new Integer(value));
	}

	public Object get(String key) {
		return this.config.get(key);
	}

	public int getInt(String key) {
		Integer tmpInt = (Integer) config.get(key);
		return tmpInt.intValue();
	}

	public String getString(String key) {
		return config.get(key).toString();
	}

	public String next() {
		if (this.getString("processtype").equalsIgnoreCase("fixspace")) {
			return this.readFile.getCountString(this.getInt("recordsize"));
		} else if (this.getString("processtype").equalsIgnoreCase("freespace")) {
			return this.readFile.getStringToken(this.getString("worddelimeter").charAt(0));
		} else
			return null;
	}

	public boolean hasMoreElement() {
		return this.readFile.hasMoreData();
	}
}