package com.csc.library.database;
import java.util.Vector;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;
/**
 * @author Administrator
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class DeleteRecord {
	private DbInquiry di;
	private UProfile up=null;
	private String tableName, filter,groupField;
	
	public DeleteRecord(UProfile up,String tableName, String filter) {
		this.up = up;
		this.tableName = tableName;
		this.filter = filter;
		this.initInquiry();
	}
	
	public DeleteRecord(DbInquiry di) {
		this.di = di;
	}
	
	private void initInquiry() {
		try {
			di = new InitialInquiry(up).getDbInquiry();
			di.initMyTable(tableName, filter, "");
			Vector v=di.getCurrentDbRecord().getAllKey();
			String fieldList="";
			for(int i=0;i<v.size();i++){
				if(fieldList.length()==0)
					fieldList+=(String)v.elementAt(i);
				else 	fieldList+=","+(String)v.elementAt(i);
			}	
			di.setColumn(fieldList);
		} catch (Exception e) {
        	MyLog.error(this, e);
		}
	}
	public void process() {
		try {
			di.refresh();
			while (di.next()) {
				di.getCurrentDbRecord().cloneRecord(true).delete();
			}
		} catch (Exception e) {
        	MyLog.error(this, e);
		}
	}
}
