package com.csc.library.database;

import java.text.DecimalFormat;



public class FieldInteger extends MyField {

	public FieldInteger(String name) {
		super(name);
		this.setDefault("0");
		this.setDefault();
		this._DEFAULT_DEFAULTVALUE="0";
		//    this.type = "Integer";
	}

	public FieldInteger(String name, String description) {
		super(name, description);
		this.setDefault("0");
		this.setDefault();
		this._DEFAULT_DEFAULTVALUE="0";
		//   this.type = "Integer";
	}

	public FieldInteger(String name, int width, String description) {
		super(name, width, description);
		this.setDefault("0");
		this.setDefault();
		this._DEFAULT_DEFAULTVALUE="0";
		//   this.type = "Integer";
	}

	public FieldInteger(String name, int width, int decimal, String description) {
		super(name, width, decimal, description);
		this.setDefault("0");
		this.setDefault();
		this._DEFAULT_DEFAULTVALUE="0";
		//    this.type = "Integer";
	}

	public FieldInteger(String name, Integer width, Integer decimal, String description) {
		this(name, width.intValue(), decimal.intValue(), description);

	}

	/**
	 *  Encryption Data
	 */
	public String getCompareString() {
		return this.getName() + "=" + this.encryption();
	}

	public String getValueString() {
		return this.getString();
	}

	public boolean set(String x) {
		x=x.trim();
		if (x.equals("")) {
			return this.set(0);
		} else if ((x.indexOf(".") == -1) && (x.indexOf(",") == -1) ){
			return this.set(Integer.parseInt(x));
		} else if (x.indexOf(",") != -1) {
			x=x.replaceAll(",", "");
			if(x.indexOf(".")>-1)
				x=x.substring(0,x.indexOf("."));
			return this.set(Integer.parseInt(x));
		}else {
			return this.set(Double.parseDouble(x));
		}
	}

	public String getFieldCreate() {
		return this.getName() + " DECIMAL(" + String.valueOf(this.getWidth()) + "," + String.valueOf(this.getDecimal()) + ")";
	}
	
	public String getSaveString() {
		if(this.isEncrypt())
			return this.encryption();
		else	
			return  String.valueOf(this.getInt());
	}	
	
	protected String getFormatValue(String format, String value) {
		DecimalFormat dc = new DecimalFormat();
		dc.applyPattern(format);
		if(this.isEncrypt()){
			String temp=value;
				value=dc.format(Double.parseDouble(temp));
		}else{
			value = dc.format(Double.parseDouble(value));
		}
		return value;
	}	
}
