package com.csc.library.database;

import com.csc.library.security.SHAEncoder;
public class FieldPassword extends FieldString {

	public FieldPassword(String name, String code) {
		super(name);
		this.setDefault("");
		this.setDefault();

	}

	public FieldPassword(String name, String description, String code) {
		super(name, description);
		this.setDefault("");
		this.setDefault();

	}

	public FieldPassword(String name, int width, int decimal, String description) {
		super(name, width, decimal, description);
		this.setDefault("");
		this.setDefault();
		//   this.type = "Double";
	}

	public FieldPassword(String name, Integer width, Integer decimal, String description) {
		this(name, width.intValue(), decimal.intValue(), description);
		this.setDefault("");
	}

	public FieldPassword(String name, int width, String description, String code) {
		super(name, width, description);
		this.setDefault("");
		this.setDefault();
	}

	public FieldPassword(String name, int width, int decimal, String description, String code) {
		super(name, width, decimal, description);
		this.setDefault("");
		this.setDefault();
		this.setProperty("oldvalue", "");
	}

	
	public String encryption(String value) {
		SHAEncoder sh = new SHAEncoder();
		String data="";
		if(sh.validSalt(value)){
			data=value;
		}else{			
			data=sh.createDigest(value);
		}
		return data;
	}
	
	public String decryption(String encryption) {
			return encryption;		
	}	
	
}
