package com.csc.library.database;

import com.csc.library.utilities.CscCalendar;

public class FieldTime extends MyField {


	public FieldTime(String name) {
		super(name);
		this.setDefault("00:00:00");
		this._DEFAULT_DEFAULTVALUE="00:00:00";
		//    this.type = "Time";
	}



	public FieldTime(String name, String description) {
		super(name, description);
		this.setDefault("00:00:00");
		//    this.type = "Time";
	}

	public FieldTime(String name, int width, String description) {
		super(name, width, description);
		this.setDefault("00:00:00");
		this._DEFAULT_DEFAULTVALUE="00:00:00";
		//    this.type = "Time";
	}

	public FieldTime(String name, int width, int decimal, String description) {
		super(name, width, decimal, description);
		this.setDefault("00:00:00");
		this._DEFAULT_DEFAULTVALUE="00:00:00";
		//    this.type = "Time";
	}

	public FieldTime(String name, Integer width, Integer decimal, String description) {
		this(name, width.intValue(), decimal.intValue(), description);

	}

	public String getCompareString() {
		//  	return this.getName()+"="+this.getValueString();
		return new GenCompareString().generate(this.getName(), this);
	}

	public String getValueString() {
		return new GenCompareString().generate(this);
	}

	public boolean set(CscCalendar d) {
		return this.set(d.getHHMMSS());
	}

	public CscCalendar getcscCalendar() {
		CscCalendar d;
		d = new CscCalendar("2000-01-01" + " " + this.getString());
		return d;
	}

	public String getFieldCreate() {
		return this.getName() + " TIME";
	}
	public String getSaveString() {
		if(this.isEncrypt())
			return this.encryption();
		else	
			return  String.valueOf(this.getTime());
	}	
	
}
