package com.csc.library.database;

import com.csc.library.utilities.CscCalendar;
public class FieldTimeStamp extends MyField {

		private String defaultValue=new CscCalendar().getTimestamp().toString();

	public FieldTimeStamp(String name) {
		super(name);
		this.setDefault(defaultValue);
		//    this.type = "Timestamp";
	}



	public FieldTimeStamp(String name, String description) {
		super(name, description);
		this.setDefault(defaultValue);
		//   this.type = "Timestamp";
	}

	public FieldTimeStamp(String name, int width, String description) {
		super(name, width, description);
		this.setDefault(defaultValue);
		//   this.type = "Timestamp";
	}

	public FieldTimeStamp(String name, int width, int decimal, String description) {
		super(name, width, decimal, description);
		this.setDefault(defaultValue);
		// this.type = "Timestamp";
	}

	public FieldTimeStamp(String name, Integer width, Integer decimal, String description) {
		this(name, width.intValue(), decimal.intValue(), description);

	}

	public String getCompareString() {
		//  	return this.getName()+"="+this.getValueString();
		return new GenCompareString().generate(this.getName(), this);
	}

	public String getValueString() {
		return new GenCompareString().generate(this);
	}

	public boolean set(CscCalendar d) {
		return this.set(d.getTimestamp());
	}

	public CscCalendar getcscCalendar() {
		CscCalendar d;
		d = new CscCalendar(this.getString());
		return d;
	}

	public String getFieldCreate() {
		return this.getName() + " TIMESTAMP";
	}
	public String getSaveString() {
		if(this.isEncrypt())
			return this.encryption();
		else	
			return  String.valueOf(this.getTimestamp());
	}	
}
