package com.csc.library.database;

import java.math.BigDecimal;
import java.util.Vector;

import com.csc.library.session.DbRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

public class MyRecordGroup extends Vector {

	private String minorKey = "";
	private Vector vDelete=new Vector();
	private Vector vInsert=new Vector();

	public void replaceAll(String fieldName, String data) {
		try {
			DbRecord r;
			for (int i = 0; i < this.size(); i++) {
				r = (DbRecord) this.elementAt(i);
				r.set(fieldName, data);
			}
		} catch (Exception e) {
			MyLog.warn(this, "fieldName : "+fieldName + " data : "+data);
			MyLog.warn(this, e);
		}
	}

	public void replaceAll(String fieldName, boolean data) {
		try {
			DbRecord r;
			for (int i = 0; i < this.size(); i++) {
				r = (DbRecord) this.elementAt(i);
				r.set(fieldName, data);
			}
		} catch (Exception e) {
			MyLog.warn(this, "fieldName : "+fieldName + " data : "+data);
			MyLog.warn(this, e);
		}
	}

	public void replaceAll(String fieldName, byte data) {
		try {
			DbRecord r;
			for (int i = 0; i < this.size(); i++) {
				r = (DbRecord) this.elementAt(i);
				r.set(fieldName, data);
			}
		} catch (Exception e) {
			MyLog.warn(this, "fieldName : "+fieldName + " data : "+data);
			MyLog.warn(this, e);
		}
	}

	public void replaceAll(String fieldName, char data[]) {
		try {
			DbRecord r;
			for (int i = 0; i < this.size(); i++) {
				r = (DbRecord) this.elementAt(i);
				r.set(fieldName, data);
			}
		} catch (Exception e) {
			MyLog.warn(this, "fieldName : "+fieldName + " data : "+data);
			MyLog.warn(this, e);
		}
	}

	public void replaceAll(String fieldName, char data) {
		try {
			DbRecord r;
			for (int i = 0; i < this.size(); i++) {
				r = (DbRecord) this.elementAt(i);
				r.set(fieldName, data);
			}
		} catch (Exception e) {
			MyLog.warn(this, "fieldName : "+fieldName + " data : "+data);
			MyLog.warn(this, e);
		}
	}

	public void replaceAll(String fieldName, short data) {
		try {
			DbRecord r;
			for (int i = 0; i < this.size(); i++) {
				r = (DbRecord) this.elementAt(i);
				r.set(fieldName, data);
			}
		} catch (Exception e) {
			MyLog.warn(this, "fieldName : "+fieldName + " data : "+data);
			MyLog.warn(this, e);
		}
	}

	public void replaceAll(String fieldName, int data) {
		try {
			DbRecord r;
			for (int i = 0; i < this.size(); i++) {
				r = (DbRecord) this.elementAt(i);
				r.set(fieldName, data);
			}
		} catch (Exception e) {
			MyLog.warn(this, "fieldName : "+fieldName + " data : "+data);
			MyLog.warn(this, e);
		}
	}

	public void replaceAll(String fieldName, long data) {
		try {
			DbRecord r;
			for (int i = 0; i < this.size(); i++) {
				r = (DbRecord) this.elementAt(i);
				r.set(fieldName, data);
			}
		} catch (Exception e) {
			MyLog.warn(this, "fieldName : "+fieldName + " data : "+data);
			MyLog.warn(this, e);
		}
	}

	public void replaceAll(String fieldName, float data) {
		try {
			DbRecord r;
			for (int i = 0; i < this.size(); i++) {
				r = (DbRecord) this.elementAt(i);
				r.set(fieldName, data);
			}
		} catch (Exception e) {
			MyLog.warn(this, "fieldName : "+fieldName + " data : "+data);
			MyLog.warn(this, e);
		}
	}

	public void replaceAll(String fieldName, double data) {
		try {
			DbRecord r;
			for (int i = 0; i < this.size(); i++) {
				r = (DbRecord) this.elementAt(i);
				r.set(fieldName, data);
			}
		} catch (Exception e) {
			MyLog.warn(this, "fieldName : "+fieldName + " data : "+data);
			MyLog.warn(this, e);
		}
	}

	public void replaceAll(String fieldName, java.sql.Timestamp data) {
		try {
			DbRecord r;
			for (int i = 0; i < this.size(); i++) {
				r = (DbRecord) this.elementAt(i);
				r.set(fieldName, data);
			}
		} catch (Exception e) {
			MyLog.warn(this, "fieldName : "+fieldName + " data : "+data);
			MyLog.warn(this, e);
		}
	}

	public void replaceAll(String fieldName, java.sql.Date data) {
		try {
			DbRecord r;
			for (int i = 0; i < this.size(); i++) {
				r = (DbRecord) this.elementAt(i);
				r.set(fieldName, data);
			}
		} catch (Exception e) {
			MyLog.warn(this, "fieldName : "+fieldName + " data : "+data);
			MyLog.warn(this, e);
		}
	}

	public void replaceAll(String fieldName, BigDecimal data) {
		try {
			DbRecord r;
			for (int i = 0; i < this.size(); i++) {
				r = (DbRecord) this.elementAt(i);
				r.set(fieldName, data);
			}
		} catch (Exception e) {
			MyLog.warn(this, "fieldName : "+fieldName + " data : "+data);
			MyLog.warn(this, e);
		}
	}

	public void replaceAll(String fieldName, java.sql.Time data) {
		try {
			DbRecord r;
			for (int i = 0; i < this.size(); i++) {
				r = (DbRecord) this.elementAt(i);
				r.set(fieldName, data);
			}
		} catch (Exception e) {
			MyLog.warn(this, "fieldName : "+fieldName + " data : "+data);
			MyLog.warn(this, e);
		}
	}

	public void replaceAll(String fieldName, CscCalendar data) {
		try {
			DbRecord r;
			for (int i = 0; i < this.size(); i++) {
				r = (DbRecord) this.elementAt(i);
				r.set(fieldName, data);
			}
		} catch (Exception e) {
			MyLog.warn(this, "fieldName : "+fieldName + " data : "+data);
			MyLog.warn(this, e);
		}
	}

	public int find(String fieldName, String data) {
		DbRecord r;
		int no = -1;
		try {
			for (int i = 0; i < this.size() && no < 0; i++) {
				r = (DbRecord) this.elementAt(i);
				if (r.getString(fieldName).equals(data))
					no = i;
			}
		} catch (Exception e) {
			MyLog.warn(this, "fieldName : "+fieldName + " data : "+data);
			MyLog.warn(this, e);
		}
		return no;
	}

	    public void addElement(Object o) {
          DbRecord r;
          int no;
          boolean ok = false;
          try {
            if (o instanceof DbRecord) {
              if (!this.minorKey.equals("")) {
                r = (DbRecord) o;
                no = this.find(this.minorKey, r.getString(this.minorKey));
                if (no >= 0) {
                  this.removeElementAt(no, true);
                }else this.vInsert.addElement(o);
              }
              ok = true;
            }
            if (ok) {
              super.addElement(o);
            }
          }
          catch (Exception e) {
			MyLog.warn(this, e);
          }
        }
      
        public boolean add(Object o) {
          DbRecord r;
          boolean ok = false;
          try {
            int no;
            if (o instanceof MyRecord) {
              if (!this.minorKey.equals("")) {
                r = (DbRecord) o;
                no = this.find(this.minorKey, r.getString(this.minorKey));
                if (no >= 0){
                  this.removeElementAt(no, true);
                }else this.vInsert.addElement(o);
              }
              ok = true;
            }
            if (ok)
              return super.add(o);
          }
          catch (Exception e) {
			MyLog.warn(this, e);
          }
          return false;
        }

	public void setMinorKey(String keyName) {
		try {
			if (keyName != null)
				this.minorKey = keyName;
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}

	public String getMinorKey() {
		return this.minorKey;
	}

	public void referLangOff() {
		try {
			DbRecord r;
			for (int i = 0; i < this.size(); i++) {
				r = (DbRecord) this.elementAt(i);
				r.referLangOff();
			}
		} catch (Exception e) {
			MyLog.warn(this, e);
		}

	}
	public void referLangOn() {
		try {
			DbRecord r;
			for (int i = 0; i < this.size(); i++) {
				r = (DbRecord) this.elementAt(i);
				r.referLangOn();
			}
		} catch (Exception e) {
			MyLog.warn(this, e);
		}
	}
	
	public Vector getVdelete(){
		return this.vDelete;
	}	




     public void removeElementAt(int i) {
           if (!this.vInsert.contains(this.elementAt(i))&&!this.vDelete.contains(this.elementAt(i)))
             this.vDelete.addElement(this.elementAt(i));
           super.removeElementAt(i);
         }
         
 	   public   void 	removeElementAt(int i,boolean dup){
                 super.removeElementAt(i);
         }	

 	   /*
 	  @Override
 	public synchronized void removeAllElements() {
 		 try {
 			for (int i = 0; i < this.size(); i++) {
 				if (!this.vDelete.contains(this.elementAt(i)))
 		              this.vDelete.addElement(this.elementAt(i)); 				
 			}
 			
 		} catch (Exception e) {
 			MyLog.warn(this, e);
 		}          		  
 		super.removeAllElements();
 	}
 	*/
}
