package com.csc.library.entry;
import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.StringTokenizer;

import com.csc.library.components.ComponentManager;
import com.csc.library.components.ListBox;
import com.csc.library.components.Text;
import com.csc.library.database.ChildManager;
import com.csc.library.database.FieldBigDecimal;
import com.csc.library.database.FieldDate;
import com.csc.library.database.FieldDouble;
import com.csc.library.database.FieldManager;
import com.csc.library.database.MyInquiry;
import com.csc.library.database.StaticProperties;
import com.csc.library.database.SystemCode;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.utilities.HelpXml;
import com.csc.library.utilities.MyFont;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.StrReplace;
public abstract class MyHelp extends MyEntry {
	public String helpRetrun, orderBy, searchList, helpName, inputBox, pageCall, orderList;
    String showList, fieldReturn, returnList, prvPage, tableHTML, skipPage;
    int recordCount,currentRec=0;
    boolean tfDate = false;
    public String stringSearch = "", title, currentPage = "1", pageTag = "", goPage = ""; 
    boolean canRefresh=false;
    String key;
    public int maxLine = 30, totalRec = 0;
    public ListBox listPage;
    String listTypeField="";
    char nextline = '\n';
    public MyHelp() {
        this.type = "myHelp";
    }
    public abstract String getLinkTag(String fieldvalue, String show);
    public abstract String tagScript(String nPage, String sPage);
    public String getTagConSearch() {
        ListBox conSearch = new ListBox();
        // ball edit 09-09-03
        conSearch.setUProfile(this.user);
        /**********************/
        conSearch.setName("conSearch");
        conSearch.setValidCode("consearch");
        conSearch.setChecked(this.conSearch);
        return conSearch.process();
    }
    public String getTagValueSearch() {
        Text inputSearch = new Text();
        inputSearch.setName("valueSearch");
        inputSearch.setonKeyPress("javaScript:chonKeyPress(this,this.value,event);");
        inputSearch.setonBlur("javaScript:chonBlur(this,this.value);");
        inputSearch.setonKeyup("javaScript:chonKeyup(this,this.value);");
        inputSearch.setonFocus("javaScript:chonFocus(this,this.value);");
        inputSearch.setType("text");
        if (this.valueSearch != null) {
            inputSearch.setValue(this.valueSearch);
        }
        inputSearch.setSize("20");
        inputSearch.setMax("30");
        return this.getListTypeField()+"   "+this.charCode("point6", inputSearch.process());
    }
    public String getTagStringSearch() {
        Text inputSearch = new Text();
        inputSearch.setName("stringSearch");
        inputSearch.setType("text");
        if (this.stringSearch != null) {
            inputSearch.setValue(this.stringSearch);
        }
        inputSearch.setSize("30");
        inputSearch.setMax("30");
        return this.charCode("point6", inputSearch.process());
    }
 /*   public void setSearch() {
        try {
            String listCon = "";
            Object obj;
            if ((this.fixCon != null) && (!this.fixCon.equals("")) && (!this.fixCon.equals("null"))) {
                listCon = fixCon;
            }
            //	this.logger.info("-----------------1----------------listCon-"+listCon);
            // this.logger.info("<"+this.valueSearch+">------------<"+this.searchBy+">-----------<"+this.valueSearch+">");
            if ((!this.valueSearch.equals("")) && (!this.searchBy.equals("")) && (!this.valueSearch.equals("null"))) {
                // this.logger.info("-----------------2-----------------");
                if (this.searchBy.substring(0, this.searchBy.indexOf(".")).equalsIgnoreCase(this.inq.getTableName())) {
                    //	this.logger.info("-----------------3-----------------");
                    if ((listCon != null) && (!listCon.equals(""))) {
                        if (this.conSearch.equals("like")) {
                            listCon = "(" + listCon + ") and " + this.searchBy.substring(this.searchBy.indexOf(".") + 1) + " " + this.conSearch + " '%" + this.valueSearch + "%'";
                        } else {
                            listCon = "(" + listCon + ") and " + this.searchBy.substring(this.searchBy.indexOf(".") + 1) + " " + this.conSearch + " '" + this.valueSearch + "'";
                        }
                    } else {
                        if (this.conSearch.equals("like")) {
                            listCon = this.searchBy.substring(this.searchBy.indexOf(".") + 1) + "  " + this.conSearch + " '%" + this.valueSearch + "%'";
                        } else {
                            listCon = this.searchBy.substring(this.searchBy.indexOf(".") + 1) + "  " + this.conSearch + " '" + this.valueSearch + "'";
                        }
                    }
                    //					//this.logger.info("-----------------listCon-->" + listCon + "<---");
                } else {
                    obj = this.inq.getCurrentDbRecord().getChild(this.searchBy.substring(0, this.searchBy.indexOf(".")));
                    if (obj instanceof DbRecord) {
                        if (this.conSearch.equals("like")) {
                            ((DbRecord) obj).setFilter(this.searchBy.substring(this.searchBy.indexOf(".") + 1) + "  " + this.conSearch + " '%" + this.valueSearch + "%'");
                        } else {
                            ((DbRecord) obj).setFilter(this.searchBy.substring(this.searchBy.indexOf(".") + 1) + "  " + this.conSearch + " '" + this.valueSearch + "'");
                        }
                    } else {
                        if (obj instanceof DbInquiry) {
                            if (this.conSearch.equals("like")) {
                                ((DbInquiry) obj).setFilter(this.searchBy.substring(this.searchBy.indexOf(".") + 1) + "  " + this.conSearch + " '%" + this.valueSearch + "%'");
                            } else {
                                ((DbInquiry) obj).setFilter(this.searchBy.substring(this.searchBy.indexOf(".") + 1) + "  " + this.conSearch + " '" + this.valueSearch + "'");
                            }
                        }
                    }
                }
            }
            if ((this.childFilter != null) && (!this.childFilter.equals("")) && (!this.childFilter.equals("null"))) {
                for (StringTokenizer token = new StringTokenizer(this.childFilter, ";"); token.hasMoreTokens();) {
                    for (StringTokenizer sub_token = new StringTokenizer(token.nextToken(), ":"); sub_token.hasMoreTokens();) {
                        obj = this.inq.getCurrentDbRecord().getChild(sub_token.nextToken());
                        if (obj instanceof DbRecord) {
                            ((DbRecord) obj).setFilter(sub_token.nextToken());
                        } else {
                            if (obj instanceof DbInquiry) {
                                ((DbInquiry) obj).setFilter(sub_token.nextToken());
                            }
                        }
                    }
                }
            }
            if ((listCon != null) && (!listCon.equals("")) && (!listCon.equals("null"))) {
                inq.setFilter(listCon);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }*/
    
    public String fontHeadT(String data) {
//        return "<FONT FACE=\"MS Sans Serif, DB ThaiText\" SIZE=\"2\" ><B>" + data + "</B></FONT>";
    	return "<b>" + data + "</b>";
    }
    public String fontBodyT(String data) {
//        return "<FONT FACE=\"MS Sans Serif, DB ThaiText\" SIZE=\"2\" >" + data + "</FONT>";
    	  return data;
    }
    public void getAndset() {
        // this.logger.info("MyHelp getAndSet().");
        try {
            // this.logger.info("MyHelp getAndSet().2");

            orderBy = searchBy = helpName = prvPage = valueSearch = inputBox = pageCall = "";
            goPage = "1";
            if (!this.getValue("goPage").equals("")) {
                this.goPage = this.getValue("goPage");                
            	if(this.goPage.matches("\\d{1,}")){
                    this.skipPage = "";
            	}else{
                    this.skipPage = this.goPage.substring(0,1);
                    this.goPage = this.goPage.substring(1, this.goPage.length());
            	}
                this.currentPage = this.goPage;
                if (this.goPage.trim().length() == 0) {
                    this.goPage = "1";
                }
                if (this.currentPage.trim().length() == 0) {
                    this.currentPage = "1";
                }
            }
            if (!this.getValue("orderBy").equals("")) {
                this.orderBy = this.getValue("orderBy");
            }
            // this.logger.info("MyHelp OredeBy :" + this.getValue("orderBy"));
            if (!this.getValue("searchBy").equals("")) {
                this.searchBy = this.getValue("searchBy");
            }
            // this.logger.info("MyHelp SearchBy :" + this.getValue("searchBy"));
            if (!this.getValue("valueSearch").equals("")) {
                this.valueSearch = this.getValue("valueSearch").trim();
            }
            // this.logger.info("MyHelp StringSearch :" + this.getValue("searchBy"));
            if (!this.getValue("stringSearch").equals("")) {
                this.stringSearch = this.getValue("stringSearch");
            }
            // this.logger.info("MyHelp ValueSearch :" + this.getValue("valueSearch"));
            if (!this.getValue("pageCall").equals("")) {
                this.pageCall = this.getValue("pageCall");
            }
            if (!this.getValue("conSearch").equals("")) {
                this.conSearch = this.getValue("conSearch");
            }
            // this.logger.info("MyHelp ConSearch :" + this.getValue("conSearch"));
            if (!this.getValue("fixCon").equals("")) {
                this.fixCon = this.getValue("fixCon");
            }
            // this.logger.info("MyHelp FixCon :" + this.getValue("fixCon"));
            if (!this.getValue("childFilter").equals("")) {
                this.childFilter = this.getValue("childFilter");
            }
            if ((this.orderBy != null) && (!this.orderBy.equals("")) && (!this.orderBy.equals("null"))) {
                // skip order list
                //        this.logger.info("OredeBy2 :" + this.orderBy);
                if ((this.orderList != null) && (!this.orderList.equals("")) ) {
                    StrReplace rep = new StrReplace();
                   this.orderList = this.orderBy + "," + rep.replace(this.orderList, this.orderBy.replaceAll(" desc", ""), "");
                    this.orderList = rep.replace(this.orderList, ",,", ",");
                    //          this.logger.info("OredeBy3 :" + this.orderList);
                } else {
                	   this.orderList = this.orderBy;
                    //          this.logger.info("OredeBy4 :" + this.orderList);
                }
            }
            if(this.valueSearch==null)this.valueSearch="";
            if(this.conSearch==null)this.conSearch="";
            if(this.searchBy==null)this.searchBy="";
            if((!this.valueSearch.equals(""))&&(this.conSearch.equals(""))&&(this.searchBy.equals(""))){
            	this.conSearch="like";
            	String fieldN="";
            	for (StringTokenizer token = new StringTokenizer(this.searchList, ","); token.hasMoreTokens();) {
            		fieldN = token.nextToken();
            		if(!fieldN.equalsIgnoreCase("companyid")){
            			this.searchBy=inq.getTableName()+"."+fieldN;
            			break;
            		}
            			
            	}
            	
            }
            String referLang =  this.getValue("referLang");
            if (referLang != null && referLang.equals("true"))inq.referLangOn();
        } catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
        }
    }
    public void dataManager(String objName, HashMap param) {
        this.param = param;
        try {
            //System.out.println("this.user="+this.user+" objName="+objName+" this.param="+this.param);
            HelpXml dataControl = new HelpXml(this.user, objName, this.user.getComCode(), this.user.getUserName(), this.user.getPassword(), this.param);
            this.inq = dataControl.getInquiry();
            if ((this.fixCon != null) && (!this.fixCon.equals("")) && (!this.fixCon.equals("null"))) {
                this.inq.setFilter(this.fixCon);
            }
            this.showList = dataControl.showList;
            this.orderList = dataControl.orderList;
            // this.logger.info("OredeList dataManager1 :" + this.orderList);
            // this.fieldReturn = dataControl.returnValue;
            this.returnList = dataControl.returnList.toLowerCase();
            this.searchList = dataControl.searchList;
            // wut edit 10/09/03
            //			this.logger.debug("returnList ====> " + this.returnList + "<=====");
            if ((this.orderBy != null) && (!this.orderBy.equals("")) && (!this.orderBy.equals("null"))) {
                // skip order list
                //       this.logger.debug("this.orderList-->" + this.orderList +     "<--this.orderBy-->" + this.orderBy + "<--");
                if ((this.orderList != null) && (!this.orderList.equals("")) ) {
                    StrReplace rep = new StrReplace();
                    this.orderList = this.orderBy + "," + rep.replace(this.orderList, this.orderBy.replaceAll(" desc", ""), "");
                    this.orderList = rep.replace(this.orderList, ",,", ",");
                    //          this.logger.info("OredeList dataManager2 :" + this.orderList);
                } else {
                	// this.orderList = this.orderBy;
                    //          this.logger.info("OredeList dataManager3 :" + this.orderList);
                }
            }
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
    }
    public void countRec(DbInquiry myInq) {
        try {
            this.totalRec =this.recordCount= myInq.recCount();
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
    }
    
    public void countRec(DbInquiry myInq,String sql) {
        try {
            this.totalRec =this.recordCount= myInq.recCount(sql);
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
    }    
    
    public String getTitlePage() {
        return title;
    }
    protected DbRecord getRecord(String nameTable, DbRecord rec) {
        DbRecord recTemp = null;
        try {
            Object obj = rec.getChild(nameTable);
            if (obj instanceof DbRecord) {
                recTemp = (DbRecord) obj;
            } else {
                if (obj instanceof DbInquiry) {
                    recTemp = ((DbInquiry) obj).getCurrentDbRecord();
                } else {
                }
            }
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
        return recTemp;
    }
    // Argument get is Property Field name
    //edit by pas 20070306
    public String getStringfm(String tableName, String fieldName, String get, boolean returnf) {
        DbRecord rec;
        FieldManager fm = null;   
        if(fieldName.trim().length()==0)
        	return "";
        try {
            if (inq.getTableName().equalsIgnoreCase(tableName)) {
                rec = inq.getCurrentDbRecord();
            } else {
                rec = (DbRecord) this.getRecord(tableName, inq.getCurrentDbRecord());
                if (rec == null) return null;
            }
            fm = rec.getField(fieldName);
            if (fm.getValidCode()!=null  && !fm.getValidCode().equals("") && get.equals("value") && !returnf)
                return rec.getSystemCode(fieldName);
            else {
//            	if (!returnf && !this.tfDate){
            	//	System.out.println("-------------------tableName-->"+tableName+"<------fieldName------->"+fieldName+"<---get--->"+get+"<---returnf-->"+returnf);
            		if (get.equalsIgnoreCase("value"))
                		return fm.getStringHTML();
                	else if (get.equalsIgnoreCase("desc"))
                		return fm.getDescription();
                	else if (get.equalsIgnoreCase("type"))       
                		return fm.getType();
            		else if(returnf || tfDate ||fm instanceof FieldDate || fm instanceof FieldBigDecimal){
            			if(fm instanceof FieldDate && (fm.getcscCalendar().getYYYYMMDD().equalsIgnoreCase("1900-01-01")))
            				return "";
            			else
            				return fm.getDataFormat();
            		}else
            		return fm.getStringHTML();
//            	}
//            	else if (get.equalsIgnoreCase("value"))
//            		return fm.getStringHTML();
//            	else if (get.equalsIgnoreCase("desc"))
//            		return fm.getDescription();
//            	else if (get.equalsIgnoreCase("type"))       
//            		return fm.getType();
//            	else
//            		return fm.getProperty(get).trim();
            }
        
        } catch (Exception e) {
        	// System.out.println("ERROR IN getStringfm  : TNAME : " + tableName + " FIELD : " + fieldName);
			MyLog.error(this, this.getUProfile(),"ERROR IN getStringfm  : TNAME : " + tableName + " FIELD : " + fieldName);
			MyLog.error(this, this.getUProfile(), e);
            return null;
        }
    }

    public void setTransformDate(boolean tfDate) {
    	this.tfDate = tfDate;
    }
    public String getPageTag() {
        if (currentPage.trim().length() < 1) {
            currentPage = "1";
        }
        int cur = 0;
        if (Integer.parseInt(currentPage) > 10) {
            cur = (Integer.parseInt(currentPage) / 10);
        }
        pageTag = "";
        if (cur != 0) {
            cur = cur * 10;
        }
        if ((cur == Integer.parseInt(currentPage)) || ((this.skipPage != null) && (this.skipPage.equalsIgnoreCase("-")) && (cur > 1))) {
            pageTag = pageTag + this.getPageIndexTAG(0, String.valueOf(cur - 10), "&lt;&lt;");
            for (int i = 1; i <= 10; i++) {
                pageTag = pageTag + "&nbsp;";
                pageTag = pageTag + this.getPageIndexTAG(1, String.valueOf(cur + (-10) + i), String.valueOf(cur + (-10) + i));
            }
            pageTag = pageTag + this.getPageIndexTAG(1, String.valueOf(cur + 1), "&gt;&gt;");
        } else {
            pageTag = pageTag + this.getPrePage();
            for (int i = 1; i <= 10; i++) {
                pageTag = pageTag + "&nbsp;";
                pageTag = pageTag + this.getPageIndexTAG(1, String.valueOf(cur + i), String.valueOf(cur + i));
                if ((cur + i) >= this.getMaxPage()) {
                    break;
                }
            }
            pageTag = pageTag + "&nbsp;" + this.getNextPage();
        }
        this.skipPage = "";
        return pageTag;
    }
    public String getCurrentKey() {
        return key;
    }
//    public String getPageIndexTAG(int check, String nPage, String sPage) {
//        Label label1 = new Label();
//        label1.setLabel(sPage);
//        label1.setLabelFont(new MyFont("labelPageHelp"));
//        if ((Integer.parseInt(nPage) <= this.getMaxPage()) && (Integer.parseInt(nPage) != Integer.parseInt(currentPage))) {
//            if (check == 1) {
//                return this.tagScript("+" + nPage, sPage);
//            } else {
//                return this.tagScript("-" + nPage, sPage);
//            }
//        } else {
//            return label1.process();
//        }
//    }
    public String getPageIndexTAG(int check, String nPage, String sPage) {
        if ((Integer.parseInt(nPage) <= this.getMaxPage()) && (Integer.parseInt(nPage) != Integer.parseInt(currentPage))) {
            if (check == 1) {
                return this.tagScript("+" + nPage, sPage);
            } else {
                return this.tagScript("-" + nPage, sPage);
            }
        } else {
            return sPage;
        }
    }
    public String getNextPage() {
        String next = "&gt;&gt;";
        int count = 0;
        int currP = Integer.parseInt(currentPage);
        if (currP < this.getMaxPage()) {
            if ((currP < 11) && (this.getMaxPage() > 10)) {
                return this.tagScript("+" + String.valueOf(10 + 1), "&gt;&gt;");
            } else {
                if ((currP >= 10) && (this.getMaxPage() > 20)) {
                    if (((currP / 10) * 10) + 10 <= this.getMaxPage()) {
                        return this.tagScript("+" + String.valueOf((((currP + 10) / 10) * 10) + 1), "&gt;&gt;");
                    }
                }
            }
        }
        return next;
    }
    public int getMaxPage() {
        int pageCount;
        pageCount = (this.totalRec / this.maxLine);
        if ((this.totalRec % this.maxLine) > 0) {
            pageCount++;
        }
        return pageCount;
    }
    public String getPrePage() {
        String pre = "&lt;&lt;";
        if (Integer.parseInt(currentPage) > 1) {
            int currP = Integer.parseInt(currentPage);
            if ((((currP / 10) * 10) >= 10) && (currP > 10)) {
                return this.tagScript("-" + String.valueOf(((currP / 10) * 10)), "&lt;&lt;");
            }
        }
        return pre;
    }
    public String getLabel(String tableName, String fieldName) {
        DbRecord rec;
        FieldManager fm = null;
        try {
            if (inq.getTableName().equalsIgnoreCase(tableName)) {
                rec = inq.getCurrentDbRecord();
            } else {
                rec = (DbRecord) this.getRecord(tableName, inq.getCurrentDbRecord());
            }
            fm = rec.getField(fieldName);
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
	        if(fm==null){
	        	return  fieldName;
	        }else{
	        	return this.charCode("point6", fm.getDescription());
	        }        
    }
    public String getLabel(String fieldName) {
        String data = "";
        try {
            data = this.getLabel(inq.getTableName(), fieldName);
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
        return data;
    }
    public String getString(String fieldName) {
        String data = "";
        try {
        	FieldManager fm = this.inq.getCurrentDbRecord().getField(fieldName);
        	if (fm != null && (fm instanceof FieldDouble || fm instanceof FieldDate)) {
        		data = fm.getStringHTML();
        	} else {
        		data = this.inq.getStringHTML(fieldName);
        	}
            //data = this.inq.getString(fieldName);
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
        return data;
    }
    public String getString(String tableName, String fieldName) {
        String data = "";
        DbRecord rec = null;
        try {
            if (inq.getTableName().equalsIgnoreCase(tableName)) {
                rec = inq.getCurrentDbRecord();
            } else {
                rec = (DbRecord) this.getRecord(tableName, inq.getCurrentDbRecord());
            }
            FieldManager fm = rec.getField(fieldName);
        	if (fm != null && (fm instanceof FieldDouble || fm instanceof FieldDate)) {
        		data = fm.getStringHTML();
        	} else {
        		data = rec.getStringHTML(fieldName);
        	}
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(),"######################### ERROR in MYHELP.GETSTRING[" + tableName + "," + fieldName + "]");
			MyLog.error(this, this.getUProfile(), e);
        }
        return data;
    }
    public String getRecCount() {
        return String.valueOf(this.recordCount);
    }
    public String process() {
        try {        	
        	currentRec=0;
        	StaticProperties.myConnection.beginTransaction(this.getUProfile(), this);
            this.setOrder();
            String inqFilter=this.inq.getFilter();
            this.inq.setFilter("");
            this.setSearch();
            if(inqFilter.trim().length()>0){
            	if(this.inq.getFilter().length()>0){
            		inqFilter+=" and "+this.inq.getFilter();
            	}
            	this.inq.setFilter(inqFilter);
            }

            if (this.stringSearch != null && !this.stringSearch.equals("")) {
                inq.setStringFilter(this.stringSearch);
            }
            if(this.param.get("securityoff")!=null && !this.param.get("securityoff").equals("")){
            	inq.setSecurityOff();
            }
            this.setPeriodRows();
            
            //inq.refresh();
            this.countRec(this.inq);
            if (this.totalRec == 0) {
                this.totalRec++;
            }
            canRefresh=true;
            this.inq.setRefreshBeforeNext(canRefresh);
            StaticProperties.myConnection.endTransaction(	this.getUProfile(), this);
        } catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
        }
        return "0";
    }

    public String process(String sqlReccount) {
        try {
        	currentRec=0;
        	StaticProperties.myConnection.beginTransaction(this.getUProfile(), this);
            this.setOrder();
            String inqFilter=this.inq.getFilter();
            this.setSearch();
            if(inqFilter.trim().length()>0){
            	if(this.inq.getFilter().length()>0){
            		inqFilter+=" and "+this.inq.getFilter();
            	}
            	this.inq.setFilter(inqFilter);
            }

            if (this.stringSearch != null && !this.stringSearch.equals("")) {
                inq.setStringFilter(this.stringSearch);
            }
            if(this.param.get("securityoff")!=null && !this.param.get("securityoff").equals("")){
            	inq.setSecurityOff();
            }
            this.setPeriodRows();
            
            //inq.refresh();
            this.countRec(this.inq,sqlReccount);
            if (this.totalRec == 0) {
                this.totalRec++;
            }
            StaticProperties.myConnection.endTransaction(	this.getUProfile(), this);
        } catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
        }
        return "0";
    }    
    
    public String getTagOrder() {
        //		this.logger.info("<<-----------------Strat getTagOrder--------------->>" + this.orderList);
        String[][] aa = new String[50][2];
        int i = 0;
        FieldManager fm;
        DbRecord rec = null;
        String tmp1, tmp2 = "";
        if (!this.orderList.equals("")) {
            ListBox listOrder = new ListBox();
            listOrder.setName("listOrder");
            listOrder.setonChange("javascript:setOrderby();");
            listOrder.setChecked(this.orderBy);
            for (StringTokenizer token = new StringTokenizer(this.orderList, ","); token.hasMoreTokens();) {
                tmp1 = token.nextToken();
                tmp2 = tmp2 + tmp1.substring(tmp1.indexOf(".") + 1);
                if (tmp2.trim().indexOf(" ") > 0) {
                	tmp2 = tmp2.substring(0,tmp2.indexOf(" "));
                	tmp1 = tmp1.substring(0,tmp1.indexOf(" "));
                } else
                	tmp2 = tmp2.trim();
                try {
                    if (inq.getTableName().equalsIgnoreCase(tmp1.substring(0, tmp1.indexOf(".")))) {
                        rec = inq.getCurrentDbRecord();
                        /*     if (tmp2.indexOf(" ") > 0) {
                         tmp2 = tmp2.substring(0, tmp2.indexOf(" "));
                         }*/
                        fm = rec.getField(tmp2);
                        aa[i][0] = tmp1;
                        aa[i][1] = fm.getDescription();
                        i++;
                    } else {
                        rec = this.getRecord(tmp1.substring(0, tmp1.indexOf(".")), inq.getCurrentDbRecord());
                        // this.logger.info(rec+"---label----"+tmp1.substring(tmp1.indexOf(".")+1,tmp1.length()));
                        tmp2 = tmp1.substring(tmp1.indexOf(".") + 1);
                        if (tmp2.trim().indexOf(" ") > 0)
                        	tmp2 = tmp2.substring(0,tmp2.indexOf(" "));
                        else
                        	tmp2 = tmp2.trim();
                        /*if (tmp2.indexOf(" ") > 0) {
                         tmp2 = tmp2.substring(0, tmp2.indexOf(" "));
                         }*/
                        fm = rec.getField(tmp2);
                        aa[i][0] = tmp1;
                        aa[i][1] = fm.getDescription();
                        i++;
                    }
                } catch (Exception e) {
       				MyLog.error(this, this.getUProfile(), e);
                }
                tmp2 = "";
            }
            String methodlang = this.getUProfile().get("lang");
            String mltmp = SystemCode.getValue("DESCENDING","DESCENDING");
            if (methodlang.equalsIgnoreCase("THA")) 
            	methodlang = " " + mltmp.substring(mltmp.indexOf(",")+1);
            else 
            	methodlang = " " + mltmp.substring(0,mltmp.indexOf(","));
            int max = i;
            for (i=0;i<max;i++) {
            	aa[i+max][0] = aa[i][0] + " desc";
            	aa[i+max][1] = aa[i][1] + methodlang; 
            }
            listOrder.setSelect(aa);
            return listOrder.process();
        } else {
            return "";
        }
    }
    public String getTagSearchBy() {
        String[][] aa = new String[50][2];
        int i = 0;
        FieldManager fm = null;
        DbRecord rec = null;
        String tmp1 = "";
        if (this.searchList != "") {
            ListBox searchOrder = new ListBox();
            searchOrder.setName("searchBy");
            searchOrder.setChecked(this.searchBy);
            for (StringTokenizer token = new StringTokenizer(this.searchList, ","); token.hasMoreTokens();) {
                tmp1 = token.nextToken();
                try {
                    if (tmp1.indexOf(".") < 0) {
                        rec = inq.getCurrentDbRecord();
                        fm = rec.getField(tmp1);
                        tmp1 = inq.getTableName() + "." + tmp1;
                    } else {
                        rec = this.getRecord(tmp1.substring(0, tmp1.indexOf(".")), inq.getCurrentDbRecord());
                        fm = rec.getField(tmp1.substring(tmp1.indexOf(".") + 1, tmp1.length()));
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }
                aa[i][0] = tmp1;
                aa[i][1] = fm.getDescription();
                i++;                
                this.listTypeField+=fm.getName()+":"+fm.getType()+"#";
            }
            searchOrder.setSelect(aa);
            searchOrder.setonChange("javaScript:clsValueSearch();");
            return this.charCode("point6", searchOrder.process());
        } else {
            return "";
        }
    }
    public void setOrder() {
        Hashtable box = new Hashtable();
        Object dbChild;
        String tmp1, tmp2, tnameList = "";
        //   this.logger.info("<----------------- order  from setOrder MyHelp :" +this.orderList);
        //try{	this.logger.info("------------------------INQ:"+inq.toString()+" "+inq.getAllKey());}catch(Exception e){e.printStackTrace();}
        for (StringTokenizer token = new StringTokenizer(this.orderList, ","); token.hasMoreTokens();) {
            tmp1 = token.nextToken();
            tmp2 = "";
            if (!tmp1.trim().equals("")) {
                //        this.logger.info("<----------------- tmp 1 from setOrder MyHelp :" +tmp1);
                if (box.containsKey(tmp1.substring(0, tmp1.indexOf(".")))) {
                    tmp2 = (String) box.get(tmp1.substring(0, tmp1.indexOf(".")));
                } else {
                    tnameList = tnameList + tmp1.substring(0, tmp1.indexOf(".")) + ",";
                }
                tmp2 = tmp2 + tmp1.substring(tmp1.indexOf(".") + 1) + ",";
                box.put(tmp1.substring(0, tmp1.indexOf(".")), tmp2);
            }
        }
        for (StringTokenizer token = new StringTokenizer(tnameList, ","); token.hasMoreTokens();) {
            tmp1 = token.nextToken();
            tmp2 = (String) box.get(tmp1);
            try {
                if (inq.getTableName().equalsIgnoreCase(tmp1)) {
                    inq.setOrderBy(tmp2.substring(0, tmp2.lastIndexOf(",")));
                } else {
                    dbChild = this.inq.getCurrentDbRecord().getChild(tmp1);
                    if (dbChild instanceof MyInquiry) {
                        ((MyInquiry) dbChild).setOrderBy(tmp2.substring(0, tmp2.length() - 1));
                    }
                }
            } catch (Exception e) {
   				MyLog.error(this, this.getUProfile(), e);
            }
        }
        if ((this.orderBy != null) && (this.orderBy != "") && (!this.orderBy.equals("null"))) {
            try {
                // ball edit
                //				this.logger.debug("Method setOrder -->" + this.orderBy + "<--this.orderBy.indexOf(.)--->" + this.orderBy.indexOf(".") + "<---");
                String orderF = "";
                String orderT = "";
                if (this.orderBy.indexOf(".") > 1) {
                    orderT = this.orderBy.substring(0, this.orderBy.indexOf("."));
                    orderF = this.orderBy.substring(this.orderBy.indexOf(".") + 1, this.orderBy.length());
                    dbChild = this.inq.getCurrentDbRecord().getChild(orderT);
                    if (dbChild instanceof MyInquiry) {
                        ((MyInquiry) dbChild).setOrderBy(orderF);
                    }
                } else {
                    this.inq.setOrderBy(this.orderBy);
                }
                // end
            } catch (Exception e) {
   				MyLog.error(this, this.getUProfile(), e);
            }
        }
    }
    // Method Create 10/09/03 by Wut
    public boolean checkReturn(String fieldName) {
        boolean ret = false;
        for (StringTokenizer token = new StringTokenizer(this.returnList, ","); token.hasMoreTokens();) {
            if (token.nextToken().equalsIgnoreCase(fieldName)) {
                ret = true;
            }
        }
        return ret;
    }
    // Method Create 160304 by pae
    protected String returnChildHelp(String tableName) {
        String retValue = "", tmp1 = "", tmp3 = "",vdesc="";
        for (StringTokenizer token = new StringTokenizer(this.getValue("helpReturn"), ","); token.hasMoreTokens();) {
            tmp1 = token.nextToken();
            if (tmp1.indexOf("@") != -1) {
                tableName = tmp1.substring(0, tmp1.indexOf("@"));
                if (tmp1.indexOf("$") != -1) {
                    tmp3 = tmp1.substring(tmp1.indexOf("@") + 1, tmp1.indexOf("$"));
                } else
                    tmp3 = tmp1.substring(tmp1.indexOf("@") + 1, tmp1.length());
            } else if (tmp1.indexOf(":") > -1) {
                try {
                    tableName=inq.getTableName();
                } catch (Exception e) {
       				MyLog.error(this, this.getUProfile(), e);
                }
                tmp3 = tmp1.substring(tmp1.indexOf(":") + 1, tmp1.length());
                tmp1 = tmp1.substring(0, tmp1.indexOf(":")).trim();
                if(tmp3.indexOf(".")>-1){
                    tableName=tmp3.substring(0,tmp3.indexOf("."));
                    tmp3=tmp3.substring(tmp3.indexOf(".")+1,tmp3.length());
                }
            }
            if(tmp3.indexOf("|")>-1){
            	vdesc=tmp3.substring(tmp3.indexOf("|")+1,tmp3.length());
            	tmp3=tmp3.substring(0,tmp3.indexOf("|"));
            	
            }
            // get from Screen if langOn 
            String langon =  this.getValue("langOn");
            if (langon == null || langon.equals("")|| langon.equalsIgnoreCase("null"))
            	langon = "true";
            if (langon.equalsIgnoreCase("true")) {
	            try {
	            	String fieldLang="",tmptbName=tableName;
	            	if (inq.getTableName().equalsIgnoreCase(tableName)) {
	            		fieldLang=StaticProperties.getPropertiesField(tableName,tmp3,"lang");
	            	}else {
	            		DbInquiry ditemp = ((DbInquiry) this.inq.getChild(tableName));
	            		if (ditemp != null){
	            			tmptbName=ditemp.getTableName();
	            			fieldLang=StaticProperties.getPropertiesField(tmptbName,tmp3,"lang");
	            		}else continue;
	            	}
	            	
					if (fieldLang != null && !fieldLang.equals("") && !fieldLang.equalsIgnoreCase("A") 
							&& !fieldLang.equalsIgnoreCase(this.user.get("lang").substring(0,1)) ) {
							tmp3 = StaticProperties.getPropertiesField(tmptbName,tmp3,"refer_lang");
						}	            	
	            	
				} catch (Exception e) {
					MyLog.error(this, this.getUProfile(),"Can't not get Field or Lang -- from " + tmp1 + " : " + tmp3);
					MyLog.error(this, this.getUProfile(), e);
				}
			}
            if(vdesc.equalsIgnoreCase("desc"))
            	retValue = retValue + tmp1 + "#" + this.getStringfm(tableName, tmp3, "value", false);
            else            
            	retValue = retValue + tmp1 + "#" + this.getStringfm(tableName, tmp3, "value", true);
            if (token.hasMoreTokens())
                retValue += ";";
        }
        return retValue;
    }
    //edit by suk 26-03-04
    protected boolean isHelpReturn() {
        return (this.getValue("helpReturn") != null && !this.getValue("helpReturn").equals("") && !this.getValue("helpReturn").equalsIgnoreCase("false"));
    }
    protected String returnHelp(String tableName) {
        String retValue = "", tmp1 = "", tmpValue = "", tmp2 = "", tmp3 = "";
        if (this.getValue("helpReturn") != null && !this.getValue("helpReturn").equals("") && !this.getValue("helpReturn").equalsIgnoreCase("false")) {
            return this.returnChildHelp(tableName);
        } else {
            for (StringTokenizer token = new StringTokenizer(this.returnList, ","); token.hasMoreTokens();) {
            	
            	//String tmptable = tableName;
            	String tmptable="";
				try {
					tmptable = this. inq.getTableName();
				} catch (RemoteException e1) {
					// TODO Auto-generated catch block
					MyLog.error(this, this.getUProfile(), e1);
				}
            	tmp1 = token.nextToken();
                // get Field for check lang
				boolean childfield = false;
				if (tmp1.indexOf(".") >=0) {
					tmptable = tmp1.substring(0,tmp1.indexOf("."));
					tmp1 = tmp1.substring(tmp1.indexOf(".")+1);
					childfield = true;
				}
                String langon =  this.getValue("langOn");
                if (langon == null || langon.equals(""))
                	langon = "true";
                if (langon.equalsIgnoreCase("true")) {
					try {
//						FieldManager fm = null;
//						if (!childfield) {
//							fm = this.inq.getCurrentDbRecord().getField(tmp1);
//						} else {
//							ChildManager cm = this.inq.getChild(tmptable);
//							if (cm instanceof DbInquiry) {
//								fm = ((DbInquiry) cm).getCurrentDbRecord().getField(tmp1);
//							} else if (cm instanceof DbRecord) {
//								fm = ((DbRecord) cm).getField(tmp1);
//							}
//						}
//						String fieldLang = String.valueOf(fm.getLang());
//						if (!fieldLang.equalsIgnoreCase("A")
//								&& !fieldLang.equalsIgnoreCase(this.user.get(
//										"lang").substring(0, 1))) {
//							tmp1 = fm.getProperty("refer_lang");
//						}

		            	String fieldLang="",tmptbName=tableName;
		            	if (!childfield) {
		            		fieldLang=StaticProperties.getPropertiesField(tableName,tmp1,"lang");
		            	}else {
		            		ChildManager cm = this.inq.getChild(tmptable);
		            		if (cm instanceof DbInquiry){
		            			tmptbName=((DbInquiry) cm).getCurrentDbRecord().getTableName();
		            			fieldLang=StaticProperties.getPropertiesField(tmptbName,tmp1,"lang");
		            		}else continue;
		            	}
		            	
						if (fieldLang != null && !fieldLang.equals("") && !fieldLang.equalsIgnoreCase("A") 
								&& !fieldLang.equalsIgnoreCase(this.user.get("lang").substring(0,1)) ) {
								tmp1 = StaticProperties.getPropertiesField(tmptbName,tmp1,"refer_lang");
							}	            	

						
					} catch (Exception e) {
        				MyLog.error(this, this.getUProfile(),"Can't not get Field or Lang -- from " + tmp1 + " : " + tmp3);
        				MyLog.error(this, this.getUProfile(), e);
					}
				}
               
                retValue = retValue + "__" + tmp1 + "#" + this.getStringfm(tmptable, tmp1, "value", true) + ";";
            }
        }
        return retValue;
    }
    public String getDateLabel(String fieldName) {
        String data = "";
        try {
            data = this.inq.getCurrentDbRecord().getField(fieldName).getcscCalendar().getString();
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
        return data;
    }
    public String getDateLabel(String tableName, String fieldName) {
        String data = "";
        DbRecord rec = null;
        try {
            if (inq.getTableName().equals(tableName)) {
                rec = inq.getCurrentDbRecord();
            } else {
                rec = (DbRecord) this.getRecord(tableName, inq.getCurrentDbRecord());
            }
            data = rec.getField(fieldName).getcscCalendar().getString();
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(),"----------------------  TableName : "+tableName+" FieldName : "+fieldName);
			MyLog.error(this, this.getUProfile(), e);
        }
        return data;
    }
    // Edit 26-03-04 by WUT
    private boolean isString() {
        //	this.inq.getCurrentDbRecord().getField("").getType();
        return false;
    }
    // Edit 26/03/04 by WUT
    // Edit by pas 20070306
    public void setTable() {
        try {
            String tmpLabel, namefield, tmp1, tmp2, tmpValue;
            String tableName = "MyTable";
            String returnValue = "", star = "&nbsp;";
            int orderField = 0;
            int numField = 0;
            String alignment = "left";
            StringTokenizer token1 = new StringTokenizer(this.showList, ",");
            numField = token1.countTokens();
            this.tableHTML = "<table class=\"large\"  width=\"0%\" border=\"0%\" cellspacing=\"0\" cellpadding=\"0\"" + " align=\"center\" id=\"" + tableName + "\" name=\"" + tableName + "\" cols=\"" + (numField + 1) + "\">";
            this.tableHTML = this.tableHTML + "<tr>" + this.nextline;
//            if (!this.isHelpReturn()) {
//                this.tableHTML = this.tableHTML + "<td class=\"HELPHEAD\" width=\"0%\">" + " " + "</td>";
//                orderField++;
//            }
            for (; token1.hasMoreTokens();) {
                tmp1 = token1.nextToken();
                tmp2 = tmp1.substring(tmp1.indexOf(".") + 1);
                tmp1 = tmp1.substring(0, tmp1.indexOf("."));
                tmpLabel = this.getStringfm(tmp1, tmp2, "desc", false);
         //       this.tableHTML = this.tableHTML + "<td class=\"HELPHEAD\" >" + "<a href=\"javascript:sortTable(" + orderField + "," + tableName + ");\">" + this.fontHeadT(tmpLabel) + "</a>" + "</td>" + this.nextline;
                this.tableHTML = this.tableHTML + "<td class=\"HELPHEAD\" >"  + this.fontHeadT(tmpLabel) + "</td>" + this.nextline;
                orderField++;
            }
            this.tableHTML = this.tableHTML + "</tr>" + this.nextline;
            this.setPeriodRows();
            inq.first();
            if(inq.recCount()>0){
            while (inq.next()){
                //if ((inq.recNo() <= (maxLine * Integer.parseInt(goPage))) && (inq.recNo() > (maxLine * (Integer.parseInt(goPage) - 1)))) {
                    this.tableHTML = this.tableHTML + "<tr>" + this.nextline;
                    star = "&nbsp; ";
                    //if this help page is help return not show record status
//                    if (!this.isHelpReturn()) {
//                        this.tableHTML = this.tableHTML + "<td class=\"forborder\" ><div align=\"CENTER\">" + star + "</div></td>";
//                    }
                    for (StringTokenizer token = new StringTokenizer(this.showList, ","); token.hasMoreTokens();) {
                        tmp1 = token.nextToken();
                        tmp2 = tmp1.substring(tmp1.indexOf(".") + 1);
                        tmp1 = tmp1.substring(0, tmp1.indexOf("."));
                        tmpValue = this.getStringfm(tmp1, tmp2, "value", false);
                        //if (this.isNumber(tmpValue)){alignment="RIGHT";}else{alignment="LEFT";}
                        if (!this.getStringfm(tmp1, tmp2, "type", false).equalsIgnoreCase("String")) {
                            alignment = "RIGHT";
                        } else {
                            alignment = "LEFT";
                        }                        
                        if (this.checkReturn(tmp2)) {
                        	returnValue = this.returnHelp(tmp1);
                            this.tableHTML = this.tableHTML + "<td  class=\"forborder\" ><div align=\"" + alignment + "\">&nbsp;" + this.getLinkTag(returnValue, this.fontBodyT(tmpValue)) + "&nbsp;</div></td>"
                                    + this.nextline;
                       } else {
                            this.tableHTML = this.tableHTML + "<td  class=\"forborder\"  ><div align=\"" + alignment + "\">&nbsp;" + this.fontBodyT(tmpValue) + "&nbsp;</div></td>" + this.nextline;
                        }
                    }
                    this.tableHTML = this.tableHTML + "</tr>" + this.nextline;
//                }
//                if (inq.recNo() > (maxLine * Integer.parseInt(goPage))) {
//                    break;
//                }
            }
            }else{
            	for(int i=0;i<numField;i++){
            		this.tableHTML +="<td  class=\"forborder\" >&nbsp;</td>" + this.nextline;
            	}
            }
            this.tableHTML = this.tableHTML + "</table>";
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
       }
    }
    public boolean nextRec() {    	
        boolean ok = false;
        try {
        	if(canRefresh){//ͧҹ process ҡ͹֧refresh
        		this.inq.refresh();
        		canRefresh=false;
        		this.inq.setRefreshBeforeNext(canRefresh);
        	}
       		ok = this.inq.next();            
       		currentRec++;
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
        return ok;
    }
    public String printTableHTML() {    	
        setTable();
        this.inq.closeConnection();
        this.inq.closeConnectionChild();
        return this.charCode("point6", this.tableHTML);
    }
    public boolean outLinePage() {
        boolean ok = false;
        /*
         * boolean ok = false;
         * ͧ͡㪤öͧ database ᷹
         * try {
            ok = (inq.recNo() > (maxLine * Integer.parseInt(goPage)));
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }*/
        return ok;
    }
    public boolean checkLinePage() {
        boolean ok = true;
        /*
         * remove by pas öͧ databbase ᷹
         * 
         * boolean ok = false;
        try {
            if (goPage.trim().length() < 1) {
                goPage = "1";
            }
            ok = (inq.recNo() <= (maxLine * Integer.parseInt(goPage))) && (inq.recNo() > (maxLine * (Integer.parseInt(goPage) - 1)));
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }*/
        return ok;
    }
    public void setMaxLine(int max) {
        this.maxLine = max;
    }
    public boolean nextChildInquiry(String nameTable) {
        boolean ok = false;
        try {
            DbInquiry eInq = null;
            Object obj;
            obj = this.inq.getCurrentDbRecord().getChild(nameTable);
            if (obj instanceof DbInquiry) {
                eInq = ((DbInquiry) obj);
            }
            ok = eInq.next();
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
        return ok;
    }
    public String getOption(String option) {
        if (option.equalsIgnoreCase("gopage")) {
            return this.goPage;
        } else if (option.equalsIgnoreCase("orderby")) {
            return this.orderBy;
        } else if (option.equalsIgnoreCase("searchby")) {
            return this.searchBy;
        } else {
            return "";
        }
    }
    public DbInquiry getInquiry() {
        return this.inq;
    }
    public void referLangOff() {
        try {
            this.inq.referLangOff();
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
    }
    public void referLangOn() {
        try {
            this.inq.referLangOn();
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
    }
    public String getDataLabel(String nameField) {
        String data = "";
        try {
        	data = this.charCode("point6", this.inq.getCurrentDbRecord().getField(nameField).getStringHTML());
            //data = this.charCode("ponit6", this.myRec.getString(nameField));
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(),"=================  SingleEntry.getDataLabel() [ Namefield : " + nameField + "] ");
			MyLog.error(this, this.getUProfile(), e);
        }
        return data;
    }
    public String getDataLabel(String tableName, String nameField) {
        String data = "";
        try {
            try {
                DbRecord db = (DbRecord) this.inq.getChild(tableName.toLowerCase());
                data = this.charCode("point6", db.getField(nameField).getStringHTML());
                //data = this.charCode("ponit6", db.getString(nameField));
            } catch (ClassCastException e) {
                DbInquiry di = (DbInquiry) this.inq.getChild(tableName.toLowerCase());
                data = this.charCode("point6", di.getCurrentDbRecord().getField(nameField).getStringHTML());
                //data = this.charCode("ponit6", di.getString(nameField));
            }
        } catch (Exception e) {
        	MyLog.error(this, this.getUProfile(),"=================  SingleEntry.getDataLabel() [TableName : " + tableName + " Namefield : " + nameField + "] ");
			MyLog.error(this, this.getUProfile(), e);
        }
        return data;
    }
    /*** Method printMynoteTableHTML() for Mynote (Print Help) ***/
    public String printMynoteTableHTML() {
        setMynoteTable();
        this.inq.closeConnection();
        this.inq.closeConnectionChild();
        return this.charCode("point6", this.tableHTML);
    }
    /*** End method printMynoteTableHTML() ***/
    /*** Method setMynoteTable() for Mynote (Print Help) ***/
    public void setMynoteTable() {
        try {
            String tmpLabel, tmp1, tmp2, tmpValue;
            String tableName = "MyTable";
            String returnValue = "", star = "&nbsp;";
            int orderField = 0;
            int numField = 0;
            String alignment = "left";
            boolean next_page = false;
            int browse_page = 1;
            //this.maxLine = 10;            
            StringTokenizer token1 = new StringTokenizer(this.showList, ",");
            numField = token1.countTokens();
            this.tableHTML = "<table width=\"100%\" border=\"0%\" cellspacing=\"1\" cellpadding=\"0\"" + " align=\"center\" id=\"" + tableName + "\" name=\"" + tableName + "\" cols=\"" + (numField + 1) + "\" class=\"txt01\">";
            this.tableHTML = this.tableHTML + "<tr bgcolor=\"#eff7fa\">" + this.nextline;
            if (!this.isHelpReturn()) {
                this.tableHTML = this.tableHTML + "<td class=\"txt01\" >" + " " + "</td>";
                orderField++;
            }
            for (; token1.hasMoreTokens();) {
                tmp1 = token1.nextToken();
                tmp2 = tmp1.substring(tmp1.indexOf(".") + 1);
                tmp1 = tmp1.substring(0, tmp1.indexOf("."));
                tmpLabel = this.getStringfm(tmp1, tmp2, "desc", false);
                this.tableHTML = this.tableHTML + "<td class=\"txt01\" >" + tmpLabel + "</td>" + this.nextline;
                orderField++;
            }
            this.tableHTML = this.tableHTML + "</tr>" + this.nextline;
            if ((goPage == null) || (goPage == "")) {
                goPage = "1";
            }else{
            	if( this.getValue("goPage") != null && this.getValue("goPage").length() > 0 ){
            		goPage = this.getValue("goPage");
            	}
            	browse_page = Integer.parseInt(goPage);
//            	if( browse_page > 1 )
//            		inq.go(this.maxLine * (browse_page - 1));
            }
            this.setPeriodRows();
            inq.first();            
            for (; inq.next();) {
//                if( (inq.recNo() <= (maxLine * Integer.parseInt(goPage))) && (inq.recNo() > (maxLine * (Integer.parseInt(goPage) - 1))) ){
                    this.tableHTML = this.tableHTML + "<tr >" + this.nextline;
                    star = "&nbsp; ";
                    //if this help page is help return not show record status
                    if (!this.isHelpReturn()) {
                        this.tableHTML = this.tableHTML + "<td class=\"txt01\" ><div align=\"center\">" + star + "</td>";
                    }
                    for (StringTokenizer token = new StringTokenizer(this.showList, ","); token.hasMoreTokens();) {
                        tmp1 = token.nextToken();
                        tmp2 = tmp1.substring(tmp1.indexOf(".") + 1);
                        tmp1 = tmp1.substring(0, tmp1.indexOf("."));
                        tmpValue = this.getStringfm(tmp1, tmp2, "value", false);
                        //if (this.isNumber(tmpValue)){alignment="RIGHT";}else{alignment="LEFT";}
                        if (!this.getStringfm(tmp1, tmp2, "type", false).equalsIgnoreCase("String")) {
                            alignment = "right";
                        } else {
                            alignment = "left";
                        }
                        returnValue = this.returnHelp(tmp1);
                        /*if (this.checkReturn(tmp2)) {
                            this.tableHTML = this.tableHTML + "<td ><div align=\"" + alignment + "\">&nbsp;" + this.getLinkTag(returnValue, this.fontBodyT(tmpValue)) + "&nbsp;</div></td>"
                                    		 + this.nextline;
                        } else {
                            this.tableHTML = this.tableHTML + "<td ><div align=\"" + alignment + "\">&nbsp;" + this.getLinkTag(returnValue, this.fontBodyT(tmpValue)) + "&nbsp;</div></td>"
                            				 + this.nextline;
                        }*/
                        if( returnValue.indexOf("null") > -1 ){
                        	this.tableHTML = this.tableHTML + "<td bgcolor=\"#efefef\" ><div align=\"" + alignment + "\">&nbsp;" + tmpValue + "&nbsp;</div></td>" + this.nextline;
                        }else{
                            this.tableHTML = this.tableHTML + "<td bgcolor=\"#efefef\" ><div align=\"" + alignment + "\">&nbsp;" + this.getLinkTag(returnValue, tmpValue) + "&nbsp;</div></td>" + this.nextline;
                        }
                    }
                    this.tableHTML = this.tableHTML + "</tr>" + this.nextline;
//                }
//                if (inq.recNo() > (maxLine * Integer.parseInt(goPage))) {
//                	next_page = true;
//                    break;
//                }
            }
            
            this.tableHTML = this.tableHTML + "<tr>" + this.nextline;
            this.tableHTML = this.tableHTML + "<td height=\"15\" colspan=\"" + orderField + "\"><div align=\"right\"></div>" + this.nextline;
            this.tableHTML = this.tableHTML + "<div align=\"left\"> </div>" + this.nextline;
            this.tableHTML = this.tableHTML + "<div align=\"center\"></div>" + this.nextline;
            this.tableHTML = this.tableHTML + "<div align=\"right\"></td>" + this.nextline;
            this.tableHTML = this.tableHTML + "</tr>" + this.nextline;
            
            int max_page = (((inq.recCount()/this.maxLine) > 0) && ((inq.recCount()%this.maxLine) > 0)?(inq.recCount()/this.maxLine)+1:((inq.recCount()/this.maxLine) == 0?1:inq.recCount()/this.maxLine));

            this.tableHTML = this.tableHTML + "<tr>" + this.nextline;
            this.tableHTML = this.tableHTML + "<td height=\"15\" colspan=\"" + orderField + "\"><div align=\"right\"></div>" + this.nextline;
            this.tableHTML = this.tableHTML + "<div align=\"left\"> </div>" + this.nextline;
            this.tableHTML = this.tableHTML + "<div align=\"center\"></div>" + this.nextline;
            this.tableHTML = this.tableHTML + "<div align=\"right\" Page : >" + this.nextline;
            this.tableHTML = this.tableHTML + "<select name=\"listpage\" onChange=\"goPage(this.value)\" class=\"txt01\">" + this.nextline;
            for( int i = 1 ; i <= max_page ; i++ ){
            	this.tableHTML = this.tableHTML + "<option value=\"" + i + "\"" + (browse_page==i?"selected":"") + ">" + i + "</option>" + this.nextline;
            }
            this.tableHTML = this.tableHTML + "</select>" + this.nextline;
            this.tableHTML = this.tableHTML + (browse_page < 2?"<IMG SRC=\"../IMAGES/MYNOTE/FIRST.gif\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=\"0\" ALT=\"#\">":"<A HREF=\"JavaScript:goPage('1');\"><IMG SRC=\"../IMAGES/MYNOTE/FIRST.gif\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=\"0\" ALT=\"1\"></A>") + (browse_page < 2?"<IMG SRC=\"../IMAGES/MYNOTE/BACK.gif\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=\"0\" ALT=\"#\">":"<A HREF=\"JavaScript:goPage('"+(browse_page-1)+"');\"><IMG SRC=\"../IMAGES/MYNOTE/BACK.gif\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=\"0\" ALT=\""+(browse_page-1)+"\"></A>") + (browse_page == this.getMaxPage()?"<IMG SRC=\"../IMAGES/MYNOTE/NEXT.gif\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=\"0\" ALT=\"#\">":"<A HREF=\"JavaScript:goPage('"+(browse_page+1)+"');\"><IMG SRC=\"../IMAGES/MYNOTE/NEXT.gif\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=\"0\" ALT=\""+(browse_page+1)+"\"></A>") + (browse_page != this.getMaxPage()?"<A HREF=\"JavaScript:goPage('"+this.getMaxPage()+"');\"><IMG SRC=\"../IMAGES/MYNOTE/LAST.gif\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=\"0\" ALT=\""+this.getMaxPage()+"\"></A>":"<IMG SRC=\"../IMAGES/MYNOTE/LAST.gif\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=\"0\" ALT=\"#\")>") + this.nextline;
            //this.tableHTML = this.tableHTML + (browse_page < 2?"<img src=\"../IMAGES/MYNOTE/FIRST.gif\" width=\"14\" height=\"14\" border=\"0\" alt=\"\">":"<a href=\"JavaScript:goPage('1');\"><img src=\"../IMAGES/MYNOTE/FIRST.gif\" width=\"14\" height=\"14\" border=\"0\" alt=\"1\"></a>") + (browse_page < 2?"<img src=\"../IMAGES/MYNOTE/BACK.gif\" width=\"14\" height=\"14\" border=\"0\" alt=\"\">":"<a href=\"JavaScript:goPage('"+(browse_page-1)+"');\"><img src=\"../IMAGES/MYNOTE/BACK.gif\" width=\"14\" height=\"14\" border=\"0\" alt=\""+(browse_page-1)+"\"></A>") + (!(next_page)?"<IMG SRC=\"../IMAGES/MYNOTE/NEXT.gif\" width=\"14\" height=\"14\" border=\"0\" alt=\"\">":"<a href=\"JavaScript:goPage('"+(browse_page+1)+"');\"><img src=\"../IMAGES/MYNOTE/NEXT.gif\" width=\"14\" height=\"14\" border=\"0\" alt=\""+(browse_page+1)+"\"></a>") + (browse_page != max_page?"<a href=\"JavaScript:goPage('"+max_page+"');\"><img src=\"../IMAGES/MYNOTE/LAST.gif\" width=\"14\" height=\"14\" border=\"0\" alt=\""+max_page+"\"></a>":"<img src=\"../IMAGES/MYNOTE/LAST.gif\" width=\"14\" height=\"14\" border=\"0\" alt=\"\")>") + this.nextline;
            //this.tableHTML = this.tableHTML + (browse_page < 2?"<IMG SRC=\"../images/FIRST.gif\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=\"0\" ALT=\"#\">":"<A HREF=\"JavaScript:goPage('1');\"><IMG SRC=\"../images/FIRST.gif\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=\"0\" ALT=\"1\"></A>") + (browse_page < 2?"<IMG SRC=\"../images/BACK.gif\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=\"0\" ALT=\"#\">":"<A HREF=\"JavaScript:goPage('"+(browse_page-1)+"');\"><IMG SRC=\"../images/BACK.gif\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=\"0\" ALT=\""+(browse_page-1)+"\"></A>") + (!(next_page)?"<IMG SRC=\"../images/NEXT.gif\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=\"0\" ALT=\"#\">":"<A HREF=\"JavaScript:goPage('"+(browse_page+1)+"');\"><IMG SRC=\"../images/NEXT.gif\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=\"0\" ALT=\""+(browse_page+1)+"\"></A>") + (browse_page != max_page?"<A HREF=\"JavaScript:goPage('"+max_page+"');\"><IMG SRC=\"../images/LAST.gif\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=\"0\" ALT=\""+max_page+"\"></A>":"<IMG SRC=\"../images/LAST.gif\" WIDTH=\"14\" HEIGHT=\"14\" BORDER=\"0\" ALT=\"#\")>") + this.nextline;
            
            this.tableHTML = this.tableHTML + "</tr>" + this.nextline;
            
            this.tableHTML = this.tableHTML + "</table>";
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
    }
    /*** End method setMynoteTable() for Mynote (Print Help) ***/
    
    public String  getInput(String nameField){
    	try{
    		DbRecord rec = this.inq.getCurrentDbRecord();
    		rec.setProperties(true);
    		FieldManager fm= rec.getField(nameField);
    		fm.setHELP_RETURN_FIELD(true);
    		String backData = fm.getString();
    		fm.set(this.getValue(fm.getName()));
    		com.process((ComponentManager)fm);
    		fm.set(backData);
    		return com.getInput();
    		
    	}catch(Exception e){
    		MyLog.error(this, this.getUProfile(), e);
    		return "";
    	}
    }
    protected String getListTypeField(){    	
    	return "<input type=\"hidden\" name=\"__listtypefield\" value=\""+this.listTypeField+"\">";
    }

    protected void setPeriodRows(){
        if ((goPage == null) || (goPage == "")) {
            goPage = "0";
        }
        if(maxLine>0){
	        int beginRow=((Integer.parseInt(goPage)-1)*maxLine)+1;
	        int endRow=(Integer.parseInt(goPage))*maxLine;
	        inq.setBetween(beginRow, endRow);
	        inq.clearOldCondition();
        }
    }    

  /*  public void processForTagpageOnly() {
        try {
            this.setOrder();
            String inqFilter=this.inq.getFilter();
            this.inq.setFilter("");
            this.setSearch();
            if(inqFilter.trim().length()>0){
            	if(this.inq.getFilter().length()>0){
            		inqFilter+=" and "+this.inq.getFilter();
            	}
            	this.inq.setFilter(inqFilter);
            }

            if (this.stringSearch != null && !this.stringSearch.equals("")) {
                inq.setStringFilter(this.stringSearch);
            }
            if(this.param.get("securityoff")!=null && !this.param.get("securityoff").equals("")){
            	inq.setSecurityOff();
            }
            this.setPeriodRows();            
            this.countRec(this.inq);
            if (this.totalRec == 0) {
                this.totalRec++;
            }
        } catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
        }
    }
         
    public void process(boolean dorefresh){
    	if(dorefresh){
    		this.process();
    	}else{
    		this.processForTagpageOnly();
    	}
    }
    */
    
    @Override
    /***
     * óշ help ¡ method endjsp кзӡ close connection ͧ inquiry  ͧ child 
     * 
     */
    public String endJSP() { 
    	String data= super.endJSP();    	
    	inq.closeConnection();
    	inq.closeConnectionChild();
    	return data;
    }
    
}
