package com.csc.library.entry;
import java.rmi.RemoteException;
import java.util.HashMap;

import com.csc.library.components.ComponentManager;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.utilities.UProfile;


public interface UIManager extends ScreenManager {
	public UProfile getUProfile() throws RemoteException;
	public ComponentManager getComponent(String name) throws RemoteException;
	public void setChannel(HashMap param) throws RemoteException;
	public String getLabel(String nameFiled) throws RemoteException;
	public String getInput(String nameFiled) throws RemoteException;
	public void setSpace(int space) throws RemoteException;
	public String getLabel(String nameChild, String nameField) throws RemoteException;
	public String getDataLabel(String FieldName) throws RemoteException;
	public String getMessage() throws RemoteException;
	public void setMessage(String message) throws RemoteException;
	public DbRecord getRecord(String name) throws RemoteException;
	public void setRecord(DbRecord db) throws RemoteException;
	public DbTable getTable(String name) throws RemoteException;
	public MultiLine getMultiLine(String tableName) throws RemoteException;
	public String getDataLabel(String tableName,String nameField)throws RemoteException;
	public String getRequire() throws RemoteException;
	public String getTagConfirm() throws RemoteException;
	public void referLangOn() throws RemoteException;
	public void referLangOff() throws RemoteException;	
	public String getMessage(String message) throws RemoteException;	
	public String getDateLabel(String FieldName) throws RemoteException;
	public String getDateLabel(String tableName,String nameField)throws RemoteException;
	public String InitialVariable();
	public String endJSP();
	public void setInputType(String fieldName,String inputType)throws RemoteException;
	public void setProperties(String fieldName,String propName,String value)throws RemoteException;
	/**************/
	
	public String getEditCheck();
}
