package com.csc.library.session;

import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Vector;

import com.csc.library.database.MyHashMap;
import com.csc.library.utilities.UProfile;

public interface DbInquiry extends com.csc.library.database.ChildManager {
	public MyHashMap getGroupData();
	public void refresh() throws RemoteException;
	public void refreshNextDB() throws RemoteException;
	public boolean next() throws RemoteException;
	public void previous() throws RemoteException;
	public boolean go(int recno) throws RemoteException;
	public void first() throws RemoteException;
	public int recCount() throws RemoteException;
	public int recCount(String sql) throws RemoteException;
	public int recNo() throws RemoteException;
	public boolean isFirst() throws RemoteException;
	public boolean isLast() throws RemoteException;
	public boolean setColumn(String columnList) throws RemoteException;
	public boolean setColumn(Vector columnList) throws RemoteException;
	public boolean foundData() throws RemoteException;
	public boolean changed(String fieldName) throws RemoteException;
	public void print() throws RemoteException;
	public void printList() throws RemoteException;
	public String getString(String fieldName) throws RemoteException;
	public String getString(String tableName, String fieldName) throws RemoteException;
	public String getOldString(String fieldName) throws RemoteException;
	public void setFilter(String s) throws RemoteException;
	public String getFilter() throws RemoteException;
	public void setOrderBy(String o) throws RemoteException;
	public String getOrderBy() throws RemoteException;
	public String getTableName() throws RemoteException;
	public String getActualName() throws RemoteException;
	public void setTableName(String name) throws RemoteException;
	public void setActualName(String name) throws RemoteException;
	public void initMyTable(String className, String filter, String order) throws RemoteException;
	public void setPropDB(String comp, String user, String pwd) throws RemoteException;
	public void setAllRequiredFound(boolean require) throws RemoteException;
	public DbRecord getCurrentDbRecord() throws RemoteException;
	public void setAllUProfile(UProfile uPro) throws RemoteException;
	public void setDataSource(String DSname) throws RemoteException;
	public void setSchemaName(String SCHEMA_NAME) throws RemoteException;
	public String getSchemaName() throws RemoteException;
	public void referLangOff() throws RemoteException;
	public void referLangOn() throws RemoteException;
	public boolean set(String fname, String value) throws RemoteException;
	public void setParam(HashMap param) throws RemoteException;
	public HashMap getParam() throws RemoteException;
	public void setParam(String key, String value) throws RemoteException;
	public String getParam(String key) throws RemoteException;
	public MyHashMap getDataSet(String filter) throws RemoteException;
	public void setFilter(String fieldName, String data) throws RemoteException;
	public void closeConnection();
	public void closeConnectionChild();
	public void setGroupfield(String gField) throws RemoteException;
	public HashMap getGroupField() throws RemoteException;
	public void setResultSet(String rs) throws RemoteException;
	public void setStringFilter(String stringFilter) throws RemoteException;
	public void setFatchAll(boolean fetchAll) throws RemoteException;
	public String getType() throws RemoteException;
	public void setRecReport(DbRecord rec) throws RemoteException;
	public void appendSql(String cmd, String statement) throws RemoteException;
	public void setSimColumn(String columnName, String tableName, String simName, String groupby, String having, String tableRelate, String whereCond) throws RemoteException;
	public void formatOn(); 
	public void formatOff();
	public void setSecurityOn();
	public void setSecurityOff();
	public boolean childNext(String tableName);
	public boolean isFieldChange(String fieldName);
	public void setFetchAll(boolean fetchall);
	public boolean isSameCondition();
	public void setGroupBy(String o) throws RemoteException;
	public String getGroupBy();
	public void setSumColumn(String o) throws RemoteException;
	public String getSumColumn();
	public void setMinColumn(String o) throws RemoteException;
	public String getMinColumn();
	public void setMaxColumn(String o) throws RemoteException;
	public String getMaxColumn() ;
	public void setAVGColumn(String o) throws RemoteException;
	public String getAVGColumn();
	public void setUDFColumn(String o) throws RemoteException;
	public String getUDFColumn();
	public void printGroupDataProcess();
	public Object calculate(String FieldName, Object oldValue);
	
	public String getSimString(String field);
	public String getFixFilter()throws RemoteException;
	public void setFixFilter(String fixFilter)throws RemoteException ;
	public void setVerifyOff();
	//public String getDataHTML(String fieldName);
	public String getStringHTML(String fieldName);
	public void clearOldCondition();
	public String getDataFormat(String fieldName);
	public MyHashMap getMyHashMap();
	public void setFilter(String fieldName, String value,String value2,String operate);
	public void clearSubFilter();
	// join table
	public void isJoinTable(boolean jointab);
	public void setGroupJoin(String group);
	public void setOrderJoin(String order);
	public void setFilterJoin(String filter);
	public void setBetween(int begin, int end) ;
	public String getDbType();
	/****
	 * test getField(int)
	 */
//	public String getString(int index) throws RemoteException;
	
	//create by pas  trace object
	
	public boolean isRefreshBeforeNext(); //óբͧ helpentry Ҽҹmethod process ѧ ѧҹǨset true 㹨ѧ next refresh  ͹ refresh 

	public void setRefreshBeforeNext(boolean preRefresh);//óբͧ helpentry Ҽҹmethod process ѧ ѧҹǨset true 㹨ѧ next refresh  ͹ refresh 
}
