package com.csc.library.session;

import java.lang.reflect.Method;

import javax.naming.Context;

import com.csc.library.utilities.MyLog;

/**
 * @author Architecture
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class InitialEntry {
	private Context ctx = null;
	private Object entry = null;
	private Object home;

	public InitialEntry() {}

	public Object getEntry(String entryName) {
		try {
			entry = Class.forName("com.csc.library.entry." + entryName).newInstance();
		} catch (InstantiationException e) {	MyLog.error(this, e);
		} catch (IllegalAccessException e) {MyLog.error(this, e);
		} catch (ClassNotFoundException e) {	MyLog.error(this, e);
		}
		return this.entry;
	}

	/*	public Object getEntry(String entryName) {
			try {
				entry = Class.forName("com.csc.library.entry."+entryName).newInstance();
			} catch (Exception e) {
				e.printStackTrace();
			}
			return this.entry;
		}
	*/

	private Object invokeRemote(String entryName) throws Exception {
		ctx = new MyContext().getInitialContext();
		//home = ctx.lookup(entryName);
		home = ctx.lookup("ejb/entry/" + entryName);
		Class c = home.getClass();
		Method mx = c.getDeclaredMethod("create", new Class[] {});
		return mx.invoke(home, new Object[] {});
	}
}
