package com.csc.library.utilities;
import java.io.File;
import java.util.HashMap;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.jsp.PageContext;

import com.csc.library.session.InitialEnvironment;
/**
 * @author Administrator
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class CscBrowseFile {
    private HashMap result = new HashMap();
    private String helpReturn = "";
    private String path = "";
    private String realPath = "";
    private int limitPage = 10;
    private int pageCount = 0;
    private CscBrowser cBrowse = null;
    private int orderBy = 1;
    private String searchBy = "";
    
    public CscBrowseFile() {
    	super();
    }
    public void setChannel(PageContext page, HttpServletRequest request, HttpServletResponse res) throws Exception {
        //this.setRealPath(page.getServletContext().getRealPath("/"));
		InitialEnvironment en = new InitialEnvironment("GLOBAL");
		this.setRealPath(en.getValue("payroll_upload-dir"));
        String tmp = "";
        tmp = request.getParameter("__path");
        if (tmp != null && !tmp.equals(""))
            this.setPath(tmp);
        else
            return;
        tmp = request.getParameter("__helpReturn");
        if (tmp != null && !tmp.equals(""))
            this.setHelpReturn(tmp);
        tmp = request.getParameter("__orderBy");
        if (tmp != null && !tmp.equals(""))
            this.setOrderBy(Integer.parseInt(tmp));
        tmp = request.getParameter("__searchBy");
        if (tmp != null && !tmp.equals(""))
            this.setSearchBy(tmp);
        tmp = request.getParameter("__limit_page");
        if (tmp != null && !tmp.equals(""))
            this.setLimitPage(Integer.parseInt(tmp));
        this.cBrowse = new CscBrowser(this.getRealPath() + this.getPath());
        this.getCBrowse().setOrderBy(this.getOrderBy());
    }
    public void process() {
        int count = 0;
        while (this.getCBrowse().nextFile()) {
            String tmp = "";
            for (int i = 0; i < this.getLimitPage(); i++) {
                String fileName = this.getCBrowse().getFileName();
                tmp += "<TR><TD  class=\"forborder\" WIDTH=\"0%\" HEIGHT=\"0%\" ><A HREF=\"javascript:backPage_Return('" + helpReturn + "#" + fileName + "');\">" + fileName + "</A></TD>";
                tmp += "<TD class=\"forborder\" WIDTH=\"0%\" HEIGHT=\"0%\" >" + this.getCBrowse().getFileSize() + "</TD>";
                tmp += "<TD class=\"forborder\" WIDTH=\"0%\" HEIGHT=\"0%\" >" + this.getCBrowse().getFileModify() + "</TD>";
                tmp += "<TD class=\"forborder\" WIDTH=\"0%\" HEIGHT=\"0%\" >" + this.getCBrowse().getMimeType() + "</TD></TR>";
                if(this.getCBrowse().nextFile()==false)
                    break;
            }
            this.putResult(String.valueOf(++count), tmp);
        }
        this.setPageCount();
    }
    public String getOrderTag() {
        String tag = "<SELECT NAME='__listOrder' onChange=\"javascript:setOrderby();\" selected=\"" + this.getOrderBy() + "\">";
        tag += "<OPTION  VALUE=\"1\"" + ((this.getOrderBy() == 1) ? "selected" : "") + ">File Name</OPTION>";
        tag += "<OPTION  VALUE=\"2\"" + ((this.getOrderBy() == 2) ? "selected" : "") + ")>Size</OPTION>";
        tag += "<OPTION  VALUE=\"3\"" + ((this.getOrderBy() == 3) ? "selected" : "") + ">Date</OPTION>";
        tag += "<OPTION  VALUE=\"4\"" + ((this.getOrderBy() == 4) ? "selected" : "") + ">Type</OPTION>";
        tag += "</SELECT>";
        return tag;
    }
    public String getPageTag() {
        String tag = "<div align=\"right\">&lt;";
        int pageCount = this.getPageCount();
        for (int i = 1; i <= pageCount; i++) {
            if(i==pageCount)
                tag += "<a href=\"#\" onclick=\"javascript:go(" + i + ")\">" + i + "</a>";
            else
                tag += "<a href=\"#\" onclick=\"javascript:go(" + i + ")\">" + i + "</a>&nbsp;";
        }
        tag += "&gt;</div>";
        return tag;
    }
    protected int getPageCount() {
        return this.pageCount;
    }
    protected void setPageCount() {
        Iterator it = this.result.entrySet().iterator();
        int count = 0;
        while (it.hasNext()) {
            it.next();
            count++;
        }
        this.pageCount = count;
    }
    public String getBrowseFiletag(Object page) {
        if (this.getResult().containsKey(page)) {
            String result = (String) this.getResult().get(page);
            if (result == null)
                return "";
            else
                return result;
        } else {
            return "";
        }
    }
    /**
     * Returns the cBrowse.
     * @return CscBrowser
     */
    protected CscBrowser getCBrowse() {
        return cBrowse;
    }
    /**
     * Returns the helpReturn.
     * @return String
     */
    protected String getHelpReturn() {
        return helpReturn;
    }
    /**
     * Returns the orderBy.
     * @return int
     */
    protected int getOrderBy() {
        return orderBy;
    }
    /**
     * Returns the result.
     * @return HashMap
     */
    protected HashMap getResult() {
        return result;
    }
    /**
     * Sets the cBrowse.
     * @param cBrowse The cBrowse to set
     */
    protected void setCBrowse(CscBrowser cBrowse) {
        this.cBrowse = cBrowse;
    }
    /**
     * Sets the helpReturn.
     * @param helpReturn The helpReturn to set
     */
    protected void setHelpReturn(String helpReturn) {
        this.helpReturn = helpReturn;
    }
    /**
     * Sets the orderBy.
     * @param orderBy The orderBy to set
     */
    protected void setOrderBy(int orderBy) {
        this.orderBy = orderBy;
    }
    /**
     * Put value to the result.
     * @param result The result to set
     */
    protected void putResult(Object key, Object value) {
        this.result.put(key, value);
    }
    /**
     * Returns the path.
     * @return String
     */
    protected String getPath() {
        return path;
    }
    /**
     * Returns the realPath.
     * @return String
     */
    protected String getRealPath() {
        return realPath;
    }
    /**
     * Sets the path.
     * @param path The path to set
     */
    protected void setPath(String path) {
        this.path = path;
    }
    /**
     * Sets the realPath.
     * @param realPath The realPath to set
     */
    protected void setRealPath(String realPath) {
        this.realPath = realPath;
    }
    /**
     * Returns the limitPage.
     * @return int
     */
    protected int getLimitPage() {
        return limitPage;
    }
    /**
     * Sets the limitPage.
     * @param limitPage The limitPage to set
     */
    protected void setLimitPage(int limitPage) {
        this.limitPage = limitPage;
    }
    /**
     * Returns the searchBy.
     * @return String
     */
    public String getSearchBy() {
        return searchBy;
    }
    /**
     * Sets the searchBy.
     * @param searchBy The searchBy to set
     */
    public void setSearchBy(String searchBy) {
        this.searchBy = searchBy;
    }
    /**
    * Returns the searchBy.
    * @return String
    */
    public String getSearchByTag() {
        return searchBy;
    }
    
    /**
     * Ǩͺ
     * @author James
     * @param filename ͧõǨͺ
     * @return šõǨͺ, true ; false 
     */
    public static boolean checkFile(String filename ){
		boolean chk = false;
		File file = new File( filename );
		if( file.exists() && file.isFile() ){
			chk = true;
		}
		return chk;
	}
    
    /**
     * Ǩͺ
     * @author James
     * @param path  path ͧõǨͺ
     * @param filename ͧõǨͺ
     * @return šõǨͺ, true ; false 
     */
    public static boolean checkFile(String path, String filename ){
		boolean chk = false;
		File file = new File( path, filename );
		if( file.exists() && file.isFile() ){
			chk = true;
		}
		return chk;
	}
    
    public static void main(String[] args) {

	}
}
