package com.csc.library.utilities;

import java.rmi.RemoteException;
import java.text.DecimalFormat;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Properties;
import java.util.Vector;

import com.csc.library.database.MyHashMap;
import com.csc.library.database.SystemCode;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialEnvironment;

/**
 * Cls 㹡ҧ͡ rtf ¹Ңк
 * 任͡ template ҧ
 * @author @SoCooL@
 */
public class MailMerge {
	private String				data;
	private String				beginTag;
	private String				endTag;
	private String				replcTag;
	private Vector				vAddr			= new Vector();
	private Vector				vToken			= new Vector();
	private String				headData;
	private String				tailData;
	private String				resultData;
	private String				sourceFile		= "";
	private String				fileName		= "";
	private String				pathName		= "";
	private String				mmPath			= new InitialEnvironment("GLOBAL").getValue("payroll_upload-dir");
	private String				mmXmlName		= "";
	private MailMergeXml		mmXml			= null;
	private DbInquiry			dbInq;
	private UProfile				up=null;
	private HashMap				param			= null;
	private MyHashMap			variable		= new MyHashMap(true);
	private Properties			filter;
	private boolean				fetchAllFlag	= false;
	private String				reportid		= "";
	protected String getReportid() {
		return reportid;
	}
	protected void setReportid(String reportid) {
		this.reportid = reportid;
	}
	/**
	 * <PRE>
	 * Constructor ա init 㹡ҹ
	 * MailMerge  beginTag , endTag
	 * ͧ¡ҹʹ 
	 * 	- public void setCondition(HashMap condition)
	 * - protected boolean initValue()
	 * ͹¡ҹʹ 
	 *  - public boolean process()
	 *  Cls MailMerge ӧҹ 
	 * </PRE>
	 */
	public MailMerge() {
		data = "";
		beginTag = "<<";// begin tag in template
		endTag = ">>";//end tag intemplate
		replcTag = "[000]";
	}
	/**
	 * <PRE>
	 * Constructor 觤㹡ҹ
	 * MailMerge  beginTag , endTag
	 * ͧ¡ҹʹ 
	 * 	- public void setCondition(HashMap condition)
	 * - protected boolean initValue()
	 * ͹¡ҹʹ 
	 *  - public boolean process()
	 *  Cls MailMerge ӧҹ 
	 * </PRE>
	 *  @param beginT  ش tag ͡ Template ҹҧ
	 *  @param endT  شش tax ͡ Template ҹҧ
	 * */
	public MailMerge(String beginT, String endT) {
		data = "";
		beginTag = beginT;
		endTag = endT;
		replcTag = "[000]";
	}
	/**
	 * ʹ㹡 out put Ѿ
	 * @return String path
	 */
	private String getPath() {
		return new InitialEnvironment("GLOBAL").getValue("temp-dir");
	}
	/**
	 * ʹ㹡絤͹䢷ѺҨҡ˹Ҩ
	 * @param condition
	 */
	public void setCondition(HashMap condition) {
		this.param = condition;
	}
	/**
	 * <PRE>
	 * ʹ㹡ô֧ҵ˹觢ͧش tag
	 * </PRE>
	 * @param point  ˹ tag ͧ
	 * @return int ش tag ˹觷ͧ
	 */
	protected int getAddr(int point) {
		return ((Integer) vAddr.get(point)).intValue();
	}
	/**
	 * ʹ֧Ҩӹǹ tag  template
	 * @return int ӹǹ tag 
	 */
	protected int getAddrSize() {
		return vAddr.size();
	}
	/**
	 * ʹ֧Ңŷ tag ͧ
	 * @param point  ˹ tag ͧ
	 * @return String  tag
	 */
	protected String getToken(int point) {
		return (String) vToken.get(point);
	}
	/**
	 * ʹ֧Ǣͧ͡ rtf (Template)
	 * @return String ͡ rtf
	 */
	protected String getHeadData() {
		return this.headData;
	}
	/**
	 * ʹ֧ҢŢͧ͡ rtf (Template)
	 * @return String ͡ rtf
	 */
	protected String getData() {
		return this.data;
	}
	/**
	 * <PRE>
	 * Ǩͺ͡ template ҧ
	 * tag йӢŷк任 template 
	 *  tag  <<field1>> л [0001] 
	 * ѭѡɳ͹зӡûżŤ xml ͹
	 * зӡТŷӹǹ template
	 * </PRE>
	 */
	private void scanToken() {
		String tmp2 = "", tmp3 = "", tmpStr = "";
		int count = 0, index = 0;
		boolean chk = true;
		try {
			FileString fs = new FileString();
			for (int i = 0; i < this.data.length() - beginTag.length(); i++) {
				tmp2 = this.data.substring(i, i + beginTag.length());
				if (tmp2.equals(beginTag)) { //begin start tag
					vAddr.add(new Integer(i));
					count = i + beginTag.length();
					tmp3 = "";
					//logger.info("i="+i+" tmp2="+tmp2);
					chk = true;
					while (chk) {
						tmp3 += this.data.charAt(count);
						tmpStr = this.data.substring(count, count + endTag.length());
						if (tmpStr.equals(endTag) || count > this.data.length()) {
							chk = false;
						}
						count++;
					}
					tmpStr = tmp3.substring(0, tmp3.length() - 1);
					vToken.add(tmpStr);
					fs.setData(this.data);
					this.data = fs.cutAndReplc(i, tmpStr.length() + beginTag.length() + endTag.length(), "[" + fs.addBlank(3, "0", index) + "]");
					index++;
				}
			}
			//new WriteFile("c:/mailmergetemplate.rtf", this.headData + data + this.tailData);
		} catch (Exception e) {
			MyLog.error(this, this.up, e);
		}
	}
	/**
	 * ¡ rtf ͡
	 * ǹ ǹ ǹ
	 * @return boolean  flag success
	 */
	protected boolean setData() {
		FileString fs = new FileString();
		fs.setDataFile(this.getSourceFile());
		if (fs.getData() == null || fs.getData().equalsIgnoreCase("")) {
			MyLog.error(this, getUp(),"!!!!!!!!!!!!!!!!!!!!!!! Data in file Is null Or blank Value !!!!!!!!!!!!!!!!!!!!!!");
			return false;
		} else {   
			//start of rtf is \aftnnrlc
			//String tmpHead = fs.getTag("{" + "\\" + "rtf1", "\\" + "aftnnrlc");
			String tmpHead = fs.getTag("{" + "\\" + "rtf1", "\\" + "ansi");
			headData = tmpHead;
			fs.delString(tmpHead);
			// close of rtf is \par }
			tailData = "\\" + "par }";
			fs.delString(tailData);
			this.data = fs.getData();
			return true;
		}
	}
	/**
	 * <PRE>
	 * ʹ㹡õǨͺ ҡ parameter  
	 * </PRE> 
	 * @param param  parameter ҡ˹Ҩ
	 * @return boolean  flag success
	 */
	protected boolean checkValue(HashMap param) {
		String fileName = param.get("outfile").toString().trim();
		String pathName = param.get("outpath").toString().trim();
		String sourceFile = param.get("sourcefile").toString().trim();
		if (param.containsKey("mailmergexml")) {
			this.mmXmlName = param.get("mailmergexml").toString().trim();
		}
		if (fileName == null || fileName.equalsIgnoreCase("")) {
			MyLog.error(this, getUp(),"!!!!!!!!!!!!!!!!!!!!!!!File name is null or blank value!!!!!!!!!!!!!!!!!!!!!!!");
			return false;
		}
		if (pathName == null || pathName.equalsIgnoreCase("")) {
			MyLog.error(this, getUp(),"!!!!!!!!!!!!!!!!!!!!!!!Path name is null or blank value!!!!!!!!!!!!!!!!!!!!!!!");
			return false;
		}
		if (sourceFile == null || sourceFile.equalsIgnoreCase("")) {
			MyLog.error(this, getUp(),"!!!!!!!!!!!!!!!!!!!!!!!Source File name (RTF) is null or blank value!!!!!!!!!!!!!!!!!!!!!!!");
			return false;
		}
		this.setFileName(fileName);
		this.setPathName(pathName);
		this.setSourceFile(sourceFile);
		return true;
	}
	/**
	 * ʹõǨͺ͹
	 * @return boolean  flag success 
	 * */
	private boolean setFetchAllCondition(MailMergeXml mXml, DbInquiry inq) {
		try {
			String fetchall = mXml.getRootAttibute("fetchall");
			if (fetchall != null && !fetchall.equals("")) {
				if (fetchall.equals("true")) {
					this.setFetchAllFlag(true);
				} else if (fetchall.equals("false")) {
					this.setFetchAllFlag(false);
				}
				return true;
			}
			String inquiryFilter = inq.getFilter();
			MyLog.debug(this, getUp(),"=========== INQUIRY FILTER IS:" + inquiryFilter + "===========");
			if (fetchall.equalsIgnoreCase("true") || (inquiryFilter == null || inquiryFilter.equals(""))) {
				this.setFetchAllFlag(true);
			} else {
				this.setFetchAllFlag(false);
			}
			return true;
		} catch (RemoteException e) {
			MyLog.error(this, this.up, e);
			return false;
		}
	}
	/**
	 * <PRE>
	 * ʹ㹡 init   
	 * Path ͧ write ͡ 
	 * DbInquiry ¨йӤҨҡ parameter
	 * ҡ˹Ҩͷӡ絤 init 
	 * </PRE>
	 * @param fileName  зӡ generate ͡
	 * @return boolean  flag success
	 */
	private boolean initValue(String fileName) {

		this.fetchVariableValue(this.getParam());
		this.up = (UProfile) this.getParam().get("UPROFILE");
		this.filter = (Properties) this.getParam().get("FILTER");
		this.setDataMerge((String) this.getParam().get("SCREEN"));
		
		
		this.param.put("sourcefile", this.getMmPath() + "MAILMERGE//FILE//" + (String) this.getParam().get("TEMPLATE"));
		this.param.put("mailmergexml", this.getMmPath() + "MAILMERGE//XML//" + this.getMmXmlName());
		this.param.put("outfile", fileName); 
		// Nu ball edit 11-10-48
	//	this.param.put("outpath", this.getMmPath() + "MAILMERGE//OUTPUT//");
		this.param.put("outpath",this.getExportPath());
		/************/
		
		
		this.setFetchAllCondition(this.getMmXml(), this.getDbInq());
		if (this.checkValue(this.param) == false)
			return false;
		MyLog.debug(this, getUp(),"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Filter is:" + this.filter + "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
		return true;
	}
	/**
	 * <PRE>
	 * ʹ Init ·ӡ絤 MailMerge XML ͹ 
	 * ҡ鹨еǨͺ MailMerge Xml աкت
	 *  աк Ҥ reportid 繪
	 * </PRE>
	 * @return
	 */
	protected boolean initValue() {
		MyLog.info(this, getUp(),"============= Param Before Process Is:" + this.getParam() + "=============");
		if (!this.setMailMergeXml(this.getParam()))
			return false;
		String fileName = this.getMmXml().getRoot().getAttributeValue("filename");
		if (fileName == null || fileName.equals("")) {
			fileName = this.getReportid();
		}
		return this.initValue(fileName);
	}
	/**
	 * ʹ絤 MailMergeXml ҡ parameter  (parameter key MMXML)
	 * @param param  parameter ҡ˹Ҩ
	 * @return boolean  flag success
	 */
	private boolean setMailMergeXml(HashMap param) {
		String name = (String) this.getParam().get("MMXML");
		if ((name == null) || (name.equals(""))) {
			return false;
		} else {
			this.setMmXmlName(name);
			this.setMmXml(new MailMergeXml(this.getMmPath() + "//MAILMERGE//XML//" + this.getMmXmlName()));
			return true;
		}
	}
	/**
	 * <PRE>
	 * ʹ㹡 fetch  parameter Ҩҡ˹Ҩ
	 * ͻС environment ͧ DynamicJava 
	 * ö¡÷ͧèҡ mailmerge xml 
	 * </PRE>
	 * @param param  parameter 觤
	 */
	private void fetchVariableValue(HashMap param) {
		Iterator it = param.keySet().iterator();
		String id = "";
		while (it.hasNext()) {
			id = (String) it.next();
			if (id.indexOf("$MM$") == 0) {
				this.addVariable(id.substring(4, id.length()), param.get(id));
			}
		}
	}
	/**
	 * <PRE>
	 * ʹ㹡絤ٻẺͧ String ѧҡ
	 * ӡ Interpret String ҹ DynamicJava
	 * </PRE>
	 * @param key  Ҥͧ Tag Data  MailMergeXml ֧ format ͧ tag ͧ
	 * @param token  String ҹ interpret 
	 * */
	private String setTokenFormat(String key, String token) {
		String tokenResult = "", blank = "", align = "";
		int digit = 0, formated = -1, count = 0;
		if (this.mmXml.containAttribute(key, "thaiCur")) {
			String tcur = this.mmXml.getStringAttribute(key, "thaiCur");
			if (tcur.equalsIgnoreCase("true")) {
				CurrencyToThai curr = new CurrencyToThai();
				ThaiUtilities thaiUtil = new ThaiUtilities();
				token = thaiUtil.ASCII2Unicode(curr.getString(token));
			}
		}
		if (this.mmXml.containAttribute(key, "size")) {
			digit = this.mmXml.getIntegerAttribute(key, "size");
			formated = 0;
			count = 1;
		}
		if (this.mmXml.containAttribute(key, "blank")) {
			blank = this.mmXml.getStringAttribute(key, "blank");
			formated = 1;
			if (this.mmXml.containAttribute(key, "align")) {
				align = this.mmXml.getStringAttribute(key, "align");
				formated = 2;
				count = 3;
			}
		}
		if (count == 3) {
			tokenResult = new FileString().addBlank(digit, blank, align, token);
		} else if (count == 1) {
			if (token.length() > digit) {
				token = token.substring(0, digit);
			}
		}
		if (this.mmXml.containAttribute(key, "char") && (token != null) && (!token.equals(""))) {
			try {
				if (formated > -1) // if formated token then
					return String.valueOf(tokenResult.charAt(this.mmXml.getIntegerAttribute(key, "char")));
				else
					return String.valueOf(token.charAt(this.mmXml.getIntegerAttribute(key, "char")));
			} catch (Exception e) {
				MyLog.error(this, this.up, e);
				return "";
			}
		} else
			return token;
	}
	/**
	 * Main of process MailMerge
	 *  xmlfile is xml file for initial inquiry
	 *  filesource is rft fie for process
	 *  outputfile is name of file to output
	 *  outputpath is path of file to output
	 * 
	 * Algorithm
	 *	while(not eof (inq)){
	 *	     StringBuffer.put(BodyData);
	 *	     while(not eof (token)){
	 *	             process dynamic java
	 *	             save String after process to  data
	 *	             next token
	 *	      }
	 *	      write data from  StringBuffer to OutputFile
	 *	      next record
	 *	   }
	 * @param param  parameter 㹡 process (ҡ˹Ҩ)
	 * */
	protected boolean process(HashMap param) {
		if (param.isEmpty()) {
			return false;
		} else {
			if (this.setData() == false) {
				return false;
			} else {
				this.scanToken();
				try {
					ThaiUtilities thaiUtil = new ThaiUtilities();
					String fact = "fact1", output = "";
		        /*	System.out.println("---------------param----------------------");
		        	
		        	System.out.println(param);
		        	System.out.println("---------------param----------------------");
		        	this.setDataMerge((String) this.getParam().get("SCREEN"));
		        	System.out.println("---------------this.getDbInq().getParam()----------------------");		        	
		        	System.out.println(this.getDbInq().getParam());
		        	System.out.println("---------------this.getDbInq().getParam()----------------------");	     */   	
					DynamicJava dj = this.getDynamicJava(this.getDbInq());
					dj.interpret(this.mmXml.getInitTag(), fact);
					//logger.info("Variable in Dynamic Java is:[" + dj.getVariableNames() + "]");					
					if (this.isFetchAllFlag()) {
						while (this.dbInq.next()) {
							dj.interpret(this.mmXml.getText("INTERPRET"), fact);
						}
						output = this.headData + this.processing(dj, fact) + this.tailData;
					} else {
						String result = "";
						while (this.dbInq.next()) {
							dj.interpret(this.mmXml.getText("INTERPRET"), fact);
							result += this.processing(dj, fact);
						}
						output = this.headData + result + this.tailData;
					}
					this.writeData(output);
					return true;
				} catch (Exception e) {
					MyLog.error(this, this.up, e);
					return false;
				}
			}
		}
	}
	/**
	 * ʹ㹡 interpret String
	 * @param dj  DynamicJava 㹡 interpret String
	 * @param fact  Factory  DynamicJava
	 * @return String Ѿҡûż
	 */
	private String processing(DynamicJava dj, String fact) {
		int i = 0, tmpAddr = 0;
		Integer tmpInt;
		String tmpResult = this.getData(), tokenValue = "", replcStr = "";
		FileString fs = new FileString();
		Vector tmpVec = (Vector) this.getVAddr().clone();
		while (i < this.vToken.size()) {
			String key = (String) this.vToken.get(i);
			MyLog.info(this, getUp(),"[ Key in Tag is:" + key + "]");
			if (this.mmXml.containKey(key)) {
				tokenValue = this.mmXml.getText(key);
			}
			if (tokenValue == null || tokenValue.equals("")) {
				replcStr = "";
			} else {
				if (this.mmXml.containAttribute(key, "method")) {
					String method = this.mmXml.getStringAttribute(key, "method");
					if (method.equals("getString")) {
						dj.interpret("replcStr = dbInq." + method + "(" + tokenValue + ");", fact);
					} else if (method.equalsIgnoreCase("data") || method.equalsIgnoreCase("variable")) {
						dj.interpret("replcStr=String.valueOf(" + tokenValue + ");", fact);
					} else {
						MyLog.error(this, getUp(),"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Not found Method:" + method + " for Process !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
						i++;
						continue;
					}
				} else { // not found attribute method
					MyLog.warn(this, getUp(),"!!!!!!!!!!!!!!!!!!!! Not found Attibute Method !!!!!!!!!!!!!!!!!!!!");
					//dj.interpret("replcStr = String.valueOf(" + tokenValue + ");", fact);
				}
				replcStr = String.valueOf(dj.getVariable("replcStr"));
				replcStr = this.setTokenFormat(key, replcStr);
			}
			MyLog.info(this, getUp(),"[ Result is:" + replcStr + "]");
			fs.setData(tmpResult);
			tmpInt = (Integer) tmpVec.get(i);
			tmpResult = fs.cutAndReplc(tmpInt.intValue(), this.replcTag.length(), replcStr);
			if (i < (this.vToken.size() - 1)) { // move addres in vector addr
				for (int j = i + 1; j < tmpVec.size(); j++) {
					tmpInt = (Integer) tmpVec.get(j);
					tmpAddr = tmpInt.intValue() + replcStr.length() - replcTag.length();
					tmpVec.setElementAt(new Integer(tmpAddr), j);
				}
			}
			i++;
		}
		//result += thaiUtil.ASCII2Unicode(tmpResult);
		return tmpResult;
	}
	/**
	 * <PRE>
	 * ʹ㹡ô֧ environment 㹡
	 * Interpret string ҡ mailmerge xml ͹
	 * ͡ template ҧ
	 * </PRE>
	 * @param inq   DbInquiry 㹡 interpret string
	 * @return DynamicJava  Interpret String
	 */
	private DynamicJava getDynamicJava(DbInquiry inq) {
		DynamicJava dj = new DynamicJava();

		dj.defineVariable("dbInq", (MmInquiry) this.getDbInq());
		dj.defineVariable("nFormat", new DecimalFormat());
		dj.defineVariable("calendar", new CscCalendar());
		dj.defineVariable("thaiCurr", new CurrencyToThai());
		dj.defineVariable("engCurr", new CurrencyToEng());
		dj.defineVariable("thaiUtil", new ThaiUtilities());
		dj.defineVariable("variable", this.getVariable());
		dj.defineVariable("code", SystemCode.getContent("MAILMERGE"));
		dj.defineVariable("fs", new FileString());
		dj.defineVariable("replcStr", "");
		dj.defineVariable("param", this.getParam());
		dj.defineVariable("fetchAll", this.isFetchAllFlag());
		return dj;
	}
	/**
	 * <PRE>
	 * ʹ Cls MailMerge ӧҹ
	 * ¨зӡ Init  ǡ xml 
	 * ҡ parameter Ҩҡ˹Ҩ
	 * ҡ鹨֧ process 
	 * </PRE>
	 * @return boolean flag success
	 */
	public boolean process() {
		this.initValue();
		return this.process(this.param);
	}
	/**
	 * <PRE>
	 * ʹ process ͧѺ  process ҹ Class ReportService
	 *  ReportEntry  reportid 
	 * </PRE>
	 * @param reportid   report id Ҩҡ Class ReportService
	 * @return boolean flag success
	 */
	public boolean process(String reportid) {
		this.setReportid(reportid);
		this.initValue();
		return this.process(this.param);
	}
	/**
	 * <PRE>
	 * ʹ㹡 init  DbInquiry ҹ Cls
	 *  DBXML 
	 *  </PRE>
	 * @param dbXml   dbxml
	 * @return boolean  flag sucess
	 */
	//DbXml(UProfile upf, String objName, String comcode, String user, String password, HashMap param)
	protected boolean setDataMerge(String dbXml) {
		try {
			if (this.up == null)
				return false;
			DbXml dbxml = new DbXml(this.up, dbXml, "", "", "",this.param);
			DbInquiry inq = dbxml.getInquiry();
			if(this.filter != null)
				this.setInquiryFilter(inq);
			inq.refresh();
			this.setDataMerge(inq);
			return true;
		} catch (Exception e) {
			MyLog.error(this, this.up, e);
			return false;
		}
	}
	/**
	 * <PRE>
	 * ʹ㹡 init  DbInquiry ҹ Cls
	 *  DBXML 
	 *  </PRE>
	 * @param dbXml   dbxml
	 * @param filter   ͧѺ DbInquiry
	 * @return boolean  flag sucess
	 */
	protected boolean setDataMerge(String dbXml, String filter) {
		try {
			if (this.up == null)
				return false;
			DbXml dbxml = new DbXml(this.up, dbXml, "", "", "",this.param);
			DbInquiry inq = dbxml.getInquiry();
			inq.setFilter(filter);
			this.setInquiryFilter(inq);
			inq.refresh();
			this.setDataMerge(inq);
			return true;
		} catch (Exception e) {
			MyLog.error(this, this.up, e);
			return false;
		}
	}
	/**
	 * <PRE>
	 * ʹ㹡 init  DbInquiry ҹ Cls
	 *  </PRE>
	 * @param inq  DbInquiry ͧ絤
	 */
	protected void setDataMerge(DbInquiry inq) {
		this.dbInq = inq;
	}
	private boolean setFileName(String str) {
		if (str.equals("") || str == null) {
			return false;
		} else {
			if (str.indexOf(".rtf") > 0) {
				this.fileName = str;
			} else {
				this.fileName = str + ".rtf";
			}
			return true;
		}
	}
	/**
	 * ʹ㹡 write ŧ rtf
	 * @param data  ŷͧè write
	 **/
	private boolean writeData(String data) {
		if (data == null || data.equalsIgnoreCase("")) {
			return false;
		} else {
			WriteFile wf = new WriteFile();
			wf.setFileName(this.getFileName());
			wf.setPathName(this.getPathName());
			wf.writeString(data);
			wf.closeFile();
			return true;
		}
	}
	/**
	 *  rtf
	 * @return String
	 */
	public String getFileName() {
		return fileName;
	}
	/**
	 * path ͧ rtf
	 * @return String
	 */
	public String getPathName() {
		return pathName;
	}
	/**
	 * Template  rtf
	 * @return String
	 */
	public String getSourceFile() {
		return sourceFile;
	}
	/**
	 * 絤 path ͧ rtf
	 * @param pathName
	 */
	private void setPathName(String pathName) {
		this.pathName = pathName;
	}
	/**
	 * 絤 Template  rtf ҹ
	 * @param sourceFile
	 */
	private void setSourceFile(String sourceFile) {
		this.sourceFile = sourceFile;
	}
	/**
	 * <PRE>
	 * ʹ絿 DbInquiry ´֧ŷ
	 * param 絤ҿ
	 * </PRE>
	 * @param dbInq  DbInquiry ͧ絿
	 */
	private void setInquiryFilter(DbInquiry dbInq) {
		try {
			Hashtable h = dbInq.getChildTable();
			Enumeration em = h.keys();
			DbInquiry inq = null;
			String tableName = dbInq.getTableName();
			String fixpFilter = "", rFilter = "";
			String fixFilter = (String)this.getParam().get("FIXFILTER" + tableName.toUpperCase());
			if (filter.get(tableName) != null ||  fixFilter != null) {
				fixpFilter = fixFilter;
				if (fixpFilter != null && !fixpFilter.equals("")) {
					rFilter += fixpFilter;
					if (filter.get(tableName) != null && !filter.get(tableName).equals(""))
						rFilter += "  AND  " + (String) filter.get(tableName);
				} else
					rFilter = (String) filter.get(tableName);
				dbInq.setFilter(rFilter);
			}
			String childName = "";
			while (em.hasMoreElements()) {
				childName = (String) em.nextElement();
				fixpFilter = "";
				rFilter = "";
				try {
					inq = (DbInquiry) dbInq.getChild(childName);
					tableName = inq.getTableName();
				} catch (ClassCastException e) {
					MyLog.warn(this, this.up, "Object not instance Inquiry Can not set Filter");
				}
				if (filter.get(tableName) != null || fixFilter != null) {
					fixpFilter = fixFilter;
					if (fixpFilter != null && !fixpFilter.equals("")) {
						rFilter += fixpFilter;
						if (filter.get(tableName) != null && !filter.get(tableName).equals(""))
							rFilter += "  AND  " + (String) filter.get(tableName);
					} else
						rFilter = (String) filter.get(tableName);
					inq.setFilter(rFilter);
				}
			}
		} catch (RemoteException e) {
			MyLog.error(this, this.up, e);
		}
	}
	/**
	 * tag  template
	 * @return String
	 */
	protected String getBeginTag() {
		return beginTag;
	}
	/**
	 * tag ش template
	 * @return String
	 */
	protected String getEndTag() {
		return endTag;
	}
	/**
	 * ŷ write
	 * @param data
	 */
	public void setData(String data) {
		this.data = data;
	}
	/**
	 * User Profile
	 * @return UProfile
	 */
	public UProfile getUp() {
		return up;
	}
	/**
	 * parameter ҡ˹Ҩ
	 * @return HashMap
	 */
	public HashMap getParam() {
		return param;
	}
	/**
	 * 㹡÷ environment ͧ DynamicJava
	 * @param key  ͧ put ҵ
	 * @param value  ҷͧ put
	 */
	public void addVariable(Object key, Object value) {
		this.variable.put(key, value);
	}
	/**
	 * ҵ÷ҹ DynamicJava
	 * @return MyHashMap
	 */
	public MyHashMap getVariable() {
		return variable;
	}
	/**
	 * DbInquiry  DynamicJava
	 * @return DbInquiry
	 */
	protected DbInquiry getDbInq() {
		return dbInq;
	}
	/**
	 * Tag зӡ Replace  Template
	 * @return String
	 */
	public String getReplcTag() {
		return replcTag;
	}
	/**
	 * ¢ͧ͡ rtf
	 * @return String
	 */
	protected String getTailData() {
		return tailData;
	}
	/**
	 * <PRE>
	 * ʹ֧ Vector 纤
	 * ˹觨ش辺ش鹢ͧ tag 
	 *  template (beginTag)
	 * </PRE>
	 * @return Vector
	 */
	protected Vector getVAddr() {
		return vAddr;
	}
	/**
	 * <PRE>
	 * ʹ֧ Vector 纤
	 *  tag ˹觷ӡõǨͺ
	 * </PRE>
	 * @return Vector
	 */
	protected Vector getVToken() {
		return vToken;
	}
	/**
	 * <PRE>
	 * flag Ǩͺ Cls ӡ
	 * fecth Ũҡ DbInquiry 
	 * Ǩ֧Ӣ任͡
	 * </PRE>
	 * @return boolean
	 */
	protected boolean isFetchAllFlag() {
		return fetchAllFlag;
	}
	/**
	 * <PRE>
	 * flag  Cls ӧҹ
	 * fecth Ũҡ DbInquiry 
	 * Ǩ֧Ӣ任͡
	 * </PRE>
	 * @param fetchAllFlag The fetchAllFlag to set
	 */
	protected void setFetchAllFlag(boolean fetchAllFlag) {
		this.fetchAllFlag = fetchAllFlag;
	}
	/**
	 * ʹ֧ Cls 红 xml ͧ MailMerge
	 * @return MailMergeXml
	 */
	public MailMergeXml getMmXml() {
		return mmXml;
	}
	/**
	 * ʹ֧  xml ͧ MailMerge
	 * @return String
	 */
	public String getMmXmlName() {
		return mmXmlName;
	}
	/**
	 * ʹ絤 Cls 红 xml ͧ MailMerge
	 * @param mmXml The mmXml to set
	 */
	public void setMmXml(MailMergeXml mmXml) {
		this.mmXml = mmXml;
	}
	/**
	 *  ʹ絤  xml ͧ MailMerge
	 * @param mmXmlName The mmXmlName to set
	 */
	public void setMmXmlName(String mmXmlName) {
		this.mmXmlName = mmXmlName;
	}
	/**
	 *  ʹ֧  Path ͧ MailMerge
	 * @return String
	 */
	public String getMmPath() {
		return mmPath;
	}
	// nu ball edit 11-10-48
	private String getExportPath(){
		 InitialEnvironment env = new InitialEnvironment("GLOBAL");
		String exportPath=env.getValue("export-dir");
		String appName = up.get("appname");
		exportPath +="/"+ appName + "/Report/";

		return exportPath;
	}
	/*******************************/
}