package com.csc.library.database;

import java.io.Serializable;
import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Vector;

import com.csc.library.utilities.UProfile;


public interface ChildManager extends Serializable{
	public void clearField() throws RemoteException;
	public void clearChild() throws RemoteException;
	public String getTableName() throws RemoteException;
	public String getDescription() throws RemoteException;
	public int setCondition(String condition[]) throws RemoteException;
	public void refresh() throws RemoteException;
	public void refreshChild() throws RemoteException;
	public ChildManager getChild(String childName) throws RemoteException;
	public Relation getRelation(String relation) throws RemoteException;
	public char getUsedFor() throws RemoteException;
	public int save() throws RemoteException;
	public int delete()throws RemoteException;
	public ConnectManager getConnectControl() throws RemoteException;
	public void setRequiredFound(boolean requrire) throws RemoteException;
	public boolean getRequiredFound() throws RemoteException;
	public Hashtable getChildTable() throws RemoteException;
	public boolean foundData() throws RemoteException;
	public void setFilter(String condition) throws RemoteException;
	public void isChild() throws RemoteException;
	public int putChild(ChildManager oChild) throws RemoteException;
	public Vector getAllKey() throws RemoteException;
	public void setUProfile(UProfile uPro) throws RemoteException;
	public UProfile getUProfile();
	public String getActualName() throws RemoteException;
	public void setParam(HashMap param) throws RemoteException;
	public void  referLangOff()throws RemoteException;
    public void  referLangOn()throws RemoteException;
    public String getString(String field)throws RemoteException;
    public HashMap getParam()throws RemoteException;
    public int recCount()throws RemoteException;
    public void setParent(ChildManager ch)throws RemoteException;
	public boolean setColumn(String columnList) throws RemoteException;
	public boolean setColumn(Vector columnList) throws RemoteException;


    /**
     *  Start RequireFound Table
     */
    public void setRequireFoundTable(String tablenames);
    public void setRequireFoundTable(Vector childRequire);
    public Vector getRequireFoundTable();
    public String getStringHTML(String fieldName);
    /**
     *    end RequireFound Table
     */
    
    /**
     * Start transaction
     */
   // public void setSqlBatch(SqlBatch sqlseq);
    //public SqlBatch getSqlBatch();
/**
 *  end transaction
 */
    
    /**
     * set aliasname for table
     */
    public void setAliasName(String aliasname);
    public String getAliasName();
}