package com.csc.library.database;

import java.lang.reflect.Constructor;
import java.math.BigDecimal;
import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.Time;
import java.sql.Timestamp;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.StringTokenizer;
import java.util.Vector;

import org.jdom.Attribute;
import org.jdom.Element;

import com.csc.entity.DataBMPBean;
import com.csc.entity.DataBMPKey;
import com.csc.library.components.ComponentManager;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.keepLog;
import com.csc.library.utilities.CheckNull;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscIndexTable;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ReadXml;
import com.csc.library.utilities.StrReplace;
import com.csc.library.utilities.UProfile;

/**
 * 
 * <p>
 * Title: Your Product Name
 * </p>
 * <p>
 * Description: Your description
 * </p>
 * <p>
 * Copyright: Copyright (c) 1999
 * </p>
 * <p>
 * Company: Your Company
 * </p>
 * 
 * @author Your Name
 * @version
 */
public class MyRecord extends MyDB implements keepLog {
	private static final long serialVersionUID = 1L;

	protected PropertyRec key;

	protected PropertyRec mf = new PropertyRec(); 

//	private Statement myStmt;

	protected String tableName, description, actualName, filter, descThai, descEng;

	char group;

//	private String error = "";

	private StringBuilder field = new StringBuilder();

	protected String editCheck = "false";

	protected Vector aField;
	
	protected Vector AllFieldName;
	
	protected Vector SystemField;
	
	private 	HashMap normalField;
	
	private 	Vector maindatoryField;

	protected int fieldCount;

	protected String wfactive = "false";

	private char usedFor = 'U'; // U-Update

	// R-Reference
	// S-Stop

	private byte autoRefresh = 1;

	transient private CheckNull chkStr = null;

	private String oldCondition = "$$$";

	protected Hashtable childTable = new Hashtable();

//	protected Hashtable parentTable = new Hashtable();
	
	protected ChildManager parentTable =null;
	
	protected Hashtable relationInfo = new Hashtable();

	protected Hashtable effectTable = new Hashtable();

	protected Hashtable fieldGroup = new Hashtable();

	protected Hashtable referenceTable = new Hashtable();

	protected Vector autoField = new Vector();

	protected Vector allKey = new Vector();
	
	protected Vector AutoNumField=new Vector();

	// MultiEntry Var
	protected Vector MultiKeyStore = new Vector();

	protected int MultiCurrent = -1;

	private String MultiField = "";

	private CscCalendar lastUpDate = new CscCalendar();

	private byte refreshModel = 0;

	protected String jndiName;

	protected ConfigMetadata vMetaData;

	private String mainHelp, referHelp, mainKey;
	
	private StringBuilder keyEmpty=new StringBuilder();

	// PROPERTIES FOR HISTORY FIELD
	protected HashMap referField = new HashMap();

	protected HashMap refervalue = new HashMap();

	protected HistoryRecord hisrec = new HistoryRecord();

//	private FieldManager searchInfo; comment by pas ͧ͡ҡҹ

	protected RSecurityManager rsm;

	public transient DataBMPBean pRemote = new DataBMPBean();

	public transient DataBMPKey pK = new DataBMPKey();

	protected String wfkey = "";
	
	protected String documentno = "";

	protected boolean isFormat = false;
	
	private HashMap aliasField = new HashMap();

	private Vector andCondition	=	new Vector();
	private Vector orCondition	=	new Vector();
	private Vector column_need = new Vector();
	
	private	Vector fieldUpload = new Vector();
	private	Vector fieldBlob   = new Vector();
	
//	protected Vector mField ;
	
	private  String createBY = ""; 
	
	protected String appname = "";
	protected String language = "";
	
	protected boolean isSim=false;
	
	protected boolean isDepend = Boolean.valueOf((String) 
			StaticProperties.myConfig.get("rule_foreingekey")).booleanValue();
	
	public void setLastUpdate() {
		lastUpDate = new CscCalendar();
	}

	public String getLastUpdate() {
		return this.lastUpDate.getDDMMYYYYHHMMSS();
	}

	/**
	 * 
	 * @param tableName
	 * @param description
	 */
	public MyRecord(String tableName, String description) {
		super();
		// ball edit
		tableName = tableName.toLowerCase();
		this.stmtType = this.setTableDB(tableName);
		// this.tableName = tableName.toLowerCase();
		this.tableName = tableName;
		this.actualName = this.tableName;
		this.description = description;
		this.jndiName = tableName;
//		this.startUp();
	}

	/**
	 * 
	 * @param tableName
	 * @param description
	 * @param aField
	 */
	public MyRecord(String tableName, String description, PropertyRec aField) {
		super();
		this.stmtType = this.setTableDB(tableName);
		// this.tableName = tableName.toLowerCase();
		this.tableName = tableName;
		this.actualName = this.tableName;
		this.description = description;
		this.mf = aField;
		this.startUp();
	}

	// clear the data in myField except keyField
	/*
	 * public void clearField() { FieldManager m; for (Iterator enum =
	 * mf.keySet(); enum.hasMoreElements();) { m = (FieldManager)
	 * mf.get(enum.nextElement()); m.setDefault(); }
	 */
	public void clearField() {
		this.clearField(false);	
	}
	
	public void clearField(boolean clearAll) {
		FieldManager m;
		boolean refer=this.referLang;
		if(refer)
			this.referLangOff();
		this.pRemote.clearOldWhere();
// befor change		
		for (Iterator it = mf.keySet().iterator(); it.hasNext();) {			
			m = (FieldManager) mf.get(it.next());
				m.setDefault();
		}
		
// remove by pas
//		for (int i=0; i< mf.size(); i++) {			
//		m = (FieldManager) mf.get(i);
//			m.setDefault();
//	}		
		
		
		this.setFoundData(false);
		if(refer)
			this.referLangOn();
	}


	public void startUp() {
/*		FieldManager m;
		this.key = new PropertyRec();
		for (Iterator it = mf.keySet().iterator(); it.hasNext();) {
			m = (FieldManager) mf.get(it.next());
			m.setRecord((RecordManager) this);
			if (m.isKey() != '0') {
				this.allKey.add(m.getName());
				key.put(String.valueOf(m.isKey()), m.getName());
				m.setWorking(true);
			}
		}
		// Initial this.field
*///		this.setColumn("*");
		// set every field to default value
//		this.clearField();
	}

	/**
	 * 
	 * @param condition
	 * @return
	 */
	public int setCondition(String condition[]) {
		// logger.info("<-- in setCondition -->");
		PropertyRec tempKey = new PropertyRec();
	    Vector tempAllKey = new Vector();
		int ok = 0;
		int k = 1;
		int i;
		if (condition.length % 2 == 0 && condition.length > 0) {
			ok = 1;
			for (i = 0; i < condition.length && ok == 1; i = i + 2) {
				// logger.info("<-- TableName " + this.tableName + " key=" +
				// condition[i] + " data=" + condition[i + 1] + " -->");
				if (this.set(condition[i], condition[i + 1]) || k > 1) {
					// logger.info("<-- TableName " + this.tableName + " key=" +
					// condition[i] + " data=" + condition[i + 1] + " -->");
					tempAllKey.add(condition[i]);
					tempKey.put(String.valueOf(k), condition[i]);
					k++;
				} else {
					ok = 0;
					for (int j = i - 2; j >= 0; j = j - 2) {
						this.restore(condition[j]);
					}
				}
			}
			if (ok == 1) {
				this.key = tempKey;
				this.allKey = tempAllKey;
//				this.pK.setKey((DbRecord)this);
//				this.pRemote.setDataBMPKey(this.pK);
				// logger.info("<-- in setCondition : key Condition = " +
				// this.key.toString() + "-->");
			} else {
				// logger.info("Could not set this condition!!!!! : ");
			}
		} else {
			// logger.info("Conditions is not Complete!");
		}
		return ok;
	}

	protected void addField(FieldManager f) {
		boolean x;
		if ((f != null) && (this.mf.get(this.charCase(f.getName())) == null)) {
			f.setWorking(true);
			this.mf.put(this.charCase(f.getName()), f);
			if (f.getUsedFor() == '1') {
//				this.fieldCount++;
//				this.field = this.addFieldList(this.field, this.charCase(f	.getName()));
				if(!this.aField.contains(this.charCase(f.getName()))){
					this.aField.add(this.charCase(f.getName()).trim());
					this.AllFieldName.add(this	.charCase(f.getName()));
				}
			}
			if (f.isKey() != '0'  &&  !this.allKey.contains(f.getName())) {
				this.allKey.add(this.charCase(f.getName()));
				this.key.put(String.valueOf(f.isKey()), this.charCase(f.getName()));
			}
			if (f instanceof FieldAutoNumber) {
				this.autoField.add(f);
			}
		}
	}

	protected void delField(FieldManager f) {
		if (f.isKey() != '0') {
			key.remove(String.valueOf(f.isKey()));
		}
		this.mf.remove(f.getName());
	}

	protected void addFieldList(String nextField) {
		if (!this.aField.contains(nextField)) {
			if (field.toString().trim().length() > 0) {
				this.field.append(",").append(nextField);
				this.fieldCount++;
			} else {
				field.append(nextField);
			}
			this.aField.add(nextField);
		}	
//		return oldList.toString(); 
	}

	public int save() {
		int mySave = 0;
		return mySave;
	}

	public int save(Connection myCon) {
		return 0;
	}

	public int delete() {
		return 1;
	}

	public int delete(Connection myCon) {
		return 0;
	}

	public void refresh() {
		try {
			if (this.pRemote.isNewWhereString()) this.search();
		} catch (RemoteException e) {
			MyLog.error(this, e); // TODO Auto-generated catch block
		}
	}

	public int search() {
		return 0;
	}

	private String getKeyCondition() {
		StringBuffer returnCondition = new StringBuffer();
		FieldManager fm;
		String keyField;
		// logger.info("myRecord:338-Key size='"+this.getSizeKey()+"'");
		if (this.getSizeKey() > 0) {
			for (int i = 0; i < this.getSizeKey(); i++) {
				keyField = (String) this.key.get(String.valueOf(i + 1));
				// logger.info("myRecord:342-Keyfield='"+keyField+"'");
				fm = (FieldManager) this.mf.get(keyField);
				if (!((String) fm.getValue()).trim().equals("")) {
					if (returnCondition.length() > 0) {
						returnCondition.append(" AND ");
						// //logger.info("myRecord:346-returnCondition='"+fm.getCompareString()+"'");
					}
					returnCondition.append(fm.getCompareString());
				}
			}
		}
		return returnCondition.toString();
	}

	public String getListKey() {
		String keyField = "";
		if (this.getSizeKey() > 0) {
			keyField = (String) this.key.get("1");
			for (int i = 1; i < this.getSizeKey(); i++) {
				keyField = keyField + ","
						+ (String) this.key.get(String.valueOf(i + 1));
			}
		}
		return keyField;
	}
	
	/*
	 * Ǩͺ key  null  SPACE
	 *  ͧ Save
	 */
	
	public boolean keyOK() {
		boolean keyOK = true;
		this.setCompany();
		String keyField, keyData;
		this.keyEmpty=new StringBuilder();
		if (this.getSizeKey() > 0) {
//			keyField = (String) this.key.get("1");
			for (int i = 0; i < this.getSizeKey() && keyOK; i++) {
				String keyFieldName = (String)this.key.get(String.valueOf(i + 1));
				if (!this.SystemField.contains(keyFieldName)) {
					FieldManager fm = this.getField(keyFieldName);
					keyData = fm.getString();
					if (keyData == null) {
						keyOK = false;
						this.keyEmpty.append(keyFieldName).append(":");
					} else {
						if (keyData.trim().length()==0) { 
							keyOK = false;
							this.keyEmpty.append(keyFieldName).append(":");
						}
					}
				}
			}
		}
		return keyOK;
	}
	
	public String getKeyEmptyList() {
		return this.keyEmpty.toString();
	}
	// get all value for save as addnew
	public String getAllValue() {
		StringBuffer fValue = new StringBuffer();
		FieldManager m;
		for (int i = 0; i < this.aField.size(); i++) {
			m = (FieldManager) mf.get(this.aField.get(i));
			if (fValue.length() != 0) {
				fValue.append(",");
			}
			if (m.getUsedFor() == '1') {
				fValue.append(m.getValueString());
			}
		}
		return fValue.toString();
	}

	// put the data to myField
	public void restore() {
		FieldManager m;
		// for (Enumeration enum = mf.keys(); enum.hasMoreElements();) {
		for (Iterator it = mf.keySet().iterator(); it.hasNext();) {
			m = (FieldManager) mf.get(it.next());
		}
		
//		for (int i=0; i< mf.size();i++) {
//			m = (FieldManager) mf.get(i);
//		}
		
	}

	public void restore(String fieldName) {
		FieldManager m;
		m = this.getField(fieldName);
		if (m != null) {
			m.restoreValue();
			this.setLastUpdate();
		}
	}

	public void print() {
		FieldManager m;
		for (Iterator it = mf.keySet().iterator(); it.hasNext();) {
			m = (FieldManager) mf.get(it.next());
			if (m.isWorking()) {
				MyLog.info(this, m.getCompareString());
			}
		}
//		for (int i=0;i< mf.size();i++) {
//			m = (FieldManager) mf.get(i);
//			if (m.isWorking()) {
//				MyLog.info(this, m.getCompareString());
//			}
//		}
		
	}

	public void printList() {
		FieldManager m;
		for (Iterator it = mf.keySet().iterator(); it.hasNext();) {
			m = (FieldManager) mf.get(it.next());
			if (m.isWorking()) {
				 MyLog.info(this, m.getValueString() + ",");
			}
		}
//		for (int i=0;i< mf.size();i++) {
//			m = (FieldManager) mf.get(i);
//			if (m.isWorking()) {
//				 MyLog.info(this, m.getValueString() + ",");
//			}
//		}
		
	}

	public boolean getBoolean(String fieldName) {
		FieldManager m = this.getField(fieldName);
		boolean data = (m != null) ? m.getBoolean() : false;
		return data;
	}

	public String getAllData() {
		String data = "";
		FieldManager m;
		for (Iterator it = mf.keySet().iterator(); it.hasNext();) {
			m = (FieldManager) mf.get(it.next());
			if (m.isWorking()) {
				 data +=m.getValueString() + " : ";
			}
		}
		
//		for (int i=0;i<mf.size();i++){
//			m = (FieldManager) mf.get(i);
//			if (m.isWorking()) {
//				 data +=m.getValueString() + " : ";
//			}
//		}
		
		return data;
	}
	
	public byte getByte(String fieldName) {
		FieldManager m = this.getField(fieldName);
		byte data = (m != null) ? m.getByte() : 0;
		// this.chkGroup(fieldName);
		return data;
	}

	public char[] getChars(String fieldName) {
		FieldManager m = this.getField(fieldName);
		char[] data = (m != null) ? m.getChars() : null;
		// this.chkGroup(fieldName);
		return data;
	}

	public char getChar(String fieldName) {
		FieldManager m = this.getField(fieldName);
		char data = (m != null) ? m.getChar() : ' ';
		// this.chkGroup(fieldName);
		return data;
	}

	public short getShort(String fieldName) {
		FieldManager m = this.getField(fieldName);
		short data = (m != null) ? m.getShort() : 0;
		// this.chkGroup(fieldName);
		return data;
	}
	
	public int getInt(String fieldName) {
		this.chkStr = new CheckNull();
		FieldManager m = this.getField(fieldName);
		int data = 0;
		if(m!=null){
			data=m.getString().indexOf(".");
			if(data==-1){
				data=Integer.parseInt(chkStr.chkNullString(m.getString(),"0"));
			}else{
				data=Integer.parseInt(chkStr.chkNullString(m.getString().substring(0,m.getString().indexOf(".")), "0"));
			}
		}else{
			data=0;
		}
		return data;
	}

//	public int getInt(int index) {
//		this.chkStr = new CheckNull();
//		FieldManager m = this.getField(index);
//		int data = 0;
//		if(m!=null){
//			data=m.getString().indexOf(".");
//			if(data==-1){
//				data=Integer.parseInt(chkStr.chkNullString(m.getString(),"0"));
//			}else{
//				data=Integer.parseInt(chkStr.chkNullString(m.getString().substring(0,m.getString().indexOf(".")), "0"));
//			}
//		}else{
//			data=0;
//		}
//		return data;
//	}
	

	public long getLong(String fieldName) {
		this.chkStr = new CheckNull();
		FieldManager m = this.getField(fieldName);
		long data = (m != null) ? Long.parseLong(chkStr.chkNullString(m.getString(), "0")) : 0;
		// long data = (m != null) ? m.getLong() : 0;
		// this.chkGroup(fieldName);
		return data;
	}

//	public long getLong(int index) {
//		this.chkStr = new CheckNull();
//		FieldManager m = this.getField(index);
//		long data = (m != null) ? Long.parseLong(chkStr.chkNullString(m.getString(), "0")) : 0;
//		// long data = (m != null) ? m.getLong() : 0;
//		// this.chkGroup(fieldName);
//		return data;
//	}
	
	public float getFloat(String fieldName) {
		this.chkStr = new CheckNull();
		FieldManager m = this.getField(fieldName);
		float data = (m != null) ? Float.parseFloat(chkStr.chkNullString(m.getString() ,
				"0.00")) : 0;
		// float data = (m != null) ? m.getFloat() : 0;
		// this.chkGroup(fieldName);
		return data;
	}
	
//	public float getFloat(int index) {
//		this.chkStr = new CheckNull();
//		FieldManager m = this.getField(index);
//		float data = (m != null) ? Float.parseFloat(chkStr.chkNullString(m.getString() ,"0.00")) : 0;
//		return data;
//	}
	

	public double getDouble(String fieldName) {
		this.chkStr = new CheckNull();
		FieldManager m = this.getField(fieldName);
		double data = (m != null) ? Double.parseDouble(chkStr.chkNullString(m.getString(),"0.00")) : 0;
		// double data = (m != null) ? m.getDouble() : 0.0;
		// this.chkGroup(fieldName);
		return data;
	}

//	public double getDouble(int index) {
//		this.chkStr = new CheckNull();
//		FieldManager m = this.getField(index);
//		double data = (m != null) ? Double.parseDouble(chkStr.chkNullString(m.getString(),
//				"0.00")) : 0;
//		return data;
//	}
	
	
	public Timestamp getTimestamp(String fieldName) {
		FieldManager m = this.getField(fieldName);
		Timestamp data = new Timestamp(1);
		if (m != null) {
			data = m.getTimestamp();
		}
		// this.chkGroup(fieldName);
		return data;
	}

	public BigDecimal getBigDecimal(String fieldName) {
		FieldManager m = this.getField(fieldName);
		BigDecimal data = new BigDecimal(1);
		if (m != null) {
			data = m.getBigDecimal();
		}
		// this.chkGroup(fieldName);
		return data;
	}

//	public BigDecimal getBigDecimal(int index) {
//		FieldManager m = this.getField(index);
//		BigDecimal data = new BigDecimal(1);
//		if (m != null) {
//			data = m.getBigDecimal();
//		}
//		return data;
//	}
	

	public Time getTime(String fieldName) {
		FieldManager m = this.getField(fieldName);
		Time data = new Time(1);
		if (m != null) {
			data = m.getTime();
		}
		// this.chkGroup(fieldName);
		return data;
	}

	public java.sql.Date getDate(String fieldName) {
		FieldManager m = this.getField(fieldName);
		java.sql.Date data = new java.sql.Date(1);
		if (m != null) {
			data = m.getDate();
		}
		// this.chkGroup(fieldName);
		return data;
	}

	public CscCalendar getCscCalendar(String fieldName) {
		FieldManager m = this.getField(fieldName);
		CscCalendar data = new CscCalendar();
		if (m != null) {
			data = m.getcscCalendar();
		}
		// this.chkGroup(fieldName);
		return data;
	}

//	public CscCalendar getCscCalendar(int index) {
//		FieldManager m = this.getField(index);
//		CscCalendar data = new CscCalendar();
//		if (m != null) {
//			data = m.getcscCalendar();
//		}
//		return data;
//	}

	
	public String getString(String fieldName) {
		FieldManager m = this.getField(fieldName);
		String data = (m != null) ? m.getString() : "";
		// ball edit
		if ((data == null) || (data == "")) {
			data = " ";
		}
		// this.chkGroup(fieldName);
		return data;
	}
	
//	public String getString(int index) {
//		FieldManager m = this.getField(index);
//		String data = (m != null) ? m.getString() : "";
//		if ((data == null) || (data == "")) {
//			data = " ";
//		}
//		return data;
//	}
	
	public String getDataFormat(String fieldName){
		FieldManager m = this.getField(fieldName);
		String data = (m != null) ? m.getDataFormat(): "";
		// ball edit
		if ((data == null) || (data == "")) {
			data = " ";
		}
		// this.chkGroup(fieldName);
		return data;		
	}
	
//	public String getDataFormat(int index){
//		FieldManager m = this.getField(index);
//		String data = (m != null) ? m.getDataFormat(): "";
//		if ((data == null) || (data == "")) {
//			data = " ";
//		}
//		return data;		
//	}	
	
	
	private void chkGroup(String fieldName) {
		if (!this.groupActive.equals("all")) {
			String fList = (String) this.groupField.get(this.groupActive);
			if (fList.indexOf(fieldName.toLowerCase()) == -1) {
				// this.initMyRecordLog();
				MyLog.error(this, "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!FIELD NAME :"
								+ fieldName
								+ " INGROUP  "
								+ this.groupActive
								+ " NOT FOUND !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
				MyLog.error(this, " ALL FIELD :" + fList);
			}
		}
	}

	protected void setCompany() {
		if (this.getArrayFieldList().contains("companyid")&& this.getString("companyid").trim().length()==0) {
			this.set("companyid", this.userPro.get("companyid"));
		}
	}

	public boolean set(String fieldName, String data) {
        boolean ok = false;
//		if (fieldName.equals("search_info"))
//			this.searchInfo.set(data);
//		else {
			FieldManager m = this.getField(fieldName);
			if (m != null) {
				this.setLastUpdate();
				ok=m.set(data);		
			}
//		}
		return ok;
	}

//	public boolean set(int index, String data) {
//        boolean ok = false;
//			FieldManager m = this.getField(index);
//			if (m != null) {
//				this.setLastUpdate();
//				ok=m.set(data);				
//			}
//		return ok;
//	}
	

	public boolean set(FieldManager fm, String data) {
        boolean ok = false;
        if (fm != null) {
//				if (fm.getName().equals("search_info"))
//					this.searchInfo.set(data);
//				else {
						this.setLastUpdate();
						ok=fm.set(data);				
//					}
		}
		return ok;
	}	
	
	public boolean set(String fieldName, boolean data) {
		boolean ok = false;
		FieldManager m = this.getField(fieldName);
		if (m != null) {
			this.setLastUpdate();
			ok=m.set(data);
		}
		return ok;
	}

	public boolean set(String fieldName, byte data) {
		boolean ok = false;
		FieldManager m = this.getField(fieldName);
		if (m != null) {
			this.setLastUpdate();
			ok=m.set(data);			
		}
		return ok;
	}

	public boolean set(String fieldName, char data[]) {
		boolean ok = false;
		FieldManager m = this.getField(fieldName);
		if (m != null) {
			ok=m.set(data);
			this.setLastUpdate();
		}
		return ok;
	}

	public boolean set(String fieldName, char data) {
		boolean ok = false;
		FieldManager m = this.getField(fieldName);
		if (m != null) {
			this.setLastUpdate();
			ok=m.set(data);			
		}
		return ok;
	}

	public boolean set(String fieldName, short data) {
		boolean ok = false;
		FieldManager m = this.getField(fieldName);
		if (m != null) {
			this.setLastUpdate();
			ok=m.set(data);			
		}
		return ok;
	}

	public boolean set(String fieldName, int data) {
		boolean ok = false;
		FieldManager m = this.getField(fieldName);
		if (m != null) {
			this.setLastUpdate();
			ok=m.set(data);			
		}
		return ok;
	}

//	public boolean set(int index, int data) {
//		boolean ok = false;
//		FieldManager m = this.getField(index);
//		if (m != null) {
//			this.setLastUpdate();
//			ok=m.set(data);			
//		}
//		return ok;
//	}

	
	public boolean set(String fieldName, long data) {
		boolean ok = false;
		FieldManager m = this.getField(fieldName);
		if (m != null) {
			this.setLastUpdate();
			ok=m.set(data);			
		}
		return ok;
	}
//	public boolean set(int index, long data) {
//		boolean ok = false;
//		FieldManager m = this.getField(index);
//		if (m != null) {
//			this.setLastUpdate();
//			ok=m.set(data);			
//		}
//		return ok;
//	}

	
	public boolean set(String fieldName, float data) {
		boolean ok = false;
		FieldManager m = this.getField(fieldName);
		if (m != null) {
			this.setLastUpdate();
			ok=m.set(data);			
		}
		return ok;
	}

//	public boolean set(int index, float data) {
//		boolean ok = false;
//		FieldManager m = this.getField(index);
//		if (m != null) {
//			this.setLastUpdate();
//			ok=m.set(data);			
//		}
//		return ok;
//	}

	
	public boolean set(String fieldName, double data) {
		boolean ok = false;
		FieldManager m = this.getField(fieldName);
		if (m != null) {
			this.setLastUpdate();
			ok=m.set(data);
		}
		return ok;
	}

//	public boolean set(int index, double data) {
//		boolean ok = false;
//		FieldManager m = this.getField(index);
//		if (m != null) {
//			this.setLastUpdate();
//			ok=m.set(data);
//		}
//		return ok;
//	}

	
	public boolean set(String fieldName, Timestamp data) {
		boolean ok = false;
		FieldManager m = this.getField(fieldName);
		if (m != null && data != null) {
			this.setLastUpdate();
			ok=m.set(data);			
		}
		return ok;
	}

	public boolean set(String fieldName, java.sql.Date data) {
		boolean ok = false;
		FieldManager m = this.getField(fieldName);
		if (m != null && data != null) {
			this.setLastUpdate();
			ok=m.set(data);			
		}
		return ok;
	}

	public boolean set(String fieldName, BigDecimal data) {
		boolean ok = false;
		FieldManager m = this.getField(fieldName);
		if (m != null && data != null) {
			this.setLastUpdate();
			ok=m.set(data);			
		}
		return ok;
	}

//	public boolean set(int index, BigDecimal data) {
//		boolean ok = false;
//		FieldManager m = this.getField(index);
//		if (m != null && data != null) {
//			this.setLastUpdate();
//			ok=m.set(data);			
//		}
//		return ok;
//	}
	
	
	public boolean set(String fieldName, Time data) {
		boolean ok = false;
		FieldManager m = this.getField(fieldName);
		if (m != null && data != null) {
			this.setLastUpdate();
			ok=m.set(data);			
		}
		return ok;
	}

	public boolean set(String fieldName, CscCalendar data) {
		boolean ok = false;
		FieldManager m = this.getField(fieldName);
		if (m != null && data != null) {
			this.setLastUpdate();
			ok=m.set(data);			
		}
		return ok;
	}

//	public boolean set(int index, CscCalendar data) {
//		boolean ok = false;
//		FieldManager m = this.getField(index);
//		if (m != null && data != null) {
//			this.setLastUpdate();
//			ok=m.set(data);			
//		}
//		return ok;
//	}	
	
	public void setKey(String data) {
		String keyField;
		keyField = (String) this.key.get("1");
		if (keyField != null) {
			this.set(keyField, data);
		}
	}

	public String getNameKey(String No) {
		return (String) this.key.get(No);
	}

	public int getSizeKey() {
		return this.key.size();
	}

	public void setKey(String data[]) {
		String keyField;
		for (int i = 0; i < data.length; i++) {
			keyField = (String) this.key.get(String.valueOf(i + 1));
			if (keyField != null) {
				this.set(keyField, data[i]);
			}
		}
	}

	public FieldManager getField(String fieldName) {
		FieldManager f=null;
//				if (fieldName.equals("search_info")) {
//					return this.searchInfo;
//				} else {
					fieldName = this.charCase(fieldName);
					if (this.mf.containsKey(fieldName)) {
						f = (FieldManager) this.mf.get(fieldName);
					} else {
						if(this.aliasField!=null&&this.aliasField.containsKey(fieldName.toUpperCase())){
							fieldName= this.aliasField.get(fieldName).toString();
							f = (FieldManager) this.mf.get(fieldName);
						}else if (this.AllFieldName.contains(fieldName)) {
//							MyLog.warn(this, this.userPro,"Please set column too! "+this.getActualName().toString()+"." + fieldName);
							f=this.createField(fieldName, (HashMap)this.normalField.get(fieldName));
							if (f==null) {
								MyLog.error(this, "Try to generate column but can not found in protable! "+this.getActualName().toString()+"." + fieldName);
							} else {
								f.setWorking(true);
								//comment by pas ͧҡջѭͧ ա setcolumn ¡ field к add ŧ aField 
								//this.field = this.addFieldList(this.field, this.charCase(fieldName));
								this.mf.put(fieldName, f);
//								this.mField.add(f);
							}
						}/* else {
		////					MyLog.debug(this, "Field Not Found! "+this.getActualName().toString()+"." + fieldName);
						}*/
					}
//				}
		return f;
	}

//	public FieldManager getField(int index) {
//		FieldManager f=null;
//		try{
//			f=(FieldManager)this.mf.get(index);
//		}catch(Exception e){
//			MyLog.debug(this, "Field Not Found! "+this.getActualName().toString()+" index [" + index+"]");
//		}
//		return f;
//	}

	
	public void setUsedFor(char usedFor) {
		this.usedFor = usedFor;
	}

	public char getUsedFor() {
		return this.usedFor;
	}

	public String getFieldList() {
		return this.field.toString();
	}

	public Vector getArrayFieldList() {
		return this.aField;
	}
	
	public void setFieldList(String fieldlist) {
		this.field = new StringBuilder(fieldlist);
	}

	public String getActualName() {
		return this.actualName;
	}

	public void setTableName(String name) {
		this.tableName = name;
	}

	public void setActualName(String name) {
		this.actualName = this.charCase(name);
	}

	public void setFilter(String condition) {
		this.filter = condition;
	}

	public String getError() {
		return "";
	}

	public String getEditCheck() {
		return this.editCheck;
	}

	public String getRunNo() {
		return "";
	}

	public void deleteFor(String condition) {
	}

	public Hashtable getRelationInfo() {
		return relationInfo;
	}

	public void setRelationInfo(Hashtable hashRelation) {
		this.relationInfo = hashRelation;
	}

	public Hashtable getEffectTable() {
		return this.effectTable;
	}

	public void setEffectTable(Hashtable hashEffectTable) {
		this.effectTable = hashEffectTable;
	}

	public Hashtable getChildTable() {
		return this.childTable;
	}

	public void setChildTable(Hashtable hashChild) {
		this.childTable = hashChild;
	}

	public void putRelation(Relation oRela) {
		this.relationInfo.put(oRela.tableName, oRela);
	}

	public void removeRelation(String tableName) {
		this.relationInfo.remove(this.charCase(tableName));
	}

	public Relation getRelation(String childName) {
		Relation rl = null;
		Object o = null;
		try {
			ChildManager ch = (ChildManager) this.childTable.get(this.charCase(childName));
			if (ch != null) {
				o = ch.getRelation(this.tableName);
			}
			if (o == null) {
				if (ch != null){
					o = this.relationInfo.get(this.charCase(ch.getActualName()));
					if(o==null){//óշö֧ relationҡ actualname ֧ relation ҡ table ᷹
						o = this.relationInfo.get(this.charCase(ch.getTableName()));
					}					
				}else {
					o = this.relationInfo.get(childName);
				}
			}
			if (o != null) {
				rl = (Relation) o;
			}
		} catch (Exception e) {
			MyLog.error(this, "childName :"+childName);
			MyLog.error(this, e);
		}
		return rl;
	}

	/*
	 * public int putChild(ChildManager oChild) { int ok = 0; try { if
	 * (oChild.getParam() != null) { oChild.getParam().putAll(this.param); }
	 * else { oChild.setParam(this.param); } Relation oRela; oRela =
	 * oChild.getRelation(this.tableName); if (oRela != null) {
	 * this.childTable.put(oChild.getActualName(), oChild);
	 * this.putEffectTable(oRela.childField, oChild.getActualName()); ok = 1; }
	 * else { oRela = this.getRelation(oChild.getActualName()); if (oRela !=
	 * null) { this.childTable.put(oChild.getActualName(), oChild); //
	 * logger.info("[PUTCHILD-CHILDNAME : " + // this.childTable.toString() +
	 * "]"); this.putEffectTable(oRela.parentField, oChild.getActualName()); //
	 * logger.info("[RELATION:FIELD" + oRela.parentField + " - // TABLE:" +
	 * oChild.getActualName() + "]"); ok = 1; } else logger.info("Can not find
	 * relation information of this object. " + this.getActualName() + "|" +
	 * oChild.getActualName()); } if (ok == 1)
	 * this.refreshConditionChild(oChild.getActualName()); } catch (Exception e) {
	 * e.printStackTrace(); } return ok; }
	 */

	public int putChild(ChildManager oChild) {
		int ok = 0;
		try { 
			if (oChild.getParam() != null) {
				oChild.getParam().putAll(this.param);
			} else {
				oChild.setParam(this.param);
			}
			Relation oRela;
			oRela = this.getRelation(oChild, this.getActualName(), oChild.getActualName());
			if (oRela == null)
				oRela = this.getRelation(oChild, this.getActualName(), oChild.getTableName());			
			if (oRela == null)
				oRela = this.getRelation(oChild, this.tableName, oChild.getTableName());
			if (oRela != null) {
				this.childTable.put(oChild.getActualName(), oChild);
				this.putEffectTable(oRela.getEffectField(), oChild.getActualName());
				ok = 1;
			} else {
				MyLog.info(this, "Can not find relation information of this object.  "
								+ this.getActualName()
								+ "|"
								+ oChild.getActualName());
			}
			if (ok == 1) {
				this.refreshConditionChild(oChild.getActualName());
			}	
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		return ok;
	}

	private Relation getRelation(ChildManager oChild, String parentName,
			String childName) {
		Relation oRela = null;
		try {
			oRela = oChild.getRelation(parentName);
			if (oRela != null) {
				oRela.setEffectField(oRela.childField);
			} else {
				oRela = this.getRelation(childName);
				if (oRela != null) {
					oRela.setEffectField(oRela.parentField);
				}
			}
		} catch (Exception e) {
			MyLog.error(this, " oChild "+oChild+"  parentName "+parentName+" childName "+childName);
			MyLog.error(this, e);
		}
		return oRela;
	}

	public void putEffectTable(Vector fieldList, String ChildName) {
		Vector vTemp;
		for (int i = 0; i < fieldList.size(); i++) {
			vTemp = (Vector) this.effectTable.get(fieldList.elementAt(i));
			if (vTemp == null) {
				vTemp = new Vector();
			}
			vTemp.add(ChildName);
			this.effectTable.put(fieldList.elementAt(i), vTemp);
		}
	}

	public void removeEffectTable(String ChildName) {
		Vector vTemp;
		String Child, key;
		for (Enumeration enumeration = this.effectTable.keys(); enumeration
				.hasMoreElements();) {
			key = (String) enumeration.nextElement();
			vTemp = (Vector) this.effectTable.get(key);
			for (int i = 0; i < vTemp.size(); i++) {
				Child = (String) vTemp.elementAt(i);
				if (Child == ChildName) {
					vTemp.removeElementAt(i);
				}
			}
			if (vTemp.isEmpty()) {
				this.effectTable.remove(key);
			}
		}
	}

	public int putChild(String childName, char type, char usedFor) {
		DbRecord oRecord;
		TableManager oTable;
		ChildManager oChild = null;
		String jndiName = childName.substring(0, childName.length() - 4);
		// logger.info("[JNDI NAME IN PUT-CHILD]:" + jndiName);
		int ok = 0;
		/* ============ NOT IMPLEMENT ============== */
		/*
		 * if (type=='R') { try { oRecord = this.getdbRecord(jndiName) ;
		 * oRecord.setUsedFor(usedFor); oChild=(ChildManager)oRecord;
		 * }catch(Exception re){ logger.info(re); } }else{ oTable=new
		 * MyTable(childName); oTable.setUsedFor(usedFor);
		 * oChild=(ChildManager)oTable; } if (oChild!=null) ok =
		 * this.putChild(oChild);
		 */
		return ok;
	}

	private DbRecord getDbRecord(String tableName) {
		return new InitialRecord(this.userPro).getDbRecord(this
				.charCase(tableName));
	}

	public void removeChild(String childName) {
		this.childTable.remove(this.charCase(childName));
		this.removeEffectTable(this.charCase(childName));
	}

	public void refreshEffectTable(String fieldName) {
		Vector vTemp;
		String child;
		vTemp = (Vector) this.effectTable.get(fieldName);
		if (vTemp != null) {
			for (int i = 0; i < vTemp.size(); i++) {
				child = (String) vTemp.elementAt(i);
				// logger.info(child);
				this.refreshChild(child);
			}
		}
	}

	public void removeAllChild() {
		this.childTable.clear();
		this.effectTable.clear();
	}

    public boolean foundData() {
		boolean flag = true;
		String NotFoundChildTable = "";
		try {
			if (requiredFound) {
				if (this.foundData) {
					for (Enumeration enumeration = this.childTable.keys(); (flag && enumeration
							.hasMoreElements());) {
						ChildManager ch = (ChildManager) this
								.getChild((String) enumeration.nextElement());
						if (ch.getRequiredFound()) {
							flag = ch.foundData();
						} else {
							flag = true;
						}
						if (!flag) {
							NotFoundChildTable += ":"+ch.getActualName()+":";
						}
					}
					if (!flag) {
						if (this.getUProfile().containsKey("processID")) {
							MyLog.error(this, "Not found data (requiredFound) :"+this.getActualName()+":"+this.getKeyCondition()+NotFoundChildTable);
						} else {
							MyLog.warn(this, "Not found data (requiredFound) :"+this.getActualName()+":"+this.getKeyCondition()+NotFoundChildTable);
						}
					}
				}
			} 
            // Start RequireFoundTable
            else if (this.getRequireFoundTable() != null) {
                Vector childR = this.getRequireFoundTable();
                if (this.foundData) {
                    for (int i=0;i<childR.size();i++) {
                        String tablename = (String) childR.get(i);
                        ChildManager ch = (ChildManager) this.getChild(tablename);
//						if (ch.getRequiredFound()) {
							flag = flag && ch.foundData();
//						}
                    }
                }
            }
            // End RequireFoundTable
            
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		// logger.info("requiredFound >" + requiredFound + "< this.foundData >"
		// + this.foundData + "< flag > " + flag + "< Table >" + this.tableName
		// + "<");
		return this.foundData & flag;
	}
    
	public void setFoundData(boolean found) {
		this.foundData = found;
	}
    
	public void refreshConditionChild(String childName) {
		try {
			ChildManager ch = (ChildManager) this.childTable.get(this
					.charCase(childName));
			if (ch != null) {
				Relation oRelation = ch.getRelation(this.tableName);
				if (oRelation == null) {
					oRelation = this.getRelation(ch.getActualName());
				}
				if (oRelation != null) {
					ch.setCondition(oRelation.GenCondtion((DbRecord) this));
				}
			}
		} catch (Exception e) {
			MyLog.error(this," childName :"+childName);
			MyLog.error(this, e);
		}
	}

	public void refreshConditionChild() {
		for (Enumeration enumeration = this.childTable.keys(); enumeration
				.hasMoreElements();) {
			this.refreshConditionChild((String) enumeration.nextElement());
		}
	}

	public ChildManager getChild(String childName) {
		ChildManager ch;
		ChildManager buff = null;
		try {
			buff = (ChildManager) childTable.get(this.charCase(childName));
			for (Enumeration enumeration = this.childTable.keys(); (enumeration.hasMoreElements() && buff == null);) {
				ch = (ChildManager) this.childTable.get((String) enumeration.nextElement());
				buff = ch.getChild(this.charCase(childName));
			}
		} catch (Exception e) {
			MyLog.error(this," childName :"+childName);
			MyLog.error(this, e);
		}
		return buff;
	}

	public void clearChild() {
		String buff = "";
		ChildManager ch;
		Relation oRelation;
		// logger.info("Child size: "+this.childTable.size());
		try {
			for (Enumeration enumeration = this.childTable.keys(); enumeration
					.hasMoreElements();) {
				ch = (ChildManager) this.childTable.get((String) enumeration
						.nextElement());
				// logger.info("Table: "+ch.getTableName());
				oRelation = (Relation) ch.getRelation(this.getActualName());
				if (oRelation == null) {
					oRelation = (Relation) this.getRelation(ch.getActualName());
				}
				if (oRelation != null) {
					ch.setCondition(oRelation.GenCondtion((DbRecord) this));
					ch.clearField();
					ch.clearChild();
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}

	public DbRecord getRecordManager(String childName) {
		return (DbRecord) this.getChild(childName);
	}

	public DbTable getTableManager(String childName) {
		return (DbTable) this.getChild(childName);
	}

	public String listChild() {
		StringBuilder buff = new StringBuilder();
		try {
			ChildManager ch;
			for (Enumeration enumeration = this.childTable.keys(); enumeration
					.hasMoreElements();) {
				ch = (ChildManager) this.childTable.get((String) enumeration
						.nextElement());
				buff.append(ch.getActualName());
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		return buff.toString();
	}

	public String listRelation() {
		String buff = "";
		for (Enumeration enumeration = this.relationInfo.keys(); enumeration
				.hasMoreElements();) {
			buff += (String) enumeration.nextElement();
		}
		return buff;
	}

	public void moveToHis() throws RemoteException {
	}

	public void setAutoRefresh(byte status) {
		this.autoRefresh = status;
	}

	public byte getAutoRefresh() {
		return this.autoRefresh;
	}

	public boolean containsReference(String tableName) {
		return this.referenceTable.containsKey(this.charCase(tableName));
	}

	protected boolean containsField(String field) {
		return this.getFieldList().indexOf(field) != -1;
	}

	public Object getReferenceTable(String tableName) {
		if (this.referenceTable.containsKey(this.charCase(tableName))) {
			return this.referenceTable.get(this.charCase(tableName));
		} else {
			return null;
		}
	}

	public boolean removeReference(String tableName) {
		if (this.referenceTable.containsKey(this.charCase(tableName))) {
			this.referenceTable.remove(this.charCase(tableName));
			return true;
		} else {
			return false;
		}
	}

	public void removeAllReference() {
		this.referenceTable.clear();
	}

	public void refreshReference(String tableName) {
		Relation oRelation;
		RecordManager rm = (RecordManager) this.referenceTable.get(this
				.charCase(tableName));
		if (rm != null) {
			oRelation = (Relation) rm.getRelation(this.tableName);
			if (oRelation == null) {
				oRelation = (Relation) this.getRelation(rm.getActualName());
			}
			// logger.info("myRecord.refreshReference: Relation=" + oRelation);
			if (oRelation != null) {
				rm.setCondition(oRelation.GenCondtion((DbRecord) this));
				rm.refresh();
				// rm.refreshReference();
			}
		}
	}

	public void refreshReference() {
		for (Enumeration enumeration = this.referenceTable.keys(); enumeration
				.hasMoreElements();) {
			this.refreshReference((String) enumeration.nextElement());
		}
	}

	public void clearReference(String tableName) {
		RecordManager rm = (RecordManager) this.referenceTable.get(this
				.charCase(tableName));
		rm.clearField();
		rm.clearAllReference();
	}

	public void clearAllReference() {
		for (Enumeration enumeration = this.referenceTable.keys(); enumeration
				.hasMoreElements();) {
			clearReference((String) enumeration.nextElement());
		}
	}

	public String getDescription() {
		return description;
	}

	// ********************************************
	// Group Field Manager Method
	// ********************************************
	public int fieldGroupCount() {
		return this.fieldGroup.size();
	}

	public Vector getAllFieldGroupName() {
		FieldGroup gf;
		Vector v = new Vector();
		for (Enumeration enumeration = this.fieldGroup.keys(); enumeration
				.hasMoreElements();) {
			gf = (FieldGroup) this.fieldGroup.get((String) enumeration
					.nextElement());
			v.add(gf);
		}
		return v;
	}

	public void putFieldGroup(FieldGroup gf) {
		this.fieldGroup.put(gf.getCode(), gf);
	}

	public FieldGroup getFieldGroup(String groupCode) {
		Object o;
		FieldGroup gf = new FieldGroup("", "", "*");
		o = this.fieldGroup.get(groupCode);
		if (o != null) {
			gf = (FieldGroup) o;
		}
		return gf;
	}

	public String getLinkFieldChild(String childName) {
		String buff = "";
		Relation oRelation = this.getRelation(childName);
		if (oRelation != null) {
			buff = oRelation.getFieldtListChild();
		}
		return buff;
	}

	public String getLinkFieldParent(String childName) {
		String buff = "";
		Relation oRelation = this.getRelation(childName);
		if (oRelation != null) {
			buff = oRelation.getFieldListParent();
		}
		return buff;
	}
	
	public boolean setColumn(Vector fieldList) {
		PropertyRec newFM = new PropertyRec();
		newFM.setUProfile(this.getUProfile());
		HashMap hm = (HashMap) StaticProperties.systemField.get("systemfield");
		FieldManager m=null;
		this.rReferLangOff();
		this.fieldCount = 0;
		this.aField = new Vector();
//		this.mField=new Vector();
		this.field =new StringBuilder();
		if (!fieldList.contains("companyid")) {
			if (this.normalField.containsKey("companyid")) {
				fieldList.addElement("companyid");
			}
		}
		for (int i = 0; i < this.maindatoryField.size(); i++) {
			if (!fieldList.contains(this.maindatoryField.get(i))) {
				fieldList.addElement(this.maindatoryField.get(i));
			}	
		}
		for (int i = 0; i < fieldList.size(); i++) {
			String fieldName = fieldList.get(i).toString();
			if (!this.aField.contains(fieldName)) {
				if (this.normalField.containsKey(fieldName)) {
					if (this.mf.containsKey(fieldName)) {
						m = (FieldManager)this.mf.get(fieldName);
						newFM.put(fieldName, m);
					} else {
						m = this.createField(fieldName,(HashMap)this.normalField.get(fieldName));
						newFM.put(fieldName, m);
					}
					m.setWorking(true);
					if (m.getUsedFor() == '1') {
						this.addFieldList(this.charCase(fieldName));
					}
				} else {
					if (this.SystemField.contains(fieldName)) {
						if (this.mf.containsKey(fieldName)) {
							m = (FieldManager)this.mf.get(fieldName);
							newFM.put(fieldName, m);
						} else {
							m = this.createField(fieldName,(HashMap)hm.get(fieldName));
							newFM.put(fieldName, m);
						}
						m.setWorking(true);
						if (m.getUsedFor() == '1') {
							this.addFieldList(this.charCase(fieldName));
						}
					}/* else {
						System.out.println(this+ "Error set column, could not found any field! : "+fieldName);
					}*/
				}
				if(m!=null){
//					mField.add(m);
					m.setUProfile(this.userPro);
					m.setRecord(this);
					m.loadSecurity();
				}
			}
		}
		

		for (int i = 0; i < this.SystemField.size(); i++) {
			String fieldName = this.SystemField.get(i).toString();
			/*if (this.mf.containsKey(fieldName)) {
				m = (FieldManager)this.mf.get(fieldName);
				newFM.put(fieldName, m);
				this.field = this.addFieldList(this.field, this.charCase(fieldName));
			}else
			*/
			if (this.mf.containsKey(fieldName)) {
				m = (FieldManager)this.mf.get(fieldName);
				newFM.put(fieldName.toLowerCase(), m);
				this.addFieldList(this.charCase(fieldName));
			} else {
				m = this.createField(fieldName,(HashMap)hm.get(fieldName));
				if (m == null) { 
					MyLog.error(this, "Couldn't create field  :"+fieldName);
				} else {
					newFM.put(fieldName, m);
					this.addFieldList(this.charCase(fieldName));
				}
			}
			if (m != null) { 
//				mField.add(m);
				m.setWorking(true);
				m.setUProfile(this.userPro);
				m.setRecord(this);
				m.loadSecurity();
			}
		}
		
		if (this.referLang)
			this.rReferLangOn();
		else
			this.rReferLangOff();		
		this.mf = newFM;
		
		
//		this.setUProfileField();
//		this.setParentField();
//		this.setSecuritfield();
		
//		this.searchInfo = this.initField("String", "search_info", 100, 100,"Search info");
//		searchInfo.setWorking(true);
//		searchInfo.set("");
		return true;

	}

	public boolean setColumn(FieldGroup fg) {
		if (fg != null) {
			return this.setColumn(fg.getFieldList());
		}
		return false;
	}

	private Vector getAllColumn(){
		Vector Allcolumn=(Vector)AllFieldName.clone();
		for(int c=0;c<SystemField.size();c++){
			Allcolumn.add(SystemField.get(c));
		}
		return Allcolumn;
	}
	
	public boolean setColumn(String columList) {
		String columnList;
		columnList = columList.toLowerCase().trim();
		if (columnList.equals("*")) {			
			this.setColumn(getAllColumn());
			//this.setColumn(this.AllFieldName);
		} else {
			Vector vf = new Vector();
			for (StringTokenizer token = new StringTokenizer(columnList,","); token.hasMoreTokens();) {
				String tmpField = token.nextToken().trim().toLowerCase();
				vf.add(tmpField);
			}
			this.setColumn(vf);
		}
		 /*
         * Start -*****-check column to user from app to cscindextable
         */
        if(StaticProperties.checkIndextable){
                CscIndexTable ci=new CscIndexTable(this.getUProfile(),this.tableName,columnList);
                ci.save();
        }
        /*
         * End -****-check column to user from app to cscindextable
         */               
		return true;	
		/*
		 * try { Class c = Class.forName("com.csc.library.config.FieldConfig");
		 * java.lang.reflect.Method mx = c.getDeclaredMethod("setColumnConfig",
		 * new Class[] { DbRecord.class, String.class }); columList = (String)
		 * mx.invoke(c.newInstance(), new Object[] { this, columList }); } catch
		 * (Exception ex) { ex.printStackTrace(); }
		 */
/*
		String tmpField;
		boolean ok = true;
		FieldManager m;
		String columnList;
		StrReplace rp = new StrReplace();
		columnList = columList.toLowerCase();
		columnList = rp.replace(columnList, " ", "");
		if (columnList.equals("*")) {
			this.fieldCount = 0;
			this.field = "";
//			this.allFieldName = "";
//			this.AllFieldName = new Vector();
			for (Iterator it = mf.keySet().iterator(); it.hasNext();) {
				m = (FieldManager) mf.get(it.next());
				m.setWorking(true);
				if (m.getUsedFor() == '1') {
					this.field = this.addFieldList(this.field, m.getName());
					this.fieldCount++;
//					this.allFieldName = this.addFieldList(this.allFieldName, m.getName());
//					this.AllFieldName.add(m.getName());
				}
			}
		} else {
			StringTokenizer token1 = new StringTokenizer(columnList, ",");
			String buff = "";
			Vector OKfield = new Vector();
			while (token1.hasMoreTokens()) {
				tmpField = token1.nextToken();
				if (this.mf.get(tmpField) != null) {
					OKfield.add(tmpField);
				}
			}
			columnList = buff;
			if (ok) {
				this.fieldCount = 0;
				this.field = "";
//				this.allFieldName = "";
//				this.AllFieldName = new Vector();
				for (Iterator it = mf.keySet().iterator(); it.hasNext();) {
					m = (FieldManager) mf.get(it.next());
					m.setWorking(false);
					if (m.getUsedFor() == '1') {
//						this.allFieldName = this.addFieldList(this.allFieldName, m.getName());
						this.AllFieldName.add(m.getName());
					}
				}
				for (StringTokenizer token = new StringTokenizer(columnList,","); token.hasMoreTokens() && ok;) {
					tmpField = token.nextToken().trim();
					m = (FieldManager) this.mf.get(tmpField);
					m.setWorking(true);
				}
				// why I did not do the same as this this.field = columnList
				// because when I use enumerationeration (mf) for saving data.
				// Sequence of Data and Sequence of field name will be mismacth.
				for (Iterator it = mf.keySet().iterator(); it.hasNext();) {
					m = (FieldManager) mf.get(it.next());
					if (m.getUsedFor() == '1') {
						if (m.isWorking()) {
							this.field = this.addFieldList(this.field, m
									.getName());
							this.fieldCount++;
						}
					}
				}
			}
		}
		if (ok) {
			this.aField = new String[this.fieldCount];
			int i = 0;
			for (StringTokenizer token = new StringTokenizer(this.field, ","); token	.hasMoreTokens();) {
				this.aField[i] = token.nextToken().trim();
				i++;
			}
		}

		
		if (columList != null && !columList.equals("")
				&& columList.indexOf("actorid") == -1
				&& columList.indexOf("ACTORID") == -1) {
//			this.allFieldName = this.addFieldList(this.allFieldName, "actorid");
			this.AllFieldName.add("actorid");
		}
        
		return ok;
*/		
	}

	public boolean addChildColumn(String childName) {
		String buff = this.getLinkFieldParent(childName);
		if (buff != null) {
			return this.addColumn(buff);
		}
		return false;
	}

	public void setFieldGroupColumn(String groupCode) {
		this.setColumn(this.getFieldGroup(groupCode));
	}

	public boolean addColumn(String columnList) {
		return this.setColumn(this.getFieldList() + "," + columnList.trim());
	}

	public void setRefreshModel(byte model) {
		if (model == 0 || model == 1) {
			this.refreshModel = model;
		}
	}

	public void appendFrom(DbRecord rec) {
		try {
			String fieldName;
			if (this.getListKey().equals(rec.getListKey())) {
				for (int i = 0; i < this.aField.size(); i++) {
					fieldName = this.aField.get(i).toString();
					this.set(fieldName, rec.getString(fieldName));
				} // for
				this.save();
			}
		} catch (Exception ex) {
			MyLog.error(this, ex);
		}
	}

	public void appendFrom(DbInquiry inq) {
		try {
			for (; inq.next();) {
				this.appendFrom(inq.getCurrentDbRecord());
			}
		} catch (Exception ex) {
			MyLog.error(this, ex);
		}
	}

	public void appendFrom(DbTable tab) {
		try {
			tab.first();
			do {
				// this.appendFrom(tab.getCurrentRecordManager());
				// REMARK------------------PETCH
				tab.next();
			} while (!tab.eof());
		} catch (Exception ex) {
			MyLog.error(this, ex);
		}
	}

	/**
	 * Set Require Found Value in all Child Table
	 * <p>
	 * Call private void setRequiredAllChild(childManager childM,boolean
	 * require)
	 * 
	 * @param require
	 */
	public void setAllRequiredFound(boolean require) {
		ChildManager child;
		this.setRequiredFound(require);
		try {
			for (Enumeration enu = this.getChildTable().elements(); enu
					.hasMoreElements();) {
				child = (ChildManager) enu.nextElement();
				child.setRequiredFound(require);
				this.setRequiredAllChild(child, require);
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}

	/**
	 * Set Require Found Value in all Child Table
	 * 
	 * @param childM
	 *            Child Manger (Child Table)
	 * @param require
	 *            (true/false)
	 */
	private void setRequiredAllChild(ChildManager childM, boolean require) {
		ChildManager child;
		try {
			for (Enumeration enu = childM.getChildTable().elements(); enu
					.hasMoreElements();) {
				child = (ChildManager) enu.nextElement();
				child.setRequiredFound(require);
				this.setRequiredAllChild(child, require);
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}

	/**
	 * set User Profile to all Child in Relation Call Methold private void
	 * setAllUProfile(childManager childM,uProfileManager uPro)
	 * 
	 * @param uPro
	 */
	public void setAllUProfile(UProfile uPro) {
		ChildManager child;
		this.setUProfile(uPro);
		try {
			for (Enumeration enu = this.getChildTable().elements(); enu
					.hasMoreElements();) {
				child = (ChildManager) enu.nextElement();
				child.setUProfile(uPro);
				this.setAllUProfile(child, uPro);
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}

	/**
	 * set User Profile to All Child
	 * 
	 * @param childM
	 *            Child Manager
	 * @param uPro
	 *            User Profile
	 */
	private void setAllUProfile(ChildManager childM, UProfile uPro) {
		ChildManager child;
		try {
			for (Enumeration enu = childM.getChildTable().elements(); enu
					.hasMoreElements();) {
				child = (ChildManager) enu.nextElement();
				child.setUProfile(uPro);
				this.setAllUProfile(child, uPro);
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}

	/**
	 * Set User Profile to Record
	 * 
	 * @param uPro
	 *            User Profile
	 */
	public void setUProfile(UProfile uPro) {
		super.setUProfile(uPro);
		this.appname = uPro.get("appname").toString();
		this.language = uPro.get("lang").toString();
	}

	/**
	 * Set User Profile to Field for Security use
	 */
	private void setUProfileField() {
		FieldManager m;
		for (int i = 0; i < this.aField.size(); i++) {
			m = (FieldManager) mf.get((String)this.aField.get(i));
			m.setUProfile(this.userPro);
		}
	}

	/**
	 * Case ot set Value for Search and want Field Security
	 * 
	 * @param fieldNmae
	 * @param value
	 * @return
	 */
	public int searchForSecurity(String fieldName, String value) {
		FieldManager m;
		String buff = "";
		for (int i = 0; i < this.aField.size(); i++) {
			m = (FieldManager) mf.get(this.aField.get(i));
			if (m.getSecurity()) {
				buff += m.getName() + ",";
			}
		}
		this.set(fieldName, value);
		this.setColumn(buff);
		return this.search();
	}

	public Vector getAllKey() {
		return this.allKey;
	}

	/**
	 * It's new Class Table for methold Security.Update.
	 * <p>
	 * recordManager give data to Select Found
	 * 
	 * @param table
	 *            Table Name
	 * @return recordManger
	 */
	protected DbRecord newRecordUpdate(String table) {
		DbRecord rec = null;
		try {
			rec = this.getDbRecord(table);
		} catch (Exception ex) {
			// logger.info(ex);
		}
		return rec;
	}

	public void isChild() {
	}

	public void setProperties() {
		this.setAllField();
		this.setProperties(false);
	}
	
	private void setAllField() {
		String appName = "";
		if (this.userPro.containsKey("appname")) {
			appName = this.userPro.get("appname");
		}

		String rTable = this.tableName;
		MyHashMap pro = null;
		try {
			pro = (MyHashMap) ((MyHashMap) StaticProperties.proTable.get(rTable.toLowerCase()));
			this.key = new PropertyRec();
			this.AllFieldName = new Vector();
			this.SystemField = new Vector();
			this.normalField =(HashMap) pro.get("properties");
			this.maindatoryField =(Vector)pro.get("column_need"); 
			
			this.andCondition=(Vector)pro.get("andconditionbeforesave");
			this.orCondition=(Vector)pro.get("orconditionbeforesave");
			this.fieldBlob=(Vector)pro.get("fieldblob");
			this.fieldUpload=(Vector)pro.get("fieldupload");
			if (pro.get("aliasfield")!=null) 	
				this.aliasField =(HashMap) pro.get("aliasfield"); 
			Iterator itField = null;
			HashMap PF; 
			String key;
			String fName="";
			
			Vector sysField = (Vector) pro.get("systemfield");				
			if (sysField.get(0).toString().equals("*")) {
				HashMap hm = (HashMap) StaticProperties.systemField.get("systemfield");
				itField = hm.keySet().iterator();
				while (itField.hasNext()) {
					 fName = itField.next().toString();
					 this.SystemField.add(fName.trim());
				}
			} else {
				if(!sysField.get(0).toString().equalsIgnoreCase("NONE"))
					this.SystemField=(Vector)sysField.clone();
			}
			
			this.allKey=(Vector) pro.get("maindatoryfield");
			this.key=(PropertyRec) pro.get("indexkey");
			this.key.setUProfile(this.getUProfile());
			this.AllFieldName=(Vector) pro.get("allfieldname");		
			this.setColumn("*");
		}catch(Exception ex){
			MyLog.error(this, "Please check Table [" + this.tableName + "] Protable or Class  ");
			MyLog.error(this, ex);			
		}
	}
	

	public void setVMetaData(ConfigMetadata vm) {
		this.vMetaData = vm;
	}

	public void setProperties(boolean loadComponent) {
		this.vMetaData = new ConfigMetadata(this.userPro);
		this.vMetaData.process();
		String appName = "";
		if (this.userPro.containsKey("appname")) {
			appName = this.userPro.get("appname");
		}

		String rTable = this.tableName;
		MyHashMap pro = null;
		ComponentField cf=null;

		if (pro == null) {
			pro =(MyHashMap) ((MyHashMap) StaticProperties.proTable.get(this.tableName.toLowerCase()));
			cf=(ComponentField)((HashMap)pro.get("properties")).get("cfield");
		}

		this.editCheck = ((String) pro.get("editcheck")).trim();
		// add for workfow active config
		String globalwfactive = this.vMetaData.getWfActive();
		if (globalwfactive.equalsIgnoreCase("true")) {
			this.wfactive = ((String) pro.get("wfactive")).trim();
		} else {
			this.wfactive = "false";
		}
		this.wfkey = (pro.get("wfkey") != null) ? (((String) pro.get("wfkey"))
				.trim()) : "";
		this.documentno = (pro.get("documentno") != null) ? 
				((String) pro.get("documentno")).trim() : "";
		this.descEng =	(String) pro.get("desceng");
		this.descThai = (String) pro.get("descthai");
		if ((this.userPro != null) && (this.userPro.get("lang") != null)&& (!this.userPro.get("lang").equalsIgnoreCase("eng"))) 
				this.description = this.descThai;
		 else 
				this.description = this.descEng;

		this.setSecurity((String) pro.get("security"));
		this.mainHelp = (String) pro.get("mainhelp");
		this.referHelp = (String) pro.get("referhelp");
		this.mainKey = (String) pro.get("mainkey");
		
		this.setRelation((HashMap) ((HashMap) pro.get("relation")).clone());
		this.groupField = (HashMap) ((HashMap) pro.get("fieldgroup")).clone();
		this.loadHelp(loadComponent);
	}
	
	public void loadHelp(boolean loadComponent){
		if (loadComponent) {
			FieldManager f;
			for (int i = 0; i < this.aField.size(); i++) {
				f= this.getField(this.aField.get(i).toString()); 
//				f= this.getField(i);comment by pas test getField(int)
				if (!this.setMainHelpProperties(f))
					this.setReferHelpProperties(f);
			}
		}
	}
	
	
	protected FieldManager initField(String type, String name, int width,
			int decimal, String description) {
		FieldManager fieldM = null;
		try {
			Class s = Class.forName("com.csc.library.database.Field" + type);
			Constructor c = s.getConstructor(new Class[] {
					java.lang.String.class, java.lang.Integer.class,
					java.lang.Integer.class, java.lang.String.class });
			fieldM = (FieldManager) c.newInstance(new Object[] { name,
					new Integer(width), new Integer(decimal), description });
			fieldM.setUProfile(this.userPro);
			StrReplace str = new StrReplace();
			fieldM.setType(str.replace(type, "Field", ""));
			fieldM.setWorking(true);
		} catch (Exception ex) {
			MyLog.error(this,"name :"+name+"type :"+type+"width :"+width+"decimal :"+decimal+"description :"+description);
			MyLog.error(this, ex);
		}
		return fieldM;
	}

	private void setRelation(HashMap rela) {
		if (!rela.isEmpty()) {
			Iterator it = rela.keySet().iterator();
			HashMap subRela;
			String relaName;
			Relation relation;
			while (it.hasNext()) {
				relaName = (String) it.next();
				subRela = (HashMap) rela.get(relaName);
				if (subRela != null) {
					relation = new Relation(this.charCase(relaName),
									(Vector) subRela.get("PARENT"), 
									(Vector) subRela.get("CHILD"), 
									(String) subRela.get("INSERTLEVEL"),
									(String) subRela.get("DELETELEVEL"), 
									(String) subRela.get("DEPENDLEVEL"),
									(String) subRela.get("RTABLENAME"),
									(String) subRela.get("MODULEDELETE"),
									(String) subRela.get("MODE"));
					this.putRelation(relation);
				}
			}
		}
	}

	protected String charCase(String stringData) {
		return stringData.toLowerCase();
	}


	public Vector listNameF(String propertiesName) {
		Iterator it = this.mf.keySet().iterator();
		String nameField = "";
		Vector box = new Vector();
		while (it.hasNext()) {
			nameField = (String) it.next();
			if (this.getField(nameField).getProperty().containsKey(
					this.charCase(propertiesName))) {
				box.add(nameField);
			}
		}
		return box;
	}
	

	/**
	 * commant by pas test getField(int)
	 * 
	public Vector listNameF(String propertiesName) {
		FieldManager Field = null;
		Vector box = new Vector();
		for (int i=0;i<this.mf.size();i++) {
			Field = (FieldManager)this.mf.get(i);
			if (Field.getProperty().containsKey(this.charCase(propertiesName))) {
				box.add(Field.getName());
			}
		}
		return box;
	}
	*
	**/
	
	

	private void setParentField() {
		FieldManager m;
		for (int i = 0; i < this.aField.size(); i++) {
			m = (FieldManager) mf.get((String)this.aField.get(i));
			m.setRecord(this);
		}
	}

	private void setDefaultField() {
		FieldManager m;
		for (int i = 0; i < this.aField.size(); i++) {
			this.setDefaultField(this.aField.get(i).toString());
		}
	}

	public void setDefaultField(String fieldName) {
		FieldManager m;
		m = (FieldManager) mf.get(fieldName);
		m.setDefault();
	}

	private void setSecuritfield() {
		FieldManager m;
		for (int i = 0; i < this.aField.size(); i++) {
			m = (FieldManager) mf.get((String)this.aField.get(i));
			m.loadSecurity();
		}
	}

	public Vector listFieldPro(String propertiesName) {
		Iterator it = this.mf.keySet().iterator();
		String nameField = "";
		Vector box = new Vector();
		while (it.hasNext()) {
			nameField = (String) it.next();
			// ball edit 13-02-44
			if ((this.getField(nameField).getProperty().containsKey(this
					.charCase(propertiesName)))
					&& (this.getField(nameField).getProperty().get(
							this.charCase(propertiesName)).equals(""))) {
				box.add(nameField);
			}
		}
		return box;
	}
	
	/***
	 * 
	 * @param propertiesName
	 * @return
	 * comment by pas test getField(int)
	public Vector listFieldPro(String propertiesName) {
		FieldManager field;
		Vector box = new Vector();
		for(int i=0;i<this.mf.size();i++) {
			field = (FieldManager)this.mf.get(i);
			if ((field.getProperty().containsKey(this.charCase(propertiesName)))&& (field).getProperty().get(this.charCase(propertiesName)).equals("")) {
				box.add(field.getName());
			}
		}
		return box;
	}	
	**/

	public String listField(String propertiesName) {
		Iterator it = this.mf.keySet().iterator();
		String nameField = "";
		String list = "";
		while (it.hasNext()) {
			nameField = (String) it.next();
			if (this.getField(nameField).getProperty().containsKey(this.charCase(propertiesName))) {
				// wut edit 11/10/03
				// ball Re_edit wuit 21-10-03
				if(this.getField(nameField).getProperty().get(this.charCase(propertiesName)).toString().equalsIgnoreCase("true")){
					if(((ComponentManager)this.getField(nameField)).getComType().equalsIgnoreCase("tel")){
						list = list + nameField+"_view" + ",";
					}else{
						if(((ComponentManager)this.getField(nameField)).getComType().equalsIgnoreCase("mobile")){
							list = list + nameField+"_view" + ",";
						}else{
							list = list + nameField + ",";
						}
						
					}
					
				}
			}
		}
		return list;
	}
	
	/**
	 * 
	 * @param propertiesName
	 * @return
	 *
	 *comment by pas test getField(int) 
	 *
	
	
//	public String listField(String propertiesName) {
//		FieldManager field=null;
//		String list = "";
//		for(int i=0;i<this.mf.size();i++){
//			field = (FieldManager) this.mf.get(i);
//			if (field.getProperty().containsKey(this.charCase(propertiesName))) {
//				if(field.getProperty().get(this.charCase(propertiesName)).toString().equalsIgnoreCase("true")){
//					if(((ComponentManager)field).getComType().equalsIgnoreCase("tel")){
//						list = list + field.getName()+"_view" + ",";
//					}else{
//						if(((ComponentManager)field).getComType().equalsIgnoreCase("mobile")){
//							list = list + field.getName()+"_view" + ",";
//						}else{
//							list = list + field.getName() + ",";
//						}
//						
//					}
//					
//				}
//			}
//		}
//		return list;
//	}
**/

	public String listFieldValue(String propertiesName) {
		Iterator it = this.mf.keySet().iterator();
		String nameField = "";
		String value = "";
		while (it.hasNext()) {
			nameField = (String) it.next();
			if (this.getField(nameField).getProperty().containsKey(
					this.charCase(propertiesName))) {
				value += this.getField(nameField).getProperty(propertiesName);
				if (it.hasNext())
					value += ",";
			}
		}
		return value.toUpperCase();
	}
	/**
	 * 
	 * 
	 *
	 * comment by pas test getField(int)
	 *
	
	public String listFieldValue(String propertiesName) {
		FieldManager field;
		String nameField = "";
		String value = "";
		for(int i=0;i<this.mf.size();i++) {
			field = (FieldManager)this.mf.get(i);
			if (field.getProperty().containsKey(this.charCase(propertiesName))) {
				value += field.getProperty(propertiesName);
				if (i<this.mf.size()-1)
						value += ",";
			}
		}
		return value.toUpperCase();
	}	
	**/
	public void referLangOn() {
		this.mf.referLangOn();
		this.setChildReferLang(true);
		/** *********ball edit 19-03-04********* */
		this.referLang = true;
		/** ******************** */
	}

	public void referLangOff() {
		this.mf.referLangOff();
		this.setChildReferLang(false);
		/** *********ball edit 19-03-04********* */
		this.referLang = false;
		/** ******************** */
	}

	public void rReferLangOn() {
		this.mf.referLangOn();
		this.setChildReferLang(true);
	}

	public void rReferLangOff() {
		this.mf.referLangOff();
		this.setChildReferLang(false);
	}

	private void setChildReferLang(boolean typeOn) {
		try {
//			Relation oRelation;
			String childName;
			ChildManager ch=null;
			for (Enumeration enumeration = this.childTable.keys(); enumeration.hasMoreElements();) {
				childName = ((String) enumeration.nextElement());
//				oRelation = this.getRelation(this.charCase(childName));
//				if (oRelation != null) {
//					ChildManager ch = (ChildManager) this.getChild(this.charCase(childName));
					ch = (ChildManager) this.childTable.get(childName);
					if (typeOn)
						ch.referLangOn();
					else
						ch.referLangOff();
//				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}

	public String getMainHelp() {
		return this.mainHelp;
	}

	public String getReferHelp() {
		return this.referHelp;
	}

	public String getMainkey() {
		return this.mainKey;
	}

	private boolean helpButtonOn(String comtype) {
		return (comtype.equalsIgnoreCase("text") || comtype
				.equalsIgnoreCase("textarea"));
	}

	private void setReferHelpProperties(FieldManager fm) {
		String tableName = fm.getRelation(), help = "";
		String comtype = fm.getComType();
		DbRecord db = null;
		try {
			if (tableName != null && !tableName.equals("")
					&& helpButtonOn(comtype)) {
				if (fm.getHelp().equals("")) {
					db = this.getRelationRecord(tableName);
					help = db.getReferHelp();
					fm.setHelp(help);
					fm.setHELP_RETURN_FIELD(true);
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}

	private boolean setMainHelpProperties(FieldManager fm) {
		String help = this.mainHelp;
		String mKey = this.mainKey;
		if (this.allKey.contains(fm.getName())
				&& fm.getName().equalsIgnoreCase(mKey)) {
			if (fm.getHelp().equals("")) {
				fm.setHelp(help);
			}
			return true;
		} else
			return false;
	}
	
	private DbRecord getRelationRecord(String table) throws Exception {
		DbRecord db = null;
//		if (this.isGlobal()) {
//			UProfile uprofileCenter = (UProfile) this.userPro.clone();
//			uprofileCenter.setSchemaName(new InitialEnvironment("GLOBAL").getValue("schema-name"));
//			uprofileCenter.setDbName(new InitialEnvironment("GLOBAL").getValue("db-name"));
//			if(this.param!=null)
//				db = new InitialRecord(uprofileCenter,this.param).getDbRecord(table, 'i');
//			else
//				db = new InitialRecord(uprofileCenter).getDbRecord(table, 'i');
//		} else{
//			if(this.param!=null)
//				db = new InitialRecord(this.userPro,this.param).getDbRecord(table, 'i');
//			else
//				db = new InitialRecord(this.userPro).getDbRecord(table, 'i');
//		}
		if(this.param!=null)
			db = new InitialRecord(this.userPro,this.param).getDbRecord(table, 'i');
		else
			db = new InitialRecord(this.userPro).getDbRecord(table, 'i');

		return db;
	}


	public boolean isGlobal() {
		String dbName = this.userPro.getDbName().trim();
		return dbName.equalsIgnoreCase(new InitialEnvironment("GLOBAL")
				.getValue("db-name"));
	}

	/*private void chkSalaryField(FieldManager fm) {
		String salary = this.userPro.get("salary");
		if (salary != null && salary.equals("0")) {
			if (fm.getProperty("salary") != null
					&& fm.getProperty("salary").equalsIgnoreCase("true")) {
				fm.setProperty("disable", "true");
			}
		}
	}*/

	public Object getObject(String objName) {
		return null;
	}

	public void refreshChild(String childName) {
		try {
			Relation oRelation = this.getRelation(this.charCase(childName));
			if (oRelation == null) { 
				oRelation = this.getRelation(this.getChild(this.charCase(childName)).getTableName());
			}
			if (oRelation != null) {
				ChildManager ch = (ChildManager) this.getChild(this.charCase(childName));
				ch.setCondition(oRelation.GenCondtion((DbRecord) this));		
				/*if (ch instanceof DbInquiry) {//  inquiry зӡ closeconnection ԴѭҶ inquiry child ҡ 1 record  nextchild Ѻ кзӡ close connection ͧ child   
					((DbInquiry) ch).closeConnection();
				}*/
				ch.refresh();				
				if (ch instanceof DbInquiry) {
                    ((DbInquiry) ch).next();                   
				}
			}
		} catch (Exception e) {
			MyLog.error(this," childName :"+childName);
			MyLog.error(this, e);
		}
	}

	public String getFilterChild(String childName) {
		String buff = "";
		try {
			Relation oRelation = this.getRelation(this.charCase(childName));
			if (oRelation == null) { 
				oRelation = this.getRelation(this.getChild(this.charCase(childName)).getTableName());
			}
			if (oRelation != null) {
				String s[] =  oRelation.GenCondtion((DbRecord) this);
			}
		} catch (Exception e) {
			MyLog.error(this," childName :"+childName);
			MyLog.error(this, e);
		}
		return buff;
	}

	public String getFilterChild() {
		String buff = "";
		try {
			for (Enumeration enumeration = this.childTable.keys(); enumeration
					.hasMoreElements();) {
				String chName = (String) enumeration.nextElement();
				ChildManager ch = (ChildManager) this.childTable.get(chName);
				ch.setParent((DbRecord)this);
				buff += this.getFilterChild(chName);
			}	
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		return buff;
	}

	public void refreshChild() {
		try {
//			if (this.keyOK()) {
				for (Enumeration enumeration = this.childTable.keys(); enumeration
						.hasMoreElements();) {
					String chName = (String) enumeration.nextElement();
					ChildManager ch = (ChildManager) this.childTable.get(chName);
					ch.setParent((DbRecord)this);
					this.refreshChild(chName);
				}
//			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
	}


	public boolean wfActive() {
		return Boolean.valueOf(this.wfactive).booleanValue();
	}

	protected void resetRelation(String tableName, String oFieldName,
			String nFieldName) {
		Relation re = this.getRelation(tableName);
		Vector chList = re.childField;
		int index = chList.indexOf(oFieldName);
		chList.add(index, nFieldName);
	}

	protected FieldManager initField(String name) {
		FieldManager fm = this.setProField(this.getFieldProperties(name), false);
		fm.setWorking(true);
		return fm;
	}

	private HashMap getFieldProperties(String fieldName) {
		HashMap hashField = new HashMap();
		HashMap fieldPro = new HashMap();
		String path = new InitialEnvironment("GLOBAL").getValue("config-dir")
				+ "VFIELD_" + this.tableName.toUpperCase() + ".xml";
		ReadXml rxml = new ReadXml(path);
		Element root = rxml.getRootElement();
		Element objField = root.getChild(fieldName.toUpperCase());
		hashField.put("NAME", fieldName);
		Iterator it = objField.getAttributes().iterator();
		Attribute att;
		while (it.hasNext()) {
			att = (Attribute) it.next();
			hashField.put(att.getName().toUpperCase(), att.getValue());
		}
		List list = objField.getChildren();
		it = list.iterator();
		Element subE = null;
		while (it.hasNext()) {
			subE = (Element) it.next();
			hashField.put(subE.getName(), subE.getText());
		}
		Element com = objField.getChild("COMPONENT");
		hashField.put("COMTYPE", com.getAttributeValue("type").trim());
		list = com.getChildren();
		it = list.iterator();
		Element subCom;
		while (it.hasNext()) {
			subCom = (Element) it.next();
			hashField.put(subCom.getName(), subCom.getText().trim());
		}
		fieldPro.put(fieldName, hashField);
		return fieldPro;
	}
	
	
	private FieldManager createField(String fName, HashMap pField) {
		String key;
		Iterator itPro, itField;
		String desc = "";
		FieldManager f = null;
		int width, decimal;
		ComponentField cfield;
		if ((pField.get("WIDTH") != null)
				&& (!pField.get("WIDTH").equals(""))) {
			width = Integer.parseInt((String) pField.get("WIDTH"));
		} else {
			width = 0;
		}
		if ((pField.get("DECIMAL") != null) && (!pField.get("DECIMAL").equals(""))) {
			decimal = Integer.parseInt((String) pField.get("DECIMAL"));
		} else {
			decimal = 0;
		}
		f = this.initField((String) pField.get("TYPE"), fName.toLowerCase(), width, decimal, desc);
		if(pField.get("KEY")!=null)
			f.setKey(((String)pField.get("KEY")).charAt(0));
		if(pField.get("TYPE").toString().equalsIgnoreCase("AutoNumber")){
			if(!AutoNumField.contains(fName.toLowerCase())){
				  AutoNumField.addElement(fName.toLowerCase());
			}
		}

		f.setEncrypt( new Boolean((String)pField.get("ENCRYPT")).booleanValue());
		f.setLog( new Boolean((String)pField.get("LOG")).booleanValue());
//		f.setVerify(new Boolean((String)pField.get("VERIFY")).booleanValue());
		f.setVerify(false);
		//System.out.println("f------>"+fName+"<---"+((String)pField.get("LANG")).charAt(0)+"<---");
		if((pField.get("LANG")==null)||(pField.get("LANG").equals(""))){
			f.setLang('A');
		}else{
			f.setLang(((String)pField.get("LANG")).charAt(0));
		}
		if(pField.get("FORMAT")!=null ){
			f.setFormat(pField.get("FORMAT").toString());
		}
		cfield=(ComponentField)pField.get("cfield");
		f.setProperty("cfield",(Object)cfield);
		String appname=this.getUProfile().get("appname");
		//set value default to field
		f.set_DEFAULT_ALT_ENG((String)pField.get("ALT_ENG")) ;
		f.set_DEFAULT_ALT_THAI((String)pField.get("ALT_THAI")) ;
		f.set_DEFAULT_COMTYPE((String)pField.get("COMTYPE")) ;
		f.set_DEFAULT_DEFAULTVALUE((String)pField.get("DEFAULTVALUE")) ;
		f.set_DEFAULT_DESC_ENG((String)pField.get("DESC_ENG")) ;
		f.set_DEFAULT_DESC_THAI((String)pField.get("DESC_THAI")) ;
		//end set value default to field

		f.initField(this.getUProfile());
		
		if((String)pField.get("RELATION")!=null)
		f.setRelation((String)pField.get("RELATION"));
		
		f.setType((String)pField.get("TYPE"));
		
		itPro = pField.keySet().iterator();
		String removeList[]={"NAME","COMPONENT","RELATION","WIDTH","KEY","ENCRYPT","LOG","VERIFY","LANG","DESC_THAI","DESC_ENG","TYPE","ALT_THAI","ALT_ENG","COMTYPE","DEFAULTVALUE"} ;
		boolean check = false;
		while (itPro.hasNext()) {

			check = false;
			key = (String) itPro.next();
			for(int i = 0;i<removeList.length;i++){
				if(removeList[i].equals(key)){
					check = true;
					break;
				}
			}
			if(!check&&!key.equalsIgnoreCase("cfield")){
				Vector vrefer;
				f.setProperty(key, (String) pField.get(key));
				if (key.equalsIgnoreCase("REFER_DATA")) {
					String tmp = (String) pField.get(key);
					String table = tmp.substring(0, tmp.indexOf("."))
							.toLowerCase();
					String field = f.getName()+ "$"+ tmp.substring(tmp.indexOf(".") + 1, tmp.length()).toLowerCase();
					if (this.referField.containsKey(table)) {
						vrefer=(Vector)this.referField.get(table);
						if(!vrefer.contains(field)){
							vrefer.addElement(field);
						}
						this.referField.put(table, vrefer);
					} else{
						vrefer=new Vector();
						vrefer.addElement(field);
						this.referField.put(table, vrefer);
					}
				}
			}
		}
		if (f.getProperty("encrypt").equalsIgnoreCase("true")) {
			f.setProperty("verify", "false");
		}
		f.setDefault();
		return f;
	}
	
	private FieldManager setProField(HashMap proField, boolean add) {
		String key;
		boolean mfEmpty = true;
		Iterator itPro, itField;
		HashMap pField = null;
		String desc = "";
		FieldManager f = null;
		String fName = "";
		int width, decimal;
		Vector vrefer=new Vector();
		/*
		 * if (this.mf.isEmpty()) { itField = proField.keySet().iterator(); }
		 * else { itField = this.mf.keySet().iterator(); mfEmpty = false; }
		 */
		itField = proField.keySet().iterator();
		while (itField.hasNext()) {
			fName = (String) itField.next();
			pField = (HashMap) proField.get(fName);
			if (mfEmpty) {
				if ((pField.get("WIDTH") != null)
						&& (!pField.get("WIDTH").equals(""))) {
					width = Integer.parseInt((String) pField.get("WIDTH"));
				} else {
					width = 0;
				}
				if ((pField.get("DECIMAL") != null)
						&& (!pField.get("DECIMAL").equals(""))) {
					decimal = Integer.parseInt((String) pField.get("DECIMAL"));
				} else {
					decimal = 0;
				}
				f = this.initField((String) pField.get("TYPE"), fName
						.toLowerCase(), width, decimal, desc);
			} else {
				f = this.getField(this.charCase(fName));
			}
			if(pField.get("KEY")!=null)
				f.setKey(((String)pField.get("KEY")).charAt(0));
			
			f.setEncrypt( new Boolean((String)pField.get("ENCRYPT")).booleanValue());
			f.setLog( new Boolean((String)pField.get("LOG")).booleanValue());
			f.setVerify(new Boolean((String)pField.get("VERIFY")).booleanValue());
			
			f.setLang(((String)pField.get("LANG")).charAt(0));
			if(this.getUProfile().get("lang").equalsIgnoreCase("ENG"))
				f.setDescription((String)pField.get("DESC_ENG"));
			else
				f.setDescription((String)pField.get("DESC_THAI"));
			f.setDescriptionThai((String)pField.get("DESC_THAI"));
			f.setDescriptionEng((String)pField.get("DESC_ENG"));
			
			if(this.getUProfile().get("lang").equalsIgnoreCase("ENG"))
				f.setAlt((String)pField.get("ALT_ENG"));
			else
				f.setAlt((String)pField.get("ALT_THAI"));
			
			f.setAltEng((String)pField.get("ALT_ENG"));
			f.setAltThai((String)pField.get("ALT_THAI"));
			
			f.setComType((String)pField.get("COMTYPE"));
			
			if((String)pField.get("DEFAULTVALUE")!=null)
				f.setDefault((String)pField.get("DEFAULTVALUE"));
			if((String)pField.get("RELATION")!=null)
			f.setRelation((String)pField.get("RELATION"));
			
			f.setType((String)pField.get("TYPE"));
			itPro = pField.keySet().iterator();
			String removeList[]={"NAME","COMPONENT","RELATION","WIDTH","KEY","ENCRYPT","LOG","VERIFY","LANG","DESC_THAI","DESC_ENG","TYPE","ALT_THAI","ALT_ENG","COMTYPE","DEFAULTVALUE"} ;
			boolean check = false;
			while (itPro.hasNext()) {
				check = false;
				key = (String) itPro.next();
				for(int i = 0;i<removeList.length;i++){
					if(removeList[i].equals(key)){
						check = true;
						break;
					}
				}
				if(!check){
				f.setProperty(key, (String) pField.get(key));
				if (key.equalsIgnoreCase("REFER_DATA")) {
					String tmp = (String) pField.get(key);
					String table = tmp.substring(0, tmp.indexOf("."))
							.toLowerCase();
					String field = f.getName()
							+ "$"
							+ tmp.substring(tmp.indexOf(".") + 1, tmp.length())
									.toLowerCase();
					if (this.referField.containsKey(table)) {
						String fList = (String) this.referField.get(table);
//						vrefer=(Vector) this.referField.get(table);
//						if(!vrefer.contains(field))
//							vrefer.addElement(field);
//						this.referField.put(table, vrefer);
						this.referField.put(table, fList + "," + field);
					} else{
//						vrefer.addElement(field);
//						this.referField.put(table,vrefer);
						this.referField.put(table, field);
					}
				}
			}

			if (add) {
				this.mf.put(this.charCase(f.getName()), f);
				addFieldList(this.charCase(f.getName()));// add  fieldlist 
			}
			}
		}
//		this.searchInfo = this.initField("String", "search_info", 100, 100,"Search info");
//		searchInfo.setWorking(true);
//		searchInfo.set("");
		mfEmpty = false;
		return f;
	}

	/**
	 * addition for security 5/01/2005
	 */
	public void setSecurity(String sClass) {
		try {
			if (sClass != null && !sClass.equals("")) {
				RSecurityManager rm = (RSecurityManager) Class.forName(
						"com.csc.library.security." + sClass).newInstance();
				this.setSecurity(rm);
			} else {
				RSecurityManager rm = (RSecurityManager) Class.forName(
						"com.csc.library.security.MainRsecurity").newInstance();
				this.setSecurity(rm);
			}
		} catch (Exception e) {
			MyLog.error(this," sClass :"+sClass);
			MyLog.error(this, e);
		}
	}

	public void formatOn() {
		isFormat = true;
		this.setFieldFormat("on");
		this.setChildFormatOn();
		this.setChildFieldFormat("on");
	}

	public void formatOff() {
		isFormat = false;
		this.setFieldFormat("off");
		this.setChildFormatOff();
		this.setChildFieldFormat("off");
	}

	public void setFieldFormat(String type) {
		Iterator it = this.mf.keySet().iterator();
		while (it.hasNext()) {
			String key = (String) it.next();
			FieldManager fm = (FieldManager) this.mf.get(key);
			if (type.equals("on")) {
				fm.formatOn();
			} else {
				fm.formatOff();
			}
		}
//		FieldManager fm=null;
//		for(int i=0;i<mf.size();i++){
//			fm = (FieldManager) this.mf.get(i);
//			if(fm!=null){
//				if (type.equals("on")) {
//					fm.formatOn();
//				} else {
//					fm.formatOff();
//				}
//			}
//		}
		this.setChildFieldFormat(type);
	}

	private void setChildFormatOn() {
		Enumeration em = this.childTable.keys();
		while (em.hasMoreElements()) {
			String key = (String) em.nextElement();
			ChildManager ch = (ChildManager) this.childTable.get(key);
			if (ch instanceof DbTable)
				((DbTable) ch).formatOn();
			else if (ch instanceof DbRecord)
				((DbRecord) ch).formatOn();
		}
	}

	private void setChildFormatOff() {
		Enumeration em = this.childTable.keys();
		while (em.hasMoreElements()) {
			String key = (String) em.nextElement();
			ChildManager ch = (ChildManager) this.childTable.get(key);
			if (ch instanceof DbTable)
				((DbTable) ch).formatOff();
			else if (ch instanceof DbRecord)
				((DbRecord) ch).formatOff();
		}
	}

	private void setChildFieldFormat(String type) {
		Enumeration em = this.childTable.keys();
		while (em.hasMoreElements()) {
			String key = (String) em.nextElement();
			ChildManager ch = (ChildManager) this.childTable.get(key);
			if (ch instanceof DbTable)
				((DbTable) ch).setFieldFormat(type);
			else if (ch instanceof DbRecord)
				((DbRecord) ch).setFieldFormat(type);
		}
	}

	public void preInqNext() {
	}
	
	public void dependOn() {
		this.isDepend = true;
	}
	
	public void dependOff() {
		this.isDepend = false;
	}
	
	private void setSystemField(String field) {
		HashMap hm = (HashMap)((HashMap) StaticProperties.systemField.get("systemfield")).clone();
		HashMap temp = new HashMap();
		if (field != null && !field.equals("*")) {
			StringTokenizer stn = new StringTokenizer(field,",");
			while (stn.hasMoreTokens()) {
				String fName = stn.nextToken();
				temp.put(fName,hm.get(fName));
			}
		} else {
			temp = hm;
		}
		this.setProField((HashMap)temp.clone(),true);
	}
	
//	protected void initWfTransfer() {
//		HashMap hm = (HashMap)((HashMap) StaticProperties.systemField.get("wftransferfield")).clone();
//		HashMap temp = new HashMap();
//		Vector vt=new Vector(hm.keySet());
//		String fName="";
//		for(int i=0;i<vt.size();i++){
//			if(!this.mf.containsKey(fName)){
//				fName=(String)vt.get(i);
//				temp.put(this.charCase(fName),hm.get(fName));
//			}			
//		}
//		this.setProField((HashMap)temp.clone(),true);
//	}
	
	
	public Vector getSystemField() {
		return this.SystemField;
	}
	
	private void clearOldCondition() {
		this.oldCondition = "$$$";
	}
	
	public void setData(DbRecord r) {
		HashMap hm = (HashMap) StaticProperties.systemField.get("systemfield");
		Iterator it = this.mf.keySet().iterator();
		String data = null;
		Vector target = this.getArrayFieldList();
		Vector source = r.getArrayFieldList();
		while (it.hasNext()) {
			String key = (String) it.next();
			if (target.contains(key) && source.contains(key) && !hm.containsKey(key)) {
				FieldManager fm = (FieldManager) this.mf.get(key);
				try {
					data = r.getString(key);
				} catch (RemoteException e) {
					MyLog.error(this, e);
				}
				if (data!=null) {
					fm.set(data);
				}
			}
		}
//		no used getInt
//		HashMap hm = (HashMap) StaticProperties.systemField.get("systemfield");		
//		String data = null;
//		Vector target = this.getArrayFieldList();
//		Vector source = r.getArrayFieldList();
//		FieldManager fm =null;
//		for(int i=0;i<this.mf.size();i++){
//			fm = (FieldManager) this.mf.get(i);
//			String key=fm.getName();
//			if (target.contains(key) && source.contains(key) && !hm.containsKey(fm.getName())) {
//				try {
//					data = r.getString(key);
//				} catch (RemoteException e) {
//					MyLog.error(this, e);
//				}
//				if (data!=null) {
//					fm.set(data);
//				}
//			}
//		}
		
	
	}
	
	public Vector getAllFieldName() {
		return this.AllFieldName;
	}
	
	public Vector getConditionOR() {
		return this.orCondition;
	}
	
	public Vector getConditionAND() {
		return this.andCondition;
	}

	public Vector getColumn_need() {
		return column_need;
	}
	
	public PropertyRec getKeyPropertyRec() {
		return this.key;
	}
	
	public HashMap getNormalField() {
		return this.normalField;
	}
	
	public Vector getMaindatoryField() {
		return this.maindatoryField;
	}
	
	public HashMap getAliasField() {
		return this.aliasField;
	}
	
	public String  getWEkey() {
		return this.wfkey;
	}
	
	public ConfigMetadata getConfigMetaData() {
		return this.vMetaData;
	}
	
	public String getWFactive() {
		return this.wfactive;
	}
	
	public String getDocumentno() {
		return this.documentno;
	}
	
	public String getDescThai() {
		return this.descThai;
	}
	
	public String getDescEng() {
		return this.descEng;
	}
	
	public String getDesc() {
		return this.description;
	}
	
	public FieldManager getSearchInfo() {
//		return this.searchInfo;
		return null;
	}
	
	public  void setProperty(DbRecord motherClass) throws RemoteException {
		this.key = motherClass.getKeyPropertyRec(); 
		this.AllFieldName = motherClass.getAllFieldName();
		this.SystemField = motherClass.getSystemField();
		this.normalField =motherClass.getNormalField();
		this.maindatoryField = motherClass.getMaindatoryField();
		
		this.andCondition=motherClass.getConditionAND();
		this.orCondition=motherClass.getConditionOR();
		this.column_need=motherClass.getColumn_need();
		this.aliasField =motherClass.getAliasField(); 
		this.allKey = motherClass.getAllKey();
		this.vMetaData = motherClass.getConfigMetaData();
		this.editCheck = motherClass.getEditCheck();
		this.wfactive = motherClass.getWFactive();
		this.wfkey = motherClass.getWEkey();
		this.documentno = motherClass.getDocumentno();
		this.descThai = motherClass.getDescThai();
		this.descEng = motherClass.getDescEng();
		if ((this.userPro != null) && (this.userPro.get("lang") != null)&& (!this.userPro.get("lang").equalsIgnoreCase("eng"))) 
				this.description = this.descThai;
		 else 
				this.description = this.descEng;

		this.rm = motherClass.getSecurity();
		this.mainHelp = motherClass.getMainHelp();
		this.referHelp = motherClass.getReferHelp();
		this.mainKey = motherClass.getMainkey();
		this.relationInfo = motherClass.getRelationInfo();
		this.groupField = motherClass.getGroupField();
		this.mf = motherClass.clonePropertyRec(this.getUProfile());
		this.aField = motherClass.getArrayFieldList();
		this.field = new StringBuilder(motherClass.getFieldList());
		this.fieldCount = this.aField.size();
		this.AutoNumField=motherClass.getAutoNumField();
		this.referField=((MyRecord)motherClass).referField;
		this.fieldBlob=motherClass.getFieldBlob();
		this.fieldUpload=motherClass.getFieldUpload();		
//		this.mField = motherClass.getmField();
		FieldManager m;
		for (int i = 0; i < this.aField.size(); i++) {
			m = (FieldManager) mf.get(this.aField.get(i));
			m.setRecord(this);
			m.loadSecurity();
		}
//		this.searchInfo = (FieldManager) motherClass.getSearchInfo().clone(this.userPro);
		this.pRemote = new DataBMPBean();
	}
	
	public PropertyRec getPropertyRec() {
		return mf;
	}
	public void setCreateBy(String s) {
		this.createBY = s;
	}
	public String  getCreateBy() {
		return this.createBY;
	}
	
	public void setBlankChild() {
		this.childTable=new Hashtable();
		this.effectTable=new Hashtable();
	}
	
	public void isSim(boolean isSim){
		this.isSim=isSim;
	}
	
	public boolean getIsSim(){
		return this.isSim;
	}

	/**
	 * @return the fieldGroup
	 */
	public Hashtable getFieldGroup() {
		return fieldGroup;
	}

	/**
	 * @param fieldGroup the fieldGroup to set
	 */
	public void setFieldGroup(Hashtable fieldGroup) {
		this.fieldGroup = fieldGroup;
	}

	/**
	 * @return the fieldBlob
	 */
	public Vector getFieldBlob() {
		return fieldBlob;
	}

	/**
	 * @param fieldBlod the fieldBlod to set
	 */
	public void setFieldBlod(Vector fieldBlob) {
		this.fieldBlob = fieldBlob;
	}

	/**
	 * @return the fieldUpload
	 */
	public Vector getFieldUpload() {
		return fieldUpload;
	}

	/**
	 * @param fieldUpload the fieldUpload to set
	 */
	public void setFieldUpload(Vector fieldUpload) {
		this.fieldUpload = fieldUpload;
	}
	
	public Vector getAutoNumField(){
		return this.AutoNumField;
	}

//	public Vector getmField() {
//		return mField;
//	}
//
//	public void setmField(Vector mField) {
//		this.mField = mField;
//	}
	
	public String getObjectTrace(){		
		StringBuilder build=new StringBuilder();
		/**
		 * 
		 * comment by pas  
		 * comment ͷͺ memory
		 * 
		 * 
		build.append("====MyRecord.toString()=").append(getClass().getName() + "@" + Integer.toHexString(hashCode()));
		build.append("key =").append(key).append("\n");
		build.append("mf =").append(mf).append("\n");
		build.append("tableName =").append(tableName).append("\n");
		build.append("description =").append(description).append("\n");
		build.append("actualName =").append(actualName).append("\n");
		build.append("filter =").append(actualName).append("\n");
		build.append("descThai =").append(actualName).append("\n");
		build.append("descEng =").append(descEng).append("\n");
		build.append("group =").append(group).append("\n");
		build.append("field =").append(group).append("\n");
		build.append("editCheck =").append(editCheck).append("\n");
		build.append("aField =").append(aField).append("\n");
		build.append("AllFieldName =").append(AllFieldName).append("\n");
		build.append("SystemField =").append(SystemField).append("\n");
		build.append("normalField =").append(normalField).append("\n");
		build.append("maindatoryField =").append(maindatoryField).append("\n");
		build.append("fieldCount =").append(fieldCount).append("\n");
		build.append("wfactive =").append(wfactive).append("\n");
		build.append("usedFor =").append(usedFor).append("\n");
		build.append("autoRefresh =").append(autoRefresh).append("\n");
		build.append("chkStr =").append(chkStr).append("\n");
		build.append("oldCondition =").append(oldCondition).append("\n");
		build.append("childTable =").append(childTable).append("\n");
		build.append("parentTable =").append(parentTable).append("\n");
		build.append("relationInfo =").append(relationInfo).append("\n");
		build.append("effectTable =").append(effectTable).append("\n");
		build.append("fieldGroup =").append(fieldGroup).append("\n");
		build.append("referenceTable =").append(referenceTable).append("\n");
		build.append("autoField =").append(autoField).append("\n");
		build.append("allKey =").append(allKey).append("\n");
		build.append("AutoNumField =").append(AutoNumField).append("\n");
		build.append("MultiKeyStore =").append(MultiKeyStore).append("\n");
		build.append("MultiCurrent =").append(MultiCurrent).append("\n");
		build.append("MultiField =").append(MultiField).append("\n");
		build.append("lastUpDate =").append(lastUpDate).append("\n");
		build.append("refreshModel =").append(refreshModel).append("\n");
		build.append("jndiName =").append(jndiName).append("\n");
		build.append("vMetaData =").append(vMetaData).append("\n");
		build.append("mainHelp =").append(mainHelp).append("\n");
		build.append("referHelp =").append(referHelp).append("\n");
		build.append("mainKey =").append(mainHelp).append("\n");
		build.append("keyEmpty =").append(keyEmpty).append("\n");
		build.append("referField =").append(referField).append("\n");
		build.append("refervalue =").append(refervalue).append("\n");
		build.append("hisrec =").append(hisrec).append("\n");
//		build.append("searchInfo =").append(searchInfo).append("\n");
		build.append("rsm =").append(rsm).append("\n");
		build.append("pRemote =").append(pRemote).append("\n");
		build.append("pK =").append(pK).append("\n");
		build.append("wfkey =").append(wfkey).append("\n");
		build.append("documentno =").append(documentno).append("\n");
		build.append("isFormat =").append(isFormat).append("\n");
		build.append("aliasField =").append(aliasField).append("\n");
		build.append("andCondition =").append(andCondition).append("\n");
		build.append("orCondition =").append(orCondition).append("\n");
		build.append("column_need =").append(column_need).append("\n");
		build.append("fieldUpload =").append(fieldUpload).append("\n");
		build.append("fieldBlob =").append(fieldBlob).append("\n");
		build.append("createBY =").append(createBY).append("\n");
		build.append("appname =").append(appname).append("\n");
		build.append("language =").append(language).append("\n");
		build.append("isSim =").append(isSim).append("\n");
		build.append("=====================");
		**/
		return build.toString();
	}
	
}