package com.csc.library.entity;

import java.lang.reflect.Method;
import java.math.BigDecimal;
import java.util.HashMap;

import com.csc.library.utilities.MyLog;

public class MyEntity {
	public MyEntity() {
		super();
	}
	
	public String getString(String field) {
		Object o=this.invokeGet(field);
		String data = "";
		if(o==null)
		  data="";
		else data = String.valueOf(this.invokeGet(field));
		return data;
	}

	public java.sql.Timestamp getTimestamp(String field) {
		try {
			java.sql.Timestamp data = (java.sql.Timestamp) this.invokeGet(field);
			return data;
		} catch (Exception e) {
			return null;
		}
	}

	public java.sql.Date getDate(String field) {
		try {
			java.sql.Date data = (java.sql.Date) this.invokeGet(field);
			return data;
		} catch (Exception e) {
			return null;
		}
	}

	public java.sql.Time getTime(String field) {
		try {
			java.sql.Time data = (java.sql.Time) this.invokeGet(field);
			return data;
		} catch (Exception e) {
			return null;
		}

	}

	public int getInt(String field) {
		try {
			Integer data = (Integer) this.invokeGet(field);
			return data.intValue();
		} catch (Exception e) {
			return 0;
		}
	}

	public float getFloat(String field) {
		try {
			Float data = (Float) this.invokeGet(field);
			return data.floatValue();
		} catch (Exception e) {
			return 0;
		}

	}

	public String getDouble(String field) {
		String dat = "0";
		try {
			Double data = (Double) this.invokeGet(field);
			if (data != null)
				dat = String.valueOf(data.doubleValue());
		} catch (Exception ex) {}
		return dat;
	}

	public String getBigDecimal(String field) {
		String data = "0";
		BigDecimal bk = (BigDecimal) this.invokeGet(field);
		if (bk != null)
			data = bk.toString();
			//System.out.println("Decimal- " + bk + " Data = " + data);
		return data;
	}

	public void set(String field, String data) {
		this.invokeSet(field, data);
	}

	public void set(String field, int data) {
		this.invokeSet(field, new Integer(data));
	}

	public void set(String field, java.sql.Timestamp data) {
		this.invokeSet(field, data);
	}

	public void set(String field, java.sql.Date data) {
		this.invokeSet(field, data);
	}

	public void set(String field, java.sql.Time data) {
		this.invokeSet(field, data);
	}

	public void set(String field, BigDecimal data) {
		this.invokeSet(field, data);
	}

	public void set(String field, float data) {
		this.invokeSet(field, new Float(data));
	}

	public void set(String field, double data) {
		this.invokeSet(field, new Double(data));
	}

	private String reverseString(String data) {
		String rev = "";
		String front = data.substring(0, 1);
		front = front.toUpperCase();
		String back = data.substring(1, data.length());
		rev = front + back;
		return rev;
	}

	/*	private String reverseString(String data) {
			String fval = "";
			if (data.indexOf("_") < 0) {
				fval = this.repareString(data);
			} else {
				StringTokenizer str = new StringTokenizer(data, "_");
				while (str.hasMoreTokens()) {
					String value = this.repareString(str.nextToken());
					fval = value + this.repareString(str.nextToken());
				}
			}
			return fval;
		}
	*/
	private Object invokeGet(String field) {
		Object data = null;
		//this.logger.info("nFieldname = "+field) ;
		//this.logger.info("vFieldname = "+this.reverseString(field)) ;
		try {
			Class c = this.getClass();
			Method[] m = c.getDeclaredMethods();
			for (int i = 0; i < m.length; i++) {
				if (m[i].getName().equals("get" + this.reverseString(field))) {
					Method mx = m[i];
					data = mx.invoke(this, new Object[] {});
					//System.out.println("Fieldname = " + this.reverseString(field) + " : Object = " + data);
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return data;
	}

	private void invokeSet(String field, Object data) {
		try {
			Class c = this.getClass();
			Method[] m = c.getDeclaredMethods();
			field=this.reverseString(field);
			for (int i = 0; i < m.length; i++) {
				if (m[i].getName().equals("set" + field)) {
					Method mx = m[i];
					mx.invoke(this, new Object[] { data });
				}
			}
		} catch (Exception e) {
			MyLog.error(this,"[## CMP Bean Field:\""+field+"\" CANNOT INVOKE METHOD SET IN myEntity WITH VALUE:\""+data+"\"##]");
		}
	}

	private int checkIncrement(HashMap m) {

		return 0;
	}

}