package com.csc.library.entry;

import java.io.Serializable;
import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.StringTokenizer;

import com.csc.library.database.ChildManager;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.RecordCmp0;
import com.csc.library.utilities.MyLog;
public class MultiEntry extends SingleEntry implements Serializable {
	Hashtable multiBox;
	public void getAndset() {
		try {
			super.getAndset();
			this.myRec.setParam(this.param);
			MultiLine multi;
			String tableName = this.getValue("multiTable");
			String tmp1 = "";
			//	String helpN, helpV;
			if (multiBox == null)
				multiBox = new Hashtable();
			for (StringTokenizer token = new StringTokenizer(tableName, ","); token.hasMoreTokens();) {
				tmp1 = token.nextToken();
				tmp1 = tmp1.toLowerCase();	
				if (multiBox.containsKey(tmp1)) {
					multi = (MultiLine) multiBox.get(tmp1);
					multi.setChannel(this.param);
				} // if
			} // for
			this.cmd = this.getValue("cmd");

		} catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
		}
	}

	public MultiEntry() {
		this.type = "multiEntry";
	}

	public String process() {
		try {
			//this.initRecord();
			this.setValue();
			//this.initSingleProcess();
			if ((this.cmd != null) && (this.cmd.length() > 0)) {
				if (this.cmd.equalsIgnoreCase("save")) {
					this.save();
				} else if (this.cmd.equalsIgnoreCase("delete")) {
					if(this.getValue("notdelall").equalsIgnoreCase("true")){
						String tableName = this.getValue("multiTable");
						for (StringTokenizer token = new StringTokenizer(tableName, ","); token.hasMoreTokens();) {
							DbTable mtable= ((DbTable)this.myRec.getChild(token.nextToken()));
							mtable.delete();
						}
					//	this.save();						
					}else{
						if(((DbTable)this.myRec.getChild( this.getValue("multiTable")))!=null){
							if(((RecordCmp0)this.myRec).chkDependTableAllRelation("delete")){//comment by pas Ǩͺ͹ ź record 
								((DbTable)this.myRec.getChild( this.getValue("multiTable"))).delete();
							}
						}
						this.del();
	/*					if(!this.keyConfirm.equals("6")){
							((DbTable)this.myRec.getChild( this.getValue("multiTable"))).delete();
						} */
					}
				} else if (this.cmd.equalsIgnoreCase("search")) {
					this.search();
				}
				/* edit by P'Pas
				 else if (!this.cmd.equalsIgnoreCase("")||(this.cmd.equalsIgnoreCase("MultiSearch"))) {
					this.setValue();
				}
				*/
			}
		} catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
		}
		return "";
	}

	public String getMessage(){
		return this.keyConfirm;
	}		

	public void setMessage(String mesage){
		this.keyConfirm=mesage;
	}		


	/*public void setChannel(HashMap param){
		try {
			this.myRec.setParam(param);
		} catch (Exception e) {
		}
		super.setChannel(param);
	}*/	


	public MultiLine getMultiLine(String tableName) {
		MultiLine multi = null;
		try {
			tableName = tableName.toLowerCase();
			if (multiBox.containsKey(tableName)) {
				multi = (MultiLine) multiBox.get(tableName);
			} else {
				multi = new MultiLine(this.myRec.getTableManager(tableName));
				multi.iFont = this.user.getInputFont();
				multi.lFont = this.user.getLabelFont();
				multiBox.put(tableName, multi);
			}
			multi.getTable().goRec(1,false);
		} catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
		}
		return multi;
	}
	
	public void setRecordInfo(){
		String fieldName,value,fieldList;
		try {
			for (Iterator e = this.param.keySet().iterator(); e.hasNext();) {
				fieldName = (String) e.next();
				value=(String)this.param.get(fieldName);
				if(fieldName.indexOf("__")!=-1){
					fieldName=fieldName.substring(2,fieldName.length());
					this.myRec.set(fieldName,value);
				}	
			}	
		} catch (RemoteException e) {			
			MyLog.error(this, this.getUProfile(), e);
		}
	}		
	public HashMap getParam(){
		return this.param;
	}	
	public void setCmd(String value){
		this.param.put("cmd",value);
		this.cmd=value;
	}	
	public DbTable getTable(){return this.myTab;}		
	public DbRecord getRecord(){
		return this.myRec;
	}	
	public void setRecord(DbRecord db){
		this.myRec=db;
	}	
   /* public void clean() {
        try {
            //this.myRec=this.myRec.cloneRecord(true);
        	//Clear Data in childtable [2005-10-02] 
        	Iterator it = this.myRec.getChildTable().keySet().iterator();
            while (it.hasNext()) {
            	String key = (String) it.next();
            	ChildManager ch = (ChildManager) this.myRec.getChildTable().get(key);
            	ch.clearField();
            }
            
        	if (this.param.containsKey("__screen")) {
        		String screenName = (String) this.param.get("__screen");
        		if (screenName.equalsIgnoreCase("TAU102")||screenName.equalsIgnoreCase("TAU103")||
        				screenName.equalsIgnoreCase("TAU104")) {
        			//not doing
        		} else {        		
        			System.out.println("--------------------MultiEntry -clean -------------------");
        			((DbTable)this.myRec.getChild(this.getValue("multiTable"))).clear();
        		}
        	}
        	it = ((DbTable)this.myRec.getChild(this.getValue("multiTable"))).getRelationInfo().keySet().iterator();
            while (it.hasNext()) {
            	String key = (String) it.next();
            	ChildManager ch = (ChildManager) this.myRec.getChildTable().get(key);  
            	if(ch != null){
	            	Iterator itChild = ch.getChildTable().keySet().iterator();
	            	while (itChild.hasNext()) {
	            		String keyChild = (String) itChild.next();
	            		ChildManager chChild = (ChildManager) ch.getChildTable().get(keyChild);
	            		chChild.clearField();
	            	}            	
	            	ch.clearField();
            	}
            }
            this.myRec.clearField(); 
        } catch (Exception e) {
            e.printStackTrace();
        }
    }*/
	
	public void clean() {
        try {
        	String tableName = this.getValue("multiTable");
        	String tmp1="";
            //this.myRec=this.myRec.cloneRecord(true);
        	//Clear Data in childtable [2005-10-02] 
        	Iterator it = this.myRec.getChildTable().keySet().iterator();
            while (it.hasNext()) {
            	String key = (String) it.next();
            	ChildManager ch = (ChildManager) this.myRec.getChildTable().get(key);
            	ch.clearField();
            }
            
        	if (this.param.containsKey("__screen")) {
        		String screenName = (String) this.param.get("__screen");
                /**
                 * PAS �� parameter �� parameter �Ҩҡ˹�Ҩ� ���� __clearChild 
                 * true = clear child
                 * false = not clear
                 */
                boolean clearChildTable=(this.param.containsKey("__clearChild")&&((String)this.param.get("__clearChild")).equals("false"))?false:true;                
        		if (screenName.equalsIgnoreCase("TAU102") || 
        				screenName.equalsIgnoreCase("TAU103") ||
        				screenName.equalsIgnoreCase("TAU104")||(!clearChildTable) ) {
        			//not doing
        		} else {      
                    /*
        			for (StringTokenizer token = new StringTokenizer(tableName, ","); token.hasMoreTokens();) {
        				tmp1 = token.nextToken();
        				System.out.println("--------------------MultiEntry <"+tmp1+"> -clean -------------------"+this.myRec.getChild(tmp1));
        				if(((DbTable)this.myRec.getChild(tmp1))!=null)
        					((DbTable)this.myRec.getChild(tmp1)).clear();
        			}*/
                    
                   
                    it= this.myRec.getChildTable().keySet().iterator();                   
                    while (it.hasNext()) {
                        String mtb = (String) it.next();
                        if(this.myRec.getChild(mtb) instanceof DbTable) {                           
                            MyLog.debug(this, this.getUProfile(), "--------------------MultiEntry <"+mtb+"> -clean -------------------");
                            ((DbTable)this.myRec.getChild(mtb)).clear();                        
                        }
                    }
                    
        		}
        	}
        	for (StringTokenizer token = new StringTokenizer(tableName, ","); token
					.hasMoreTokens();) {
				tmp1 = token.nextToken();
				it = ((DbTable) this.myRec.getChild(tmp1)).getRelationInfo()
						.keySet().iterator();
				while (it.hasNext()) {
					String key = (String) it.next();
					ChildManager ch = (ChildManager) this.myRec.getChildTable()
							.get(key);
					if (ch != null) {
						Iterator itChild = ch.getChildTable().keySet()
								.iterator();
						while (itChild.hasNext()) {
							String keyChild = (String) itChild.next();
							ChildManager chChild = (ChildManager) ch
									.getChildTable().get(keyChild);
							chChild.clearField();
						}

						ch.clearField();
					}

				}
			}
            this.myRec.clearField(); 
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
    }
    
	public void dataManager(String objName, HashMap param) {
		super.dataManager(objName, param);
		try {
			Iterator itChild = this.myRec.getChildTable().keySet().iterator();
			while (itChild.hasNext()) {
				String keyChild = (String) itChild.next();
				ChildManager chChild = (ChildManager) this.myRec.getChildTable().get(keyChild);
				if(chChild instanceof DbTable){
					((DbTable)chChild).setRefreshModel((byte)1);
				}
				
				chChild.clearField();
			}
		} catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
	    }
	}	
}