package com.csc.library.entry;

import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Map;
import java.util.StringTokenizer;
import java.util.Vector;

import com.csc.library.database.FieldManager;
import com.csc.library.session.DbTable;
import com.csc.library.utilities.DbXml;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

public class MultiNoRecEntry extends MultiEntry {

	private String filter="";

	public MultiNoRecEntry() {
		this.type = "MultiEntry";
	}
	public void getAndset() {
		try {
        	if((this.getValue("isloadparam").equalsIgnoreCase(""))||(this.getValue("isloadparam").equalsIgnoreCase("true"))){
        		HashMap h = this.myTab.getParam();
        		h.clear();
        		h.putAll(((Map)this.param));
        	}
			if (this.getValue("recVerify").equalsIgnoreCase("true")&&!this.getValue("help").equals("")){
				UProfile tup =(UProfile) this.user.clone();
				tup.setUserId(this.getValue("editBy"));
				this.myTab.setUProfile(tup);
				this.help_return = this.getValue("help");
				this.help_return = this.getValue("help").replace('$','#');
			}			
			MultiLine multi;
			String tableName = this.getValue("multiTable");
			String tmp1 = "";
			if (multiBox == null)
				multiBox = new Hashtable();
			for (StringTokenizer token = new StringTokenizer(tableName, ","); token.hasMoreTokens();) {
				tmp1 = token.nextToken();
				if (multiBox.containsKey(tmp1)) {
					multi = (MultiLine) multiBox.get(tmp1);
					multi.setChannel(this.param);
				} 
			} 
			this.cmd = this.getValue("cmd");
// user in method search
// comment by pas 20090721			
//			if(!this.getFilter().equals("")){
//				this.myTab.setFilter(this.getFilter());
//				this.myTab.setKeyOff();
//				this.myTab.refresh();
//				this.myTab.setKeyOn();
//			}	
			this.search();
			
		} catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
		}
	}
   
   private boolean isFieldNumeric(FieldManager field){
		String fieldType = field.getType().trim();
		if(fieldType.equalsIgnoreCase("integer")||fieldType.equalsIgnoreCase("double") || 
			fieldType.equalsIgnoreCase("float")||fieldType.equalsIgnoreCase("bigdecimal")){
			return true;
		}
		else{
			return false;
		}		
	}
	
	private String getFilter() {
		String help = this.getValue("help");		
		if (this.getValue("recVerify").equalsIgnoreCase("true")&&!this.getValue("help").equals("")){					
			help = this.getValue("help").replace('$','#');
			}else help = this.getValue("help");			
		Vector list = new Vector();
		filter="";
		if (!help.equals("")) {
			StringTokenizer st = new StringTokenizer(help, ";");
			while (st.hasMoreTokens()) {
				list.addElement(st.nextToken());
			}
			filter="";
			for(int i=0;i<list.size();i++){
				st=new StringTokenizer((String)list.elementAt(i),"#");
				while(st.hasMoreTokens()){
					String s1=st.nextToken().substring(2);
					String s2=st.nextToken();		
				try {
					if (this.isFieldNumeric(this.myTab.getRecordManager().getField(s1))){
							filter+=s1+"="+s2;
						}	else{
							filter+=s1+"='"+s2+"'";
						}
					} catch (RemoteException e) {
					}
				if(i+1<list.size())
					filter+=" and ";
			}	
		}
		}	
	return filter;

	}
	public void dataManager(String objName,HashMap param) {
		this.param=param;
		try {
			if (this.myTab == null) {
				DbXml dataControl = new DbXml(this.user, objName, this.user.getComCode(), this.user.getUserName(), this.user.getPassword(),this.param);
				this.myTab = dataControl.getTable();
				this.myTab.setPropDB(this.user.getComCode(), this.user.getUserName(), this.user.getPassword());
				//   this.myTab.search();
			}
			this.myTab.setRefreshModel((byte)1);
		} catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
		}
	}

	public String process() {
		//this.initSingleProcess();
		try {
			this.cmd = this.getValue("cmd");
			this.keyConfirm = "";
			if ((this.cmd != null) && (this.cmd.length() > 0)) {
				this.myRec = this.myTab.getRecordManager();
				if (cmd.equalsIgnoreCase("save")) {
					this.saveTable();
				}else if (cmd.equalsIgnoreCase("delete")) {
					if (this.myTab.delete() >= 0) {
						this.clean();
						this.keyConfirm = "4";
					} else {
						this.keyConfirm = "6";
					}
				}else {
					this.keyConfirm=myTab.getMessage();
				}
				//this.myTab.setMessage("");
			}
		} catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
		}
		return "";
	}

	public void saveTable() {
        int re = 0;
        try {
           if (this.getValue("confirm").equals("c")) {  
                re =9;
            } else { //insert & update
            	if(!this.getValue("setfilter").equals(""))
            		this.myTab.setFilter(this.getValue("setfilter"));
                re = this.myTab.save();
            }
           if (re==9) {
           		this.clean();
          }        
   /*         if (re>0) {
            	this.clean();
            } */
            
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
	}
	/*
		try {
				int re = this.myTab.save();
				if(re==3){
					this.keyConfirm=String.valueOf(re);
					this.clean();
				}else this.keyConfirm=this.myTab.getMessage();	
				
		} catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
		}
	}
*/


	public String getMessage(){
		return this.keyConfirm;
	}		

	public void setMessage(String mesage){
		this.keyConfirm=mesage;
	}		

	public DbTable getTable(String name) {
		try {
			if (this.myTab.getTableName().equalsIgnoreCase(name))
				return this.myTab;
			else
				return (DbTable) this.myTab.getTableManager(name);
		} catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
		}
		return null;
	}

	public MultiLine getMultiLine(String tableName) {
		MultiLine multi = null;
		try {
			if (multiBox == null)
				multiBox = new Hashtable();
			if (multiBox.containsKey(tableName)) {

				multi = (MultiLine) multiBox.get(tableName);
			} else {

				if (tableName.equalsIgnoreCase(this.myTab.getTableName()))
					multi = new MultiLine(this.myTab);
				else {
					multi = new MultiLine(this.myTab.getTableManager(tableName));
				}
				multi.iFont = this.user.getInputFont();
				multi.lFont = this.user.getLabelFont();
				multiBox.put(tableName, multi);
			}
			multi.goFirst();
		} catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
		}
		return multi;
	}
    public String getRequire() {
        String data = "";
        try {
            data = this.myTab.getRecordManager().listField("require");
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
        return data;
    }
    
    public void clean() {
        try {
            //this.myRec=this.myRec.cloneRecord(true);
    		//String screenName = (String) this.param.get("__screen");
    		String cleanflag = (String) this.param.get("__cleardata");
			if((cleanflag !=null) &&(cleanflag.equalsIgnoreCase("false"))) {
				// do not action
			} else {
				this.myTab.clear();
			}
            
        } catch (Exception e) {
			MyLog.error(this, this.getUProfile(), e);
        }
    }
    public void referLangOn() {
        try {
            this.myTab.referLangOn();
        } catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
        }
    }
    public void referLangOff() {
        try {
            this.myTab.referLangOff();
        } catch (Exception ex) {
			MyLog.error(this, this.getUProfile(), ex);
        }
    }

    @Override
    public void setChannel(HashMap param) {
    	this.param=(HashMap)param.clone();
    }
    
    @Override
    public void search() {
    	try{
		if(!this.getFilter().equals("")){
			this.myTab.setFilter(this.getFilter());
			this.myTab.setKeyOff();
			this.myTab.refresh();
			this.myTab.setKeyOn();
		}
    	}catch(Exception ex){
    		MyLog.error(this,this.getUProfile(),"Can't  Search MultiNoRecEntry");
    	}
	}

}