package com.csc.library.entry;

import java.util.HashMap;
import java.util.Iterator;

import org.apache.commons.lang.math.NumberUtils;

import com.csc.library.service.GenProcessQuque;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;
/**
 * @author Architecture
 */
public class ProcessEntry extends SingleEntry {

	protected HashMap condition;
	protected int maxlist = 100;
	
	public void getAndset() {
		condition = new HashMap();
		
		if(param.containsKey("maxlist")) {
			maxlist = NumberUtils.toInt((String)param.get("maxlist"), 100);
		}
		String fieldName = "";
		Iterator it = this.param.keySet().iterator();
		while (it.hasNext()) {
			fieldName = (String) it.next();
			if (fieldName.indexOf("__condition$") > -1) {
				// if field in param is process then do
				condition.put(fieldName.substring(fieldName.indexOf("$") + 1, fieldName.length()), param.get(fieldName));
			}
		}
		
		final UProfile uprofile = (UProfile)user.clone();
		uprofile.put("state","PROCESS");
		condition.put("UProfile", uprofile);
	}
	
	
/*	private void genProcess() {
		DbProcess dp = new InitialProcess().getProcess(this.getValue("prclass"));
		try {
			dp.setProcess_name(this.getValue("name"));
			dp.setProcess_type(this.getValue("ptype"));
			dp.setProcess_class(this.getValue("prclass"));
			dp.setProcess_join(this.getValue("proc_join"));
			dp.setRefresh_time("");
			dp.setCondition(condition);
			dp.setUProfile(this.user);
			//dp.process(condition);
			this.fileName = dp.genProcess();
			this.runService();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
*/	

	private String genProcess()  {
		GenProcessQuque GPS = new GenProcessQuque();
		try {
			GPS.setCondition(condition);
			GPS.setParam(param);
			GPS.setUProfile(user);
			GPS.setMaxlist(maxlist);
			return GPS.genThred();
			
		} catch (Exception e) {
			MyLog.error(this, getUProfile(), e);
		}
		
		return null;
	}

	
	public String process() {
		String cmd = "";
		cmd = getValue("cmd");
		if (cmd.equalsIgnoreCase("save")||cmd.equalsIgnoreCase("process")) {
			return this.genProcess();
		}
		return null;
	}
	
	public String getConditonInput(String name) {
		return "<input type \"text\" name=\"__condition$" + name + "\">";
	}
	
	public void dataManager(String objName, HashMap param) {
		this.param = param;
	}
	
	public void setChannel(HashMap param) {
		// process no MyRec and no isloadparam
	}	
}
