package com.csc.library.entry;

import java.rmi.RemoteException;
import java.util.HashMap;

import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.utilities.UProfile;
import com.csc.library.utilities.CscCalendar;



public interface ScreenManager {
	public void setChannel(HashMap param) throws RemoteException;
	public void setLastActive() throws RemoteException;
	public String process() throws RemoteException;
	public void dataManager(String ScreenObj,HashMap param) throws RemoteException;
	public String getType() throws RemoteException;
	public void setUserProfile(UProfile oUser) throws RemoteException;
	public void setStartActive() throws RemoteException;
	public void setTable(DbTable table) throws RemoteException;
	public DbRecord getRecord(String name) throws RemoteException;
	public DbTable getTable(String name) throws RemoteException;
	public DbTable getTable() throws RemoteException;	
	public MultiLine getMultiLine(String tableName) throws RemoteException;
	public void setParentName(String name) throws RemoteException;
	public String getParentName() throws RemoteException;
	public void setRecordInfo()	throws RemoteException;
	public void setCmd(String cmd)throws RemoteException;
	public void setMessage(String Message)throws RemoteException;
	public String getMessage()throws RemoteException;
	public DbRecord getRecord() throws RemoteException;
	public CscCalendar getLastActive();
	public void clean();
	public void getAndset() throws RemoteException;
	public void isSim(boolean isSim) throws RemoteException;
//	public void processForTagpageOnly() throws Exception;	
//	public void process(boolean dorefresh) throws Exception;
}
