package com.csc.library.entry;
import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;

import com.csc.library.session.DbRecord;
import com.csc.library.utilities.DbXml;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;


/**
 * @author Administrator
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class SingleProcess {
	private DbRecord dbRecord=null;
	private HashMap paramScreen,param,prop;
	private Hashtable child;
	
	public DbRecord getDbRecord(){
		return this.dbRecord;
	}	
	public int insert(HashMap prop, boolean confirm) {
		this.prop=prop;
		this.initParam();
		this.initRecord();
		int returnValue = 0;
		try {
			this.dbRecord.setConfirm(confirm);
			returnValue = dbRecord.insert();
			dbRecord.clearField();
		} catch (RemoteException e) {
//			try {
				MyLog.error(this, this.getDbRecord().getUProfile(), e);
//			} catch (RemoteException e1) {
//				MyLog.error(this,  e1);
//			}
		}
		return returnValue;
	}

	public int delete(HashMap prop) {
		this.prop=prop;
		this.initParam();
		this.initRecord();
		int returnValue = 0;
		try {
			returnValue = dbRecord.delete();
		} catch (RemoteException e) {
//			try {
				MyLog.error(this, this.getDbRecord().getUProfile(), e);
//			} catch (RemoteException e1) {
//				MyLog.error(this,  e1);
//			}
		}
		return returnValue;
	}
	
	private void setRecordInfo() {
		String fieldName, value, fieldList;
		try {
			for (Iterator e = this.paramScreen.keySet().iterator(); e.hasNext();) {
				fieldName = (String) e.next();
				value = (String) this.paramScreen.get(fieldName);
				if (fieldName.indexOf("__") != -1) {
					fieldName = fieldName.substring(2, fieldName.length());
					this.dbRecord.set(fieldName, value);
				}
			}
			this.dbRecord.setParam(this.param);
		} catch (RemoteException e) {			
//			try {
				MyLog.error(this, this.getDbRecord().getUProfile(), e);
//			} catch (RemoteException e1) {
//				MyLog.error(this,  e1);
//			}
		}
	}
	
	private void initRecord(){
		UProfile up=(UProfile) prop.get("uprofile");
		if(this.prop.get("db") != null)
			this.dbRecord=(DbRecord)this.prop.get("db");
		else{	
			this.dbRecord = new DbXml(up, (String)prop.get("dbscreen"), up.getComCode(), up.getUserName(), up.getPassword(),this.param).getRecord();
			this.setRecordInfo();
		}	
	}	
	
	private void initParam(){
		this.paramScreen = (HashMap) prop.get("screen_param");
	}	
	
/*	private void setChildInfo() {
		Enumeration em = child.elements();
		ChildManager ch = null;
		while (em.hasMoreElements()) {
			ch = (ChildManager) em.nextElement();
			try {
				this.dbRecord.putChild(ch);
			} catch (RemoteException e) {e.printStackTrace();}
		}
	}
*/
}
