package com.csc.library.formula;


import java.math.BigDecimal;
import java.math.RoundingMode;
import java.text.DecimalFormat;
import java.util.Hashtable;
import java.util.StringTokenizer;

import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
/**
 * @author xerox
 *
 * Cls  tool Cls 㹡¹ٵ
 */
public class FormulaString {
    public String Substr(String st, int start, int end) {
        int x = st.length();
        if (start + end > x) {
            end = x;
        } else {
            end = start - 1 + end;
        }
        String st1 = st.substring(start - 1, end);
        return st1;
    }
    public String Alltrim(String st) {
        String st1 = st.trim();
        return st1;
    }
    public String Rtrim(String st) {
        int d = 0, a;
        String st1 = "";
        Hashtable h = new Hashtable();
        for (int i = 0; i < st.length(); i++) {
            h.put(new Integer(i), st.substring(i, i + 1));
        }
        for (int i = 0; i < h.size(); i++) {
            if (h.get(new Integer(i)).equals(" ")) {
                d++;
            } else {
                d = 0;
            }
        }
        a = h.size() - d;
        for (int i = h.size(); i >= a; i--) {
            h.remove(new Integer(i));
        }
        for (int i = 0; i < h.size(); i++) {
            st1 += h.get(new Integer(i));
        }
        return st1;
    }
    public String Ltrim(String st) {
        int d = 0, a;
        String st1 = "";
        Hashtable h = new Hashtable();
        for (int i = 0; i < st.length(); i++) {
            h.put(new Integer(i), st.substring(i, i + 1));
        }
        for (int i = 0; i < h.size(); i++) {
            if (h.get(new Integer(i)).equals(" ")) {
                d++;
            } else {
                break;
            }
        }
        for (int i = 0; i < d; i++) {
            h.remove(new Integer(i));
        }
        for (int i = d; i < h.size() + d; i++) {
            st1 += h.get(new Integer(i));
        }
        return st1;
    }
    public String Str(double n, int a) {
        String z;
        int x;
        z = String.valueOf(n);
        x = z.indexOf('.');
        if (a == 0) {
            a = x;
        } else {
            x = x + a + 1;
        }
        if (x <= z.length()) {
            z = z.substring(0, x);
        }
        return z;
    }
    public double Val(String a) {
        return Double.parseDouble(a);
    }
    public int Int(double a) {
        int c = RoundInt(a);
        return c;
    }
    public int RoundInt(double d) {
        String a, a1, a2;
        int x, x1, x2;
        a = String.valueOf(d);
        x = a.indexOf(".");
        a1 = a.substring(x + 1, x + 2);
        a2 = a.substring(0, x);
        x1 = Integer.parseInt(a1);
        x2 = Integer.parseInt(a2);
        if (x1 >= 5) {
            x2++;
        }
        return x2;
    }
    public double Round(double n) {
        return n;
    }
    public double Round(double n, int a) {
        /*
         *  ѴȹԴ ó n = 1.8958 кѴ 1.81
         * by TongZuu 25-02-2015
         * String z, b, c;
        int x, c1, b1, d1;
        double z1;
        z = String.valueOf(n);
        x = z.indexOf('.');
        d1 = z.substring(x + 1).length();
        if (a == 0) {
            a = x;
        } else {
            x = x + a;
        }
        if (x <= z.length() && a < d1) {
            b = z.substring(x, x + 1);
            c = z.substring(x + 1, x + 2);
            z = z.substring(0, x);
            b1 = Integer.parseInt(b);
            c1 = Integer.parseInt(c);
            if (c1 >= 5) {
                b1 = b1 + 1;
            }
            b = Integer.toString(b1);
            z = z + b;
        }
        z1 = Double.parseDouble(z);
        return z1;
        */
        BigDecimal bd = new BigDecimal(n);
        return bd.setScale(a, RoundingMode.HALF_UP).doubleValue();
    }
    public String RoundD(String z) {
        String b, c;
        int x=0, c1=0, b1=0, d1=0, a = 2;
        double z1;        
        x = z.indexOf('.');
        if(x>-1){
        d1 = z.substring(x + 1).length();
        if (a == 0) {
            a = x;
        } else {
            x = x + a;
        }
        if (x <= z.length() && a < d1) {
            b = z.substring(x, x + 1);
            c = z.substring(x + 1, x + 2);
            z = z.substring(0, x);
            //System.out.println(">>--------------->>>"+z+"<****>"+c+"<*****>"+c);
            b1 = Integer.parseInt(b);
            c1 = Integer.parseInt(c);
            if (c1 >= 5) {
                b1 = b1 + 1;
            }
            b = Integer.toString(b1);
            z = z + b;
        }
        }
        return z;
    }
    public int Day(String st) {
        CscCalendar c = new CscCalendar(st);
        return c.getDate();
    }
    public int Month(String st) {
        CscCalendar c = new CscCalendar(st);
        int a = Integer.parseInt(c.getMM());
        return a;
    }
    public int Year(String st) {
        CscCalendar c = new CscCalendar(st);
        return c.getYear();
    }
    public String Ctod(String st) {
        return DelFL(st);
    }
    public String Dtoc(String st) {
        return "'" + st + "'";
    }
    public String DelFL(String st) {
        String st1 = "";
        Hashtable h = new Hashtable();
        for (int i = 0; i < st.length(); i++) {
            h.put(new Integer(i), st.substring(i, i + 1));
        }
        h.remove(new Integer(0));
        h.remove(new Integer(h.size()));
        for (int i = 1; i < h.size() + 1; i++) {
            st1 += h.get(new Integer(i));
        }
        return st1;
    }
    public int Dow(String st) {
        CscCalendar c = new CscCalendar(st);
        return c.getDayOfWeek();
    }
    public double Tm_To_Dec(double st) {
        double x1, x2;
        int i;
        String st1, st2, x;
        x = String.valueOf(st);
        i = x.indexOf(".");
        st1 = x.substring(x.indexOf(".") + 1);
        st2 = x.substring(0, i);
        x1 = Double.parseDouble(st2);
        x2 = Double.parseDouble(st1);
        if (st1.length() == 1) {
            x2 *= 10;
        }
        x1 = x1 + x2 / 60;
        return Round(x1, 2);
    }
    public String Dec_To_Tm(double st) {
        String a, x, y, z;
        int b, d;
        double c;
        a = String.valueOf(st);
        b = a.indexOf(".");
        x = a.substring(b + 1);
        y = a.substring(0, b);
        c = Double.parseDouble(x);
        if (x.length() == 1) {
            c *= 10;
        }
        c = (double) (c * 0.6);
        d = RoundInt(c);
        if (d < 10) {
            z = "0" + String.valueOf(d);
        } else {
            z = String.valueOf(d);
        }
        x = y + "." + z;
        return x;
    }
    public int Tm_To_Min(double st) {
        String b, c, st1;
        int b1, c1, a;
        st1 = String.valueOf(this.Round(st, 2));
        a = st1.indexOf(".");
        b = st1.substring(0, a);
        c = st1.substring(a + 1);
        b1 = Integer.parseInt(b);
        c1 = Integer.parseInt(c);
        if (c.length() == 1) {
            c1 *= 10;
        }
        b1 = b1 * 60;
        b1 += c1;
        return b1;
    }
    public String Min_to_tm(int i) {
        double a;
        String v;
        a = (double) i / 60;
        a = Round(a, 2);
        v = Dec_To_Tm(a);
        return v;
    }
    public int DhmToM(String t) {
        String t1;
        int i = 1, a = 0, b = 0, c = 0, m = 0, count = 0;
        StringTokenizer stChkFormula = new StringTokenizer(t, ":");
        count = stChkFormula.countTokens();
        while (stChkFormula.hasMoreTokens()) {
            t1 = stChkFormula.nextToken().toString();
            if (count == 3) {
                if (i == 1) {
                    a = Integer.parseInt(t1);
                    a = a * 8 * 60;
                }
                if (i == 2) {
                    b = Integer.parseInt(t1);
                    b = b * 60;
                }
                if (i == 3) {
                    c = Integer.parseInt(t1);
                }
            }
            if (count == 2) {
                if (i == 1) {
                    b = Integer.parseInt(t1);
                    b = b * 60;
                }
                if (i == 2) {
                    c = Integer.parseInt(t1);
                }
            }
            if (count == 1) {
                c = Integer.parseInt(t1);
            }
            i++;
        }
        m = a + b + c;
        return m;
    }    
    
    public int DhmToM(String t, int h) {
        String t1;
        int i = 1, a = 0, b = 0, c = 0, m = 0, count = 0;
        StringTokenizer stChkFormula = new StringTokenizer(t, ":");
        count = stChkFormula.countTokens();
        while (stChkFormula.hasMoreTokens()) {
            t1 = stChkFormula.nextToken().toString();
            if (count == 3) {
                if (i == 1) {
                    a = Integer.parseInt(t1);
                    a = a * h * 60;
                }
                if (i == 2) {
                    b = Integer.parseInt(t1);
                    b = b * 60;
                }
                if (i == 3) {
                    c = Integer.parseInt(t1);
                }
            }
            if (count == 2) {
                if (i == 1) {
                    b = Integer.parseInt(t1);
                    b = b * 60;
                }
                if (i == 2) {
                    c = Integer.parseInt(t1);
                }
            }
            if (count == 1) {
                c = Integer.parseInt(t1);
            }
            i++;
        }
        m = a + b + c;
        return m;
    }    
    public int DhmToM(String t, double h) {
        String t1;
        int i = 1, a = 0, b = 0, c = 0, m = 0, count = 0;
        StringTokenizer stChkFormula = new StringTokenizer(t, ":");
        count = stChkFormula.countTokens();
        while (stChkFormula.hasMoreTokens()) {
            t1 = stChkFormula.nextToken().toString();
            if (count == 3) {
                if (i == 1) {
                    a = Integer.parseInt(t1);
                    //ͧ
                    //a = a * ((int) (h * 60));
                    
                    //================= Nuiss Code ===============
                    /**
                     * Author : Nuiss
                     * Date : 05/11/2552
                     * Logic :  ͼԴҴ 㹡ŧ .  ҷ
                     *   parameter h  ҢͧҷҴ  8.40
                     * з äӹǳԴͼԴҴ
                     */
                    DecimalFormat dc = new DecimalFormat();
                    dc.applyPattern("#0.00");
                    String[] HHMM = dc.format(h).replace(".", ":").split(":");
                    double HH = Double.valueOf(HHMM[0]);
                    double MM = Double.valueOf(HHMM[1]);   
                    a = a * (((int) (HH * 60)+(int) MM));
                  //================= Nuiss Code ===============                         
                }
                if (i == 2) {
                    b = Integer.parseInt(t1);
                    b = b * 60;
                }
                if (i == 3) {
                    c = Integer.parseInt(t1);
                }
            }
            if (count == 2) {
                if (i == 1) {
                    b = Integer.parseInt(t1);
                    b = b * 60;
                }
                if (i == 2) {
                    c = Integer.parseInt(t1);
                }
            }
            if (count == 1) {
                c = Integer.parseInt(t1);
            }
            i++;
        }
        m = a + b + c;
        return m;
    }   
    /*public int DhmToM(String t, double h) {
        String t1;
        int i = 1, a = 0, b = 0, c = 0, m = 0;
        int t2 = Tm_To_Min(h);
        StringTokenizer stChkFormula = new StringTokenizer(t, ":");
        while (stChkFormula.hasMoreTokens()) {
            t1 = stChkFormula.nextToken().toString();
            if (i == 1) {
                a = Integer.parseInt(t1);
                a = a * (t2 * 60);
            }
            if (i == 2) {
                b = Integer.parseInt(t1);
                b = b * 60;
            }
            if (i == 3) {
                c = Integer.parseInt(t1);
            }
            i++;
        }
        m = a + b + c;
        return m;
    }*/
    public String MTODhm(int m, int h) {
    	try { 
	        int t1, t12, t2, t3;
	        t1 = m / (h * 60);
	        t12 = m % (h * 60);
	        t2 = t12 / 60;
	        t3 = t12 % 60;
	        //String t = String.valueOf(t1) + ":" + String.valueOf(t2) + ":" + String.valueOf(t3);
	        String s1=String.valueOf(t1);
	        if (s1.length()==1) s1="0"+s1;
	        String s2=String.valueOf(t2);
	        if (s2.length()==1) s2="0"+s2;
	        String s3=String.valueOf(t3);
	        if (s3.length()==1) s3="0"+s3;
	        
	        //String t = String.valueOf(t1) + ":" + String.valueOf(t2) + ":" + String.valueOf(t3);
	        String t = s1+":"+s2+":"+s3;
	        return t;
    	} catch (Exception e) {
    		return "00:00:00";
    	}
    }
    public String MTODhm(int m) {
    	try {
	        int t1, t12, t2, t3;
	        t1 = m / (8 * 60);
	        t12 = m % (8 * 60);
	        t2 = t12 / 60;
	        t3 = t12 % 60;
	        
	        String s1=String.valueOf(t1);
	        if (s1.length()==1) s1="0"+s1;
	        String s2=String.valueOf(t2);
	        if (s2.length()==1) s2="0"+s2;
	        String s3=String.valueOf(t3);
	        if (s3.length()==1) s3="0"+s3;
	        
	        //String t = String.valueOf(t1) + ":" + String.valueOf(t2) + ":" + String.valueOf(t3);
	        String t = s1+":"+s2+":"+s3;
	        return t;
    	}catch (Exception e) {
    		return "00:00:00";
    	}
    }
    public String MTODhm(int m, double h) {    	
    	try {
	        int t1, t12, t2, t3;
	        int t4 = Tm_To_Min(h);
	        //System.out.println("T4 -->> "+t4);
	        t1 = m / (t4);
	        t12 = m % (t4);
	        t2 = t12 /60;
	        t3 = t12 % 60;
	       // System.out.println("t1 -> "+t1+" t12-> "+t12+" t2-> "+t2+" t3-> "+t3);
	        String s1=String.valueOf(t1);
	        if (s1.length()==1) s1="0"+s1;
	        String s2=String.valueOf(t2);
	        if (s2.length()==1) s2="0"+s2;
	        String s3=String.valueOf(t3);
	        if (s3.length()==1) s3="0"+s3;
	        
	        //String t = String.valueOf(t1) + ":" + String.valueOf(t2) + ":" + String.valueOf(t3);
	        String t = s1+":"+s2+":"+s3;
	        return t;
    	}catch (Exception e) {
    		return "00:00:00";
    	}
    }
    public String subDhm(String t1,String t2,double hd){
    	int d1,d2,m1,m2,d,m,hm1,h=0,indexS,leng,h3=1;
    	double hd1,h1,h2,hm3;
    	String dhm,hour,sub,sub1;
    	
    	StringTokenizer time1 = new StringTokenizer(t1, ":");
    	StringTokenizer time2 = new StringTokenizer(t2, ":");
    	
    	d1=Integer.parseInt(time1.nextToken().toString());
    	d2=Integer.parseInt(time2.nextToken().toString());
    	h1=Integer.parseInt(time1.nextToken().toString());
    	h2=Integer.parseInt(time2.nextToken().toString());
    	m1=Integer.parseInt(time1.nextToken().toString());
    	m2=Integer.parseInt(time2.nextToken().toString());
    
    	//System.out.println("day -->"+d1+" <-> "+d2);
    	//System.out.println("hour -->"+h1+" <-> "+h2);
    	//System.out.println("minut -->"+m1+" <-> "+m2);
    	
    	if(m2>m1){
    		if(h1==0){
    			d1=d1-1;
        		h1=h1+hd;
    		}
    		h1=h1-1;
    		m1=m1+60;
    		m=m1-m2;
    	}else{
    		m=m1-m2;
    	}
    	
    	if(h2>h1){
    		System.out.println("h1 -->> "+h1+" h2 -->>"+h2);
    		d1=d1-1;
    		h1=h1+hd;
    		hm3=h1-h2;
    		hour=hm3+"";
    		//hour="2.11";
    		if(hour.indexOf(".")>-1){
    			leng=hour.length()-(hour.indexOf(".")+1);
    			//System.out.println("hour -->> "+hour);
    			//System.out.println("leng -->> "+leng);
    			if(leng>2){
    				indexS=hour.indexOf(".")+3;
    			}else{
    				indexS=leng+2;
    			}    			
    			sub=hour.substring(hour.indexOf(".")+1,indexS);
    			//System.out.println("sub -->> "+sub);
    			hm1=Integer.parseInt(sub);
    			//System.out.println("hm1 -->> "+hm1+" m -->> "+m);
    			m=m+hm1;
    			h=Integer.parseInt(hour.substring(0,hour.indexOf(".")));
    			//System.out.println("m -->> "+m);
    			if(m>=60){
    				m=m-60;
    				h=h+1;
    			}
    			//System.out.println("time -->> "+sub);
    		}else{h=this.RoundInt(Double.parseDouble(hour));}
    	}else{    		
    		if(h1>0){
    			//System.out.println("h1-h2 -->> "+(h1-h2));    			
    			h=this.RoundInt((h1-h2));    			
    		}
    		
    	}
    	
    	d=d1-d2;
    	dhm=d+":"+h+":"+m;    		
    	   	
    	return dhm;
    }
    public int times(double t) {
        int i = 1, h = 0, m = 0, m1, m2;
        String t1 = String.valueOf(t), t2;
        StringTokenizer stChkFormula = new StringTokenizer(t1, ".");
        while (stChkFormula.hasMoreTokens()) {
            t2 = stChkFormula.nextToken().toString();
            if (i == 2 && t2.length() == 1) {
                t2 = t2 + "0";
            }
            ;
            if (i == 1)
                h = Integer.valueOf(t2).intValue();
            if (i == 2)
                m = Integer.valueOf(t2).intValue();
            i++;
        }
        m1 = (h * 60) + m;
        return m1;
    }
    public double times1(int i) {
        String s1, s2;
        int t1, t2;
        t1 = i / 60;
        t2 = i % 60;
        s1 = String.valueOf(t1);
        s2 = String.valueOf(t2);
        s1 = s1 + "." + s2;
        double a = Double.valueOf(s1).doubleValue();
        return a;
    }
    
    /*
    public double subtime(double t, double t1) {
        double a, b;
        int a1, b1;
        String z;
        a1 = times(t);
        b1 = times(t1);
        a1 = b1 - a1;
        a = times1(a1);
        return a;
    }
    public double addtime(double t, double t1) {
        double a, b;
        int a1, b1;
        String z;
        a1 = times(t);
        b1 = times(t1);
        a1 = b1 + a1;
        a = times1(a1);
        return a;
    }    
    */
    //edit by pea 2006-05-03
    public double subtime(double t, double t1) {
        CscTime ct = new CscTime(Float.parseFloat(String.valueOf(t1)));
        ct.sub(Float.parseFloat(String.valueOf(t)));
        double result = Double.parseDouble(String.valueOf(ct.getFloat()));
        return result;
    }
    public double addtime(double t, double t1) {
    	CscTime ct = new CscTime(Float.parseFloat(String.valueOf(t1)));
        ct.add(Float.parseFloat(String.valueOf(t)));
        double result = Double.parseDouble(String.valueOf(ct.getFloat()));
        return result;
    }    
    public int ymd2day(String age){        
        int[] a=new int[3];
        int day=0,i=0;
        StringTokenizer st=new StringTokenizer(age,":");
        while(st.hasMoreTokens()){
           a[i]=Integer.parseInt( st.nextToken().toString());
           i++;
        }
        day=(a[0]*365)+(a[1]*30)+a[2];        
        return day;
    }
    
    public String day2ymd(int day){
        int year,month,days;
        String age="";
        year=day/365;
        month=(day%365)/30;
        days=(day%365)%30;
        age=year+":"+month+":"+days;        
        return age;
    }
    public double Tm_To_Dec4(double st) {
        double x1, x2;
        int i;
        String st1, st2, x;
        x = String.valueOf(st);
        i = x.indexOf(".");
        st1 = x.substring(x.indexOf(".") + 1);
        st2 = x.substring(0, i);
        x1 = Double.parseDouble(st2);
        x2 = Double.parseDouble(st1);
        if (st1.length() == 1) {
            x2 *= 10;
        }
		  java.text.DecimalFormat dc=new  java.text.DecimalFormat();
		  dc.applyPattern("0.000000");
		  x2 = Double.parseDouble(dc.format(x2 / 60));
        x1 = x1 + x2;
        return x1;
    }    
    
    public CscCalendar getCscCalendar(){
		 return new CscCalendar();
	}
	
	public CscCalendar getCscCalendar(String date){
		 return new CscCalendar(date);
	}
	
	public int time2min(double hhmm){
		DecimalFormat df = new DecimalFormat("#0.00");
		int val = 0;
		double time = 0;		
		time =  Double.parseDouble(df.format(hhmm));
		val = ((int)(time*100)/100*60) + ((int)(time*100)%100);		
		return val;
	}
	
	public String min2time(int minute){
		DecimalFormat df = new DecimalFormat("00");
		String val = "0.00";
		val = (String)( (minute/60)+"."+df.format((minute%60)) );		
		return val;
	}
}
