package com.csc.library.report;

import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.HashMap;


import com.csc.library.session.InitialEnvironment;
import com.csc.library.utilities.MyLog;
public class ConnectReport {

	private java.sql.Connection con = null;
	private java.sql.Statement st = null;
	private java.sql.ResultSet rs = null;
	private HashMap rec = new HashMap();

	/*public ConnectReport() {
		try {
			String dbName=new InitialEnvironment("GLOBAL").getValue("db-name");
			con = new ConnectDB(dbName).getConnection();
			st = con.createStatement();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}
	}*/
	
	public ConnectReport() {
		try {
			Class.forName("COM.ibm.db2.jdbc.app.DB2Driver");
			con = DriverManager.getConnection("jdbc:db2:prdbs10d", "wasadmin", "systemadmin");
			st = con.createStatement();
		} catch (SQLException ex) {
			MyLog.error(this, ex);
		} catch (ClassNotFoundException ex) {
			MyLog.error(this, ex);
		}
	}
		

	private void findLog() {
		int i = 0;
		String schemaName=new InitialEnvironment("GLOBAL").getValue("schema-name");		
		try {
			rs = st.executeQuery("SELECT * FROM "+schemaName+".report_log WHERE status = 'A'");
			if (rs != null) {
				while (rs.next()) {
					String[] data = new String[7];
					data[0] = rs.getString("reportid");
					data[1] = rs.getString("name");
					data[2] = rs.getString("rclass_name");
					data[3] = rs.getString("event");
					data[4] = rs.getString("status");
					data[5] = rs.getString("owner");
					data[6] = rs.getString("condition");
					rec.put(new Integer(i++), data);
				}
			}
			this.release();
		} catch (SQLException ex) {
			MyLog.error(this, ex);
		}
	}

	public HashMap getReport() {
		this.findLog();
		return this.rec;
	}

	private String checkComplete() {
		String file = "";
		return "";
	}

	public int updateLog(String reportid, String data) { 
		int ok = 0;
		String schemaName=new InitialEnvironment("GLOBAL").getValue("schema-name");		
		try {
			ok = st.executeUpdate("UPDATE "+schemaName+".report_log set status='" + data + "' WHERE reportid  = '" + reportid + "'");
			this.release();
		} catch (SQLException ex) {
			MyLog.error(this, ex);
		}
		return ok;
	}

	private void release() {
		try {
			if (rs != null) {
				rs.close();
			}
			if (st != null) {
				st.close();
			}
			if (con != null) {
				con.close();
			}
		} catch (SQLException ex) {
			MyLog.error(this, ex);
		}
	}
}
