package com.csc.library.session;

import java.lang.reflect.Method;

import javax.naming.Context;
import javax.naming.NamingException;

import com.csc.library.database.Connectable;
import com.csc.library.utilities.MyLog;

/**
 * @author raisara
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class InitialConnection {
	private Connectable db;
	private Object home;
	private String sql,dbName;
		
	public Connectable getDbData(String sql, String dbName) {
		this.sql=sql;
		this.dbName=dbName;
		try {
			this.getInitialContext();
			db = this.invokeRemote();
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		return this.db;
	}

	private Connectable invokeRemote() throws Exception {
		Class c = home.getClass();
		Method mx = c.getDeclaredMethod("create", new Class[] {java.lang.String.class, java.lang.String.class });
		Connectable db=(Connectable) mx.invoke(home, new Object[] { this.sql, this.dbName});
		return db;
	}

	private void getInitialContext() throws NamingException {
		Context ctx = new MyContext().getInitialContext();
		home = ctx.lookup("ConnectionManage");
	}
	
}
