package com.csc.library.utilities;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.TreeSet;
import java.util.Vector;

import com.csc.library.database.ComponentField;
import com.csc.library.database.MyHashMap;
import com.csc.library.database.StaticProperties;
/** 
 * 
 * @author Dragonfire
 * 
 */

public class MyProperties {
    
    private MyHashMap myProp=null;
    private Iterator itTable=null;
    private Iterator itField=null;    
    private Iterator itFieldProp=null;    
    private String tableName="";
    private String fieldName="";
    private String fieldProp="";
    private boolean nextTable=false;
    private boolean nextField=false;
    private boolean nextFieldProp=false;
    private Arrangement arng=new Arrangement();
    private ComponentField cfield=new ComponentField();
    private String lang="tha";
    private String appname="";
    
    public Iterator getItField() {
        return itField;
    }
    public Iterator getItTable() {
        return itTable;
    }

    public MyProperties() {
    }

    public void Load(){
        MyHashMap mp=StaticProperties.proTable;
        Iterator it =mp.getKeySortIterator();
        HashMap hf=null;
        MyHashMap ht=new MyHashMap();
        while(it.hasNext()){
            String key=(String)it.next();
                MyHashMap tt=(MyHashMap)mp.get(key);
                Iterator it2=tt.getKeySortIterator();
                        while(it2.hasNext()){
                                   it2.next();
                                   HashMap ttt=(HashMap)tt.get("properties");
                                    Iterator it3=ttt.keySet().iterator();    
                                     hf=new LinkedHashMap();
                                            while(it3.hasNext()){
                                                String key3=(String)it3.next();
                                                hf.put(key3,ttt.get(key3));
                                            }
                           ht.put(key,hf);
                        }            
          }       
        this.myProp=ht;
        this.itTable=this.getHashTableList().getKeySortIterator();
    }
       
    public  MyHashMap getHashTableList(){
        return (MyHashMap)this.myProp;
}

    public Vector getTableList(){
    	Iterator it=this.getHashTableList().getKeySortIterator();   	
        Vector vt=new Vector();
        String tablename="";
        while(it.hasNext()){
        	tablename=(String)it.next();
        	vt.add(tablename);
        }
        return vt;
}
    
    public boolean hasTableNext(){    	
    	nextTable=itTable.hasNext();
    	if(nextTable)
    		tableName=(String)itTable.next();
    	return nextTable;
}    

    public boolean hasFieldNext(){    	
    	nextField=itField.hasNext();
    	if(nextField)
    		fieldName=(String)itField.next();
    	return nextField;
}

    public boolean hasFieldPropNext(){    	
    	nextFieldProp=itFieldProp.hasNext();
    	if(nextFieldProp)
    		fieldProp=(String)itFieldProp.next();
    	return nextFieldProp;
}

    public void setTable(String table){
    	this.itField=arng.getSortKeyMap((HashMap)this.getHashTableList().get(table)).keySet().iterator();
    }

    public void setField(String tablename,String fieldname){
    	this.itFieldProp=arng.getSortKeyMap((HashMap)((HashMap)this.getHashTableList().get(tablename.toLowerCase())).get(fieldname.toLowerCase())).keySet().iterator();
    }

    public HashMap getHashFieldList(String tablename){
        return arng.getSortKeyMap((HashMap)this.getHashTableList().get(tablename));
} 
    
    public HashMap getHashFieldProperties(String tablename,String fieldname){    	
        return arng.getSortKeyMap((HashMap)((HashMap)this.getHashTableList().get(tablename.toLowerCase())).get(fieldname.toLowerCase()));
}     

    public String getFieldProperties(String tablename,String fieldname,String properties){
    	String prop="";
    	try{
    		HashMap obj=(HashMap)arng.getSortKeyMap((HashMap)((HashMap)this.getHashTableList().get(tablename.toLowerCase())).get(fieldname.toLowerCase()));
    		cfield=(ComponentField)obj.get("cfield");
    	if(cfield!=null){
    		prop=cfield.getComField(this.getAppname(),properties.toUpperCase());
			if(prop==null){	
					prop = (String) obj.get(properties.toUpperCase());
					if (prop == null) {
						prop = "";
					}
			}
    	}
    	}catch(Exception ex){
    		prop="not found";
    	}
    	return prop;
}     
    
    
    public Vector getFieldList(String table){
    	Vector vt=new Vector(this.getHashFieldList(table).keySet());
          return vt;
}
    
    public String getField(){
        return this.fieldName;
    };
    
    public String getTable(){
        return this.tableName;
    }
    
    public String getFieldProp(){
    	return this.fieldProp;
    }

    public void setAppname(String appname){
    	this.appname=appname;
    }
    
    public String getAppname(){
    	return this.appname;
    }
}
